# ObjectFile

[![Build Status](https://travis-ci.org/staticfloat/ObjectFile.jl.svg?branch=master)](https://travis-ci.org/staticfloat/ObjectFile.jl)
[![Coverage](http://codecov.io/github/staticfloat/ObjectFile.jl/coverage.svg?branch=master)](http://codecov.io/github/staticfloat/ObjectFile.jl?branch=master)

This package provides basic functionality to read and analyze binary object files. It was written with ELF/MachO/COFF in mind, but should be easily adaptable to other object files as well.  While not originally intended as a package to enable the construction of a compiler/linker, the package authors welcome any and all efforts to extend the capabilities of this package toward synthesis of object files as well as the analysis of them.

export MachOHandle

abstract type AbstractMachOHandle{T <: IO} <: ObjectHandle end

struct MachOHandle{T <: IO} <: AbstractMachOHandle{T}
    # Backing IO and start point within the IOStream of this MachO object
    io::T
    start::Int64

    # The parsed-out header of the MachO object
    header::MachOHeader

    # The path of the file this was created with, if it exists
    path::String
end

function readmeta(io::IO, ::Type{AbstractMachOHandle})
    start = position(io)

    # Peek at the magic
    magic = read(io,UInt32)
    seek(io, start)

    # See which magic it is:
    header_type = macho_header_type(magic)
    endianness = macho_endianness(magic)

    header_type, endianness
end

function readmeta(io::IO,::Type{MachOHandle})
    start = position(io)
    header_type, endianness = readmeta(io, AbstractMachOHandle)
    !(header_type <: MachOFatHeader) || throw(MagicMismatch("Binary is fat"))

    # Unpack the header
    header = unpack(io, header_type, endianness)
    return [MachOHandle(io, Int64(start), header, path(io))]
end

## IOStream-like operations:
startaddr(oh::AbstractMachOHandle) = oh.start
iostream(oh::AbstractMachOHandle) = oh.io


## Format-specific properties:
header(oh::AbstractMachOHandle) = oh.header
endianness(oh::AbstractMachOHandle) = macho_endianness(header(oh).magic)
Platform(oh::MachOHandle) = Platform(macho_cpu_to_arch(header(oh).cputype), "macos")
is64bit(oh::MachOHandle) = macho_is64bit(header(oh).magic)
isrelocatable(oh::MachOHandle) = header(oh).filetype == MH_OBJECT
isexecutable(oh::MachOHandle) = header(oh).filetype == MH_EXECUTE
islibrary(oh::MachOHandle) = header(oh).filetype == MH_DYLIB
isdynamic(oh::MachOHandle) = !isempty(findall(MachOLoadCmds(oh), [MachOLoadDylibCmd]))
mangle_section_names(oh::MachOHandle, name) = string("__", name)
mangle_symbol_name(oh::MachOHandle, name::AbstractString) = string("_", name)
format_string(::Type{H}) where {H <: AbstractMachOHandle} = "MachO"

# Section information
section_header_size(oh::MachOHandle) = sizeof(section_header_type(oh))
function section_header_type(oh::H) where {H <: MachOHandle}
    if is64bit(oh)
        return MachOSection64{H}
    else
        return MachOSection32{H}
    end
end

# Misc. stuff
path(oh::MachOHandle) = oh.path

# Note that since Base Julia already has a `Symbol` object, we use the term
# `SymtabEntry` to refer to the concrete instantiation of a symbol within an
# object file, and the term `SymbolRef` as a reference to that object.

# Export Symbols API
export Symbols,
       getindex, length, iterate, lastindex, eltype,
       findall, findfirst,
       handle, header

# Export SymtabEntry API
export SymtabEntry,
       deref, symbol_name, symbol_value, isundef, isglobal, islocal, isweak, symbol_section, symbol_offset

# Export SymbolRef API
export SymbolRef,
       symbol_number

# Import Base methods for extension
import Base: length, iterate, lastindex, findall, findfirst

"""
    Symbols

An abstraction over the concept of a collection of symbol (`SymtabEntry`) types
within an object file.  One can think of the `Symbols` object containing the
table of symbols within the object file, whereas the `SymtabEntry`/`SymbolRef`
objects contain the actual symbol data itself.  The list of available API
operations is given below, with methods that subclasses must implement marked
in emphasis:

### Creation
  - *Symbols()*

### Iteration
  - getindex()
  - *lastindex()*
  - length()
  - iterate()
  - eltype()

### Search
  - findall()
  - findfirst()

### Misc.
  - *handle()*
"""
abstract type Symbols{H<:ObjectHandle} end

# Fairly simple iteration interface specification
@mustimplement lastindex(syms::Symbols)
length(syms::Symbols) = lastindex(syms)
iterate(syms::Symbols, idx=1) = idx > length(syms) ? nothing : (syms[idx], idx+1)
eltype(::Type{S}) where {S <: Symbols} = SymbolRef

function getindex(syms::Symbols{H}, idx) where {H <: ObjectHandle}
    # Punt off to `getindex_ref`
    oh = handle(syms)
    return getindex_ref(
        syms,
        symtab_entry_offset(oh),
        symtab_entry_size(oh),
        symtab_entry_type(oh),
        SymbolRef,
        idx
    )
end

"""
    findall(symbols::Symbols, name::String)

Return a list of symbols that match the given `name`.
"""
function findall(symbols::Symbols, name::AbstractString)
    return findall(symbols, [name])
end

"""
    findall(symbols::Symbols, name::String)

Return a list of symbols that match one of the given `names`.
"""
function findall(symbols::Symbols, names::Vector{S}) where {S <: AbstractString}
    return [s for s in symbols if symbol_name(s) in names]
end

"""
    findfirst(symbols::Symbols, name::String)

Return the first section that matches the given `name`.
"""
function findfirst(symbols::Symbols, name::AbstractString)
    return findfirst(symbols, [name])
end

"""
    findfirst(symbols::Symbols, names::Vector{String})

Return the first section that matches on of the given `names`.
"""
function findfirst(symbols::Symbols, names::Vector{String})
    results = findall(symbols, names)
    isempty(results) && return nothing
    return first(results)
end





"""
    SymtabEntry

An abstraction over the concept of a symbol within an object file.  This type
does not use the `Symbol` name as this would conflict with the builtin Julia
`Symbol` type, so the name `SymtabEntry` is used instead.  As a user, the
`SymbolRef` type should be the primary method of interacting with symbols, as a
developer adding new object file formats, some methods must support
`SymtabEntry`s, others must support only `SymbolRef`s.  Note that any method
that works on a `SymtabEntry` must also work with a `SymbolRef`, see the
`@derefmethod` macro for a convenient helper macro to generate `SymbolRef` ->
`SymtabEntry` wrapper methods. The list of available API operations is given
below, with methods that subclasses must implement marked in emphasis:

### Creation:
  - *SymtabEntry()*

### Util:
  - deref()

### Properties:
  - *symbol_name()*
  - *symbol_value()*
  - *isundef()*
  - *isglobal()*
  - *islocal()*
  - *isweak()*
"""
abstract type SymtabEntry{H<:ObjectHandle} end

# Dummy `deref()`
deref(sym::SymtabEntry) = sym

"""
    symbol_name(sym::SymtabEntry)

Return the name of the given section as a string.  In order to return a true
name, it is necessary to perform a lookup within the object's string table,
which cannot be done using just a `SymtabEntry` object; use a `SymbolRef`
object instead if you need that.  For sanity sake, this method will return a
string, but the contents of the string may be something like the offset within
the string table pointing to this `SymtabEntry`'s name, e.g. "@strtab.123"
"""
@mustimplement symbol_name(sym::SymtabEntry)

"""
    symbol_value(sym::SymtabEntry)

Return the value of the given symbol
"""
@mustimplement symbol_value(sym::SymtabEntry)

"""
    symbol_section(sym::SymtabEntry)
Return the section that this symbol refers to
"""
@mustimplement symbol_section(sym::SymtabEntry)

"""
    symbol_offset(sym::SymtabEntry)
Return the offset into the file that this symbol refers to.
"""
@mustimplement symbol_offset(sym::SymtabEntry)


"""
    isundef(sym::SymtabEntry)

Return `true` if the given symbol is undefined
"""
@mustimplement isundef(sym::SymtabEntry)

"""
    isglobal(sym::SymtabEntry)

Return `true` if the given symbol is global
"""
@mustimplement isglobal(sym::SymtabEntry)

"""
    islocal(sym::SymtabEntry)

Return `true` if the given symbol is local
"""
@mustimplement islocal(sym::SymtabEntry)

"""
    isweak(sym::SymtabEntry)

Return `true` if the given symbol is weak
"""
@mustimplement isweak(sym::SymtabEntry)





"""
    SymbolRef

Provides a reference to a `SymtabEntry`, along with a reference to the
`ObjectHandle` this `SymtabEntry` comes from.  This should be the primary
method by which users interact with symbols inside object files.  The list of
available API operations is given below, with methods that subclasses must
implement marked in emphasis.  Note that this overlaps heavily with the
`SymtabEntry` object API, this is by design as many of the methods are simply
passthroughs to the underlying `SymtabEntry` API calls for ease of use.

### Creation:
  - *SymbolRef()*

### Util:
  - *deref()*
  - *Symbols()*
  - handle()

### Properties:
  - *symbol_number()*
  - *symbol_name()*
  - symbol_value()
  - isundef()
"""
abstract type SymbolRef{H<:ObjectHandle} end

"""
SymbolRef(symbols::Symbols, sym::SymtabEntry, idx::UInt32)

Construct a `SymbolRef` object pointing to the given `SymtabEntry`, which
itself represents the `idx`'th symbol within the given `Symbols` collection.
"""
@mustimplement SymbolRef(symbols::Symbols, sym::SymtabEntry, idx)
@mustimplement deref(sym::SymbolRef)

"""
    Symbols(sym::SymbolRef)

Return the `Symbols` object that this `SymbolRef` belongs to.
"""
@mustimplement Symbols(sym::SymbolRef)

"""
    handle(sym::SymbolRef)

Return the `ObjectHandle` that this `SymbolRef` belongs to.
"""
handle(sym::SymbolRef) = handle(Symbols(sym))

"""
    symbol_number(sym::SymbolRef)

Return the number (index) of the given symbol.
"""
@mustimplement symbol_number(sym::SymbolRef)

"""
    symbol_name(sym::SymbolRef)

Return the name of the given symbol as a string.  This method often performs
some kind of lookup within the string table of the object to get the full name
of the symbol.
"""
@mustimplement symbol_name(sym::SymbolRef)

@derefmethod symbol_value(sym::SymbolRef)
@derefmethod isundef(sym::SymbolRef)
@derefmethod isglobal(sym::SymbolRef)
@derefmethod islocal(sym::SymbolRef)
@derefmethod isweak(sym::SymbolRef)



## Printing
function show(io::IO, sym::Union{SymtabEntry{H},SymbolRef{H}}) where {H <: ObjectHandle}
    print(io, "$(format_string(H)) Symbol")

    if !get(io, :compact, false)
        println(io)
        println(io, "       Name: $(symbol_name(sym))")
        println(io, "      Value: $(symbol_value(sym))")
        println(io, "    Defined: $(isundef(sym) ? "No" : "Yes")")
        println(io, "     Strong: $(isweak(sym) ? "No" : "Yes")")
        print(io,   "   Locality: $(isglobal(sym) ? "Global" : "Local")")
    else
        print(io, " \"$(symbol_name(sym))\"")
    end
end

show(io::IO, syms::Symbols{H}) where {H <: ObjectHandle} = show_collection(io, syms, H)

export MachOSegments, MachOSegment, MachOSegmentRef

"""
    MachOSegments

`Segments` type that contains all load commands within a Mach-O file that
contain segment commands.
"""
struct MachOSegments{H <: MachOHandle, S <: MachOLoadCmdRef} <: Segments{H}
    handle::H
    segments::Vector{S}
end

function Segments(lcs::MachOLoadCmds)
    return MachOSegments(handle(lcs), findall(lcs, [MachOSegmentCmd]))
end
function Segments(oh::MachOHandle)
    # Sub out to our MachOLoadCmds-based constructor
    return Segments(MachOLoadCmds(oh))
end

handle(segments::MachOSegments) = segments.handle
lastindex(segments::MachOSegments) = lastindex(segments.segments)
function getindex(segs::MachOSegments{H}, idx) where {H <: MachOHandle}
    seg = MachOSegment(segs.segments[idx])
    return MachOSegmentRef(segs, seg, UInt32(idx))
end


"""
    MachOSegment

MachO `Segment` type which is returned from a `MachOSegmentRef` when it is
dereferenced.  Note that this type exists only for the purposes of type
conformity; all the real work is done within `MachOSegmentCmd`; but since that
already inherits from `MachOLoadCmd`, it cannot also inherit from `Segment`.
Thus, this wrapper type was born to bridge the type hierarchy.
"""
struct MachOSegment{H <: MachOHandle, S <: MachOSegmentCmd{H}} <: Segment{H}
    seg::MachOLoadCmdRef{H,S}
end

Segment(seg::MachOLoadCmdRef{H,MachOSegmentCmd{H}}) where {H <: MachOHandle} = MachOSegment(seg)

MachOLoadCmdRef(seg::MachOSegment) = seg.seg
MachOLoadCmd(seg::MachOSegment) = deref(MachOLoadCmdRef(seg))

is64bit(seg::MachOSegment) = isa(seg.seg, MachOSegment64Cmd)
segment_name(seg::MachOSegment) = segment_name(seg.seg)
segment_offset(seg::MachOSegment) = segment_offset(seg.seg)
segment_file_size(seg::MachOSegment) = segment_file_size(seg.seg)
segment_memory_size(seg::MachOSegment) = segment_memory_size(seg.seg)
segment_num_sections(seg::MachOSegment) = segment_num_sections(seg.seg)


"""
    MachOSegmentRef

MachO `SegmentRef` type which is returned from a `MachOSegments` when it is
indexed into.  Note that this type exists only for the purposes of type
conformity; all the real work is done within `MachOSegmentCmd`; but since that
already inherits from `MachOLoadCmd`, and we needed a `MachOSegment` type that
would inherit from `Segment`, we figured might as well make a `MachOSegmentRef`
as well to keep things nice and symmetric.
"""
struct MachOSegmentRef{H <: MachOHandle} <: SegmentRef{H}
    segments::MachOSegments{H}
    segment::MachOSegment{H}
    idx::UInt32
end
function SegmentRef(segs::MachOSegments, seg::MachOSegment, idx)
    return MachOSegmentRef(segs, seg, idx)
end

Segments(seg::MachOSegmentRef) = seg.segments
segment_number(seg::MachOSegmentRef) = seg.idx
deref(seg::MachOSegmentRef) = seg.segment
@derefmethod MachOLoadCmdRef(seg::MachOSegmentRef)
@derefmethod segment_num_sections(seg::MachOSegmentRef)
@derefmethod segment_name(seg::MachOSegmentRef)
@derefmethod is64bit(seg::MachOSegmentRef) 


# Printing
function show(io::IO, seg::Union{MachOSegment,MachOSegmentRef})
    print(io, "MachO Segment", is64bit(seg) ? " (64 bit)" : "")

    if !get(io, :compact, false)
        fsz = string(segment_file_size(seg), base=16)
        msz = string(segment_memory_size(seg), base=16)

        println(io)
        println(io, "       Name: $(segment_name(seg))")
        println(io, "       Size: (File: 0x$(fsz),   Mem: 0x$(msz))")
        println(io, "     Offset: 0x$(string(segment_offset(seg), base=16))")
        print(io,   "   Sections: $(segment_num_sections(seg))")
    else
        print(io, " $(segment_name(seg))")
    end
end

@io struct MachOSymtabCmd{H <: MachOHandle} <: MachOLoadCmd{H}
    symoff::UInt32
    nsyms::UInt32
    stroff::UInt32
    strsize::UInt32
end

show(io::IO, lc::MachOSymtabCmd) = write(io, "SymtabCmd")

# Accessors for symbols info
symtab_symbols_offset(cmd::MachOSymtabCmd) = cmd.symoff
symtab_num_symbols(cmd::MachOSymtabCmd) = cmd.nsyms

# Accessors for strtab info
symtab_strtab_offset(cmd::MachOSymtabCmd) = cmd.stroff
symtab_strtab_length(cmd::MachOSymtabCmd) = cmd.strsize

@derefmethod symtab_symbols_offset(cmd::MachOLoadCmdRef{H,MachOSymtabCmd{H}}) where {H <: MachOHandle}
@derefmethod symtab_num_symbols(cmd::MachOLoadCmdRef{H,MachOSymtabCmd{H}}) where {H <: MachOHandle}
@derefmethod symtab_strtab_offset(cmd::MachOLoadCmdRef{H,MachOSymtabCmd{H}}) where {H <: MachOHandle}
@derefmethod symtab_strtab_length(cmd::MachOLoadCmdRef{H,MachOSymtabCmd{H}}) where {H <: MachOHandle}

function strtab_lookup(cmd::MachOLoadCmdRef{H,MachOSymtabCmd{H}}, index) where {H <: MachOHandle}
    oh = handle(cmd)
    seek(oh, symtab_strtab_offset(cmd) + index)
    return strip(readuntil(oh, '\0'), '\0')
end

# We don't actually use this yet, but it doesn't hurt to have it here
@io struct MachODySymtabCmd{H <: MachOHandle} <: MachOLoadCmd{H}
    ilocalsym::UInt32
    nlocalsym::UInt32
    iextdefsym::UInt32
    nextdefsym::UInt32
    iundefsym::UInt32
    nundefsym::UInt32
    tocoff::UInt32
    ntoc::UInt32
    modtaboff::UInt32
    nmodtab::UInt32
    extrefsymoff::UInt32
    nextrefsyms::UInt32
    indirectsymoff::UInt32
    nindirectsyms::UInt32
    extreloff::UInt32
    nextrel::UInt32
    locreloff::UInt32
    nlocrel::UInt32
end

"""
    show_collection(io, collection, ::Type{H<:ObjectHandle})

Given a collection-like object, (`Symbols`, `DynamicLinks`, ``)
"""
function show_collection(io::IO, stuff::ST, ::Type{H}) where {ST} where {H <: ObjectHandle}
    h_str = format_string(H)

    # Get the type name, removing the `ELF`/`MachO`/`COFF` at the beginning
    type_name = if isa(ST, UnionAll)
        string(ST.body.name.name)
    else
        string(ST.name.name)
    end

    if startswith(type_name, h_str)
        type_name = type_name[length(h_str)+1:end]
    end

    # Start by outputting the container type
    print(io, h_str," ", type_name)

    # Next, print either the entire thing, or a limited subsection of it
    limited = get(io, :limit, false)
    if limited && length(stuff) > 20
        for idx in 1:10
            print(io, "\n  [$(idx)] ")
            show(IOContext(io, :compact => true), stuff[idx])
        end
        print(io, "\n   \u2026")
        for idx in length(stuff)-10:length(stuff)
            print(io, "\n  [$(idx)] ")
            show(IOContext(io, :compact => true), stuff[idx])
        end
    else
        for idx in 1:length(stuff)
            print(io, "\n  [$(idx)] ")
            show(IOContext(io, :compact => true), stuff[idx])
        end
    end
end

export ELFVersionData, ELFVersionNeededData, ELFHash

# Special ELF version data structures
@io struct ELFVerDef{H <: ELFHandle}
    vd_version::UInt16
    vd_flags::UInt16
    vd_ndx::UInt16
    vd_cnt::UInt16
    vd_hash::UInt32
    vd_aux::UInt32
    vd_next::UInt32
end

@io struct ELFVerdAux{H <: ELFHandle}
    vda_name::UInt32
    vda_next::UInt32
end

@io struct ELFVerNeed{H <: ELFHandle}
    vn_version::UInt16
    vn_cnt::UInt16
    vn_file::UInt16
    vn_aux::UInt32
    vn_next::UInt32
end

@io struct ELFVernAux{H <: ELFHandle}
    vna_hash::UInt32
    vna_flags::UInt16
    vna_other::UInt16
    vna_name::UInt32
    vna_next::UInt32
end

struct ELFVersionEntry{H <: ELFHandle}
    ver_def::ELFVerDef{H}
    names::Vector{String}
end

struct ELFVersionNeededEntry{H <: ELFHandle}
    ver_need::ELFVerNeed{H}
    auxes::Vector{ELFVernAux}
    names::Vector{String}
end

"""
Collect all version definitions from .gnu.version_d.  This section contains a
sequence of verdef structs `vd`, each of which owns exactly `vd.vd_cnt` verdaux
structs which we convert to names.  The first name is generally the only
important one to the given `vd`; it is the version being defined, and
corresponds to `vd.vd_hash`.  If present, a second verdaux usually notes the
parent version (e.g. `names = ["GLIBCXX_3.4.7", "GLIBCXX_3.4.6"]`)
"""
function ELFVersionData(oh::H) where {H <: ELFHandle}
    s = findfirst(Sections(oh), ".gnu.version_d")
    strtab = StrTab(findfirst(Sections(oh), ".dynstr"))
    (isnothing(s) || isnothing(strtab)) && return ELFVersionEntry[]

    # Queue oh up to the beginning of this section
    seek(oh, section_offset(s))

    # Read out ALL OF THE version definitions
    version_defs = ELFVersionEntry[]
    while true
        vd_pos = position(oh)
        vd = unpack(oh, ELFVerDef{H})

        # Find aux names and resolve immediately to strings
        auxes = String[]
        aux_offset = 0
        for aux_idx in 1:vd.vd_cnt
            seek(oh, vd_pos + vd.vd_aux + aux_offset)
            aux = unpack(oh, ELFVerdAux{H})
            name = strtab_lookup(strtab, aux.vda_name)
            push!(auxes, name)  
            aux_offset += aux.vda_next
        end

        push!(version_defs, ELFVersionEntry(vd, auxes))

        if vd.vd_next == 0
            break
        end
        seek(oh, vd_pos + vd.vd_next)
    end
    
    return version_defs
end

"""
Collect all version requirements from .gnu.version_r.  This section is
structurally similar to the version definition section, but the primary
"verneed" struct corresponds to one shared library, and the auxiliary struct
corresponds to a version.
"""
function ELFVersionNeededData(oh::H) where {H <: ELFHandle}
    s = findfirst(Sections(oh), ".gnu.version_r")
    strtab = StrTab(findfirst(Sections(oh), ".dynstr"))
    (isnothing(s) || isnothing(strtab)) && return ELFVersionNeededEntry[]

    seek(oh, section_offset(s))
    verneeds = ELFVersionNeededEntry[]
    while true
        vn_pos = position(oh)
        vn = unpack(oh, ELFVerNeed{H})
        auxes = ELFVernAux[]
        names = String[]
        aux_offset = 0
        for aux_idx in 1:vn.vn_cnt
            seek(oh, vn_pos + vn.vn_aux + aux_offset)
            aux = unpack(oh, ELFVernAux{H})
            name = strtab_lookup(strtab, aux.vna_name)
            push!(auxes, aux)
            push!(names, name)
            aux_offset += aux.vna_next
        end
        push!(verneeds, ELFVersionNeededEntry(vn, auxes, names))

        if vn.vn_next == 0
            break
        end
        seek(oh, vn_pos + vn.vn_next)
    end

    return verneeds
end

"""
See https://en.wikipedia.org/wiki/PJW_hash_function

Hash function used to create vd_hash from vda_name, or vna_hash from vna_name.
Stops at the first null byte.
"""
function ELFHash(v::Vector{UInt8})
    h = UInt32(0)
    for b in v
        (b == 0) && break;
        h = (h << 4) + b
        hi = h & 0xf0000000
        if (hi != 0)
            h ⊻= (hi >> 24)
        end
        h &= ~hi
    end
    return h
end

export MachOFatArch, MachOFatHeader, FatMachOHandle

abstract type MachOFatArchitecture end

@io struct MachOFatArch32 <: MachOFatArchitecture
    cputype::UInt32
    cpusubtype::UInt32
    offset::UInt32
    size::UInt32
    align::UInt32
end

@io struct MachOFatArch64 <: MachOFatArchitecture
    cputype::UInt64
    cpusubtype::UInt64
    offset::UInt64
    size::UInt64
    align::UInt32
    reserved::UInt32
end

struct MachOFatHeader{H <: ObjectHandle} <: MachOHeader{H}
    magic::UInt32
    archs::Vector{MachOFatArchitecture}
end

function StructIO.unpack(io::IO, T::Type{<:MachOFatHeader}, endian::Symbol)
    magic = read(io, UInt32)
    nfats = unpack(io, UInt32, endian)
    archtyp = macho_is64bit(magic) ? MachOFatArch64 : MachOFatArch32
    archs = Vector{archtyp}(undef, nfats)
    for i = 1:nfats
        archs[i] = unpack(io, archtyp, endian)
    end
    T(magic, archs)
end

function show(io::IO, header::MachOFatHeader)
    println(io, "MachOFatHeader Header")
    println(io, "  architectures: $(length(header.archs))")
end

struct FatMachOHandle{T <: IO} <: AbstractMachOHandle{T}
    # Backing IO and start point within the IOStream of this MachO object
    io::T
    start::Int64

    # The parsed-out header of the MachO object
    header::MachOFatHeader

    # The path of the file this was created with, if it exists
    path::String
end

function readmeta(io::IO,::Type{FatMachOHandle})
    start = position(io)
    header_type, endianness = readmeta(io, AbstractMachOHandle)
    (header_type <: MachOFatHeader) || throw(MagicMismatch("Binary is not fat"))

    # Unpack the header
    header = unpack(io, header_type, endianness)
    return FatMachOHandle(io, start, header, path(io))
end

# Iteration
keys(h::FatMachOHandle) = 1:length(h)
iterate(h::FatMachOHandle, idx=1) = idx > length(h) ? nothing : (h[idx], idx+1)
lastindex(h::FatMachOHandle) = lastindex(h.header.archs)
length(h::FatMachOHandle) = length(h.header.archs)
eltype(::Type{S}) where {S <: FatMachOHandle} = MachOLoadCmdRef
function getindex(h::FatMachOHandle, idx)
    seek(h.io, h.start + h.header.archs[idx].offset)
    only(readmeta(h.io, MachOHandle))
end

function show(io::IO, oh::FatMachOHandle)
    print(io, "$(format_string(typeof(oh))) Fat Handle")
end

# # # Machine Types
@constants IMAGE_FILE_MACHINE "IMAGE_FILE_" begin
    const IMAGE_FILE_MACHINE_UNKNOWN        = 0x0       # The contents of this field are assumed to be applicable to any machine type
    const IMAGE_FILE_MACHINE_AM33           = 0x1d3     #   Matsushita AM33
    const IMAGE_FILE_MACHINE_AMD64          = 0x8664    #  x64
    const IMAGE_FILE_MACHINE_ARM            = 0x1c0     #   ARM little endian
    const IMAGE_FILE_MACHINE_ARMNT          = 0x1c4     #   ARMv7 (or higher) Thumb mode only
    const IMAGE_FILE_MACHINE_ARM64          = 0xaa64    #  ARMv8 in 64-bit mode
    const IMAGE_FILE_MACHINE_EBC            = 0xebc     #   EFI byte code
    const IMAGE_FILE_MACHINE_I386           = 0x14c     #   Intel 386 or later processors and compatible processors
    const IMAGE_FILE_MACHINE_IA64           = 0x200     #   Intel Itanium processor family
    const IMAGE_FILE_MACHINE_M32R           = 0x9041    #  Mitsubishi M32R little endian
    const IMAGE_FILE_MACHINE_MIPS16         = 0x266     #   MIPS16
    const IMAGE_FILE_MACHINE_MIPSFPU        = 0x366     #   MIPS with FPU
    const IMAGE_FILE_MACHINE_MIPSFPU16      = 0x466     #   MIPS16 with FPU
    const IMAGE_FILE_MACHINE_POWERPC        = 0x1f0     #   Power PC little endian
    const IMAGE_FILE_MACHINE_POWERPCFP      = 0x1f1     #   Power PC with floating point support
    const IMAGE_FILE_MACHINE_R4000          = 0x166     #   MIPS little endian
    const IMAGE_FILE_MACHINE_SH3            = 0x1a2     #   Hitachi SH3
    const IMAGE_FILE_MACHINE_SH3DSP         = 0x1a3     #   Hitachi SH3 DSP
    const IMAGE_FILE_MACHINE_SH4            = 0x1a6     #   Hitachi SH4
    const IMAGE_FILE_MACHINE_SH5            = 0x1a8     #   Hitachi SH5
    const IMAGE_FILE_MACHINE_THUMB          = 0x1c2     #   ARM or Thumb (“interworking”)
    const IMAGE_FILE_MACHINE_WCEMIPSV2      = 0x169     #   MIPS little-endian WCE v2
end

function coff_machine_to_arch(machine::UInt16)
    if machine ∈ (IMAGE_FILE_MACHINE_I386,)
        return "i686"
    elseif machine ∈ (IMAGE_FILE_MACHINE_AMD64, IMAGE_FILE_MACHINE_IA64)
        return "x86_64"
    elseif machine ∈ (IMAGE_FILE_MACHINE_ARM, IMAGE_FILE_MACHINE_ARMNT, IMAGE_FILE_MACHINE_THUMB)
        return "armv7l"
    elseif machine ∈ (IMAGE_FILE_MACHINE_ARM64,)
        return "aarch64"
    elseif machine ∈ (IMAGE_FILE_MACHINE_POWERPC,)
        return "ppc64le"
    end
end

# # # Characteristics

@constants IMAGE_FILE_CHARACTERISTICS "IMAGE_FILE_" begin
    const IMAGE_FILE_RELOCS_STRIPPED            = 0x0001 # Image only, Windows CE, and Windows NT® and later. This indicates that the file does not contain base relocations and must therefore be loaded at its preferred base address. If the base address is not available, the loader reports an error. The default behavior of the linker is to strip base relocations from executable (EXE) files.
    const IMAGE_FILE_EXECUTABLE_IMAGE           = 0x0002 # Image only. This indicates that the image file is valid and can be run. If this flag is not set, it indicates a linker error.
    const IMAGE_FILE_LINE_NUMS_STRIPPED         = 0x0004 # COFF line numbers have been removed. This flag is deprecated and should be zero.
    const IMAGE_FILE_LOCAL_SYMS_STRIPPED        = 0x0008 # COFF symbol table entries for local symbols have been removed. This flag is deprecated and should be zero.
    const IMAGE_FILE_AGGRESSIVE_WS_TRIM         = 0x0010 # Obsolete. Aggressively trim working set. This flag is deprecated for Windows 2000 and later and must be zero.
    const IMAGE_FILE_LARGE_ADDRESS_AWARE        = 0x0020 # Application can handle > 2 GB addresses.
    const IMAGE_FILE_BYTES_REVERSED_LO          = 0x0080 # Little endian: the least significant bit (LSB) precedes the most significant bit (MSB) in memory. This flag is deprecated and should be zero.
    #                                           = 0x0040 # This flag is reserved for future use.
    const IMAGE_FILE_32BIT_MACHINE              = 0x0100 # Machine is based on a 32-bit-word architecture.
    const IMAGE_FILE_DEBUG_STRIPPED             = 0x0200 # Debugging information is removed from the image file.
    const IMAGE_FILE_REMOVABLE_RUN_FROM_SWAP    = 0x0400 # If the image is on removable media, fully load it and copy it to the swap file.
    const IMAGE_FILE_NET_RUN_FROM_SWAP          = 0x0800 # If the image is on network media, fully load it and copy it to the swap file.
    const IMAGE_FILE_SYSTEM                     = 0x1000 # The image file is a system file, not a user program.
    const IMAGE_FILE_DLL                        = 0x2000 # The image file is a dynamic-link library (DLL). Such files are considered executable files for almost all purposes, although they cannot be directly run.
    const IMAGE_FILE_UP_SYSTEM_ONLY             = 0x4000 # The file should be run only on a uniprocessor machine.
    const IMAGE_FILE_BYTES_REVERSED_HI          = 0x8000 # Big endian: the MSB precedes the LSB in memory. This flag is deprecated and should be zero.
end

# # # Magic Numbers
const MAGICPE32 = 0x10b
const MAGICPE   = 0x20b

# # # Windows Subsystem
const IMAGE_SUBSYSTEM_UNKNOWN                   =   0  # An unknown subsystem
const IMAGE_SUBSYSTEM_NATIVE                    =   1  # Device drivers and native Windows processes
const IMAGE_SUBSYSTEM_WINDOWS_GUI               =   2  # The Windows graphical user interface (GUI) subsystem
const IMAGE_SUBSYSTEM_WINDOWS_CUI               =   3  # The Windows character subsystem
const IMAGE_SUBSYSTEM_POSIX_CUI                 =   7  # The Posix character subsystem
const IMAGE_SUBSYSTEM_WINDOWS_CE_GUI            =   9  # Windows CE
const IMAGE_SUBSYSTEM_EFI_APPLICATION           =   10 # An Extensible Firmware Interface (EFI) application
const IMAGE_SUBSYSTEM_EFI_BOOT_SERVICE_DRIVER   =   11 # An EFI driver with boot services
const IMAGE_SUBSYSTEM_EFI_RUNTIME_DRIVER        =   12 # An EFI driver with run-time services
const IMAGE_SUBSYSTEM_EFI_ROM                   =   13 # An EFI ROM image
const IMAGE_SUBSYSTEM_XBOX                      =   14 # XBOX


# # # DLL Characteristics

#                                                       = 0x0001 #  Reserved, must be zero
#                                                       = 0x0002 #  Reserved, must be zero
#                                                       = 0x0004 #  Reserved, must be zero
#                                                       = 0x0008 #  Reserved, must be zero
const IMAGE_DLL_CHARACTERISTICS_DYNAMIC_BASE            = 0x0040 #  DLL can be relocated at load time.
const IMAGE_DLL_CHARACTERISTICS_FORCE_INTEGRITY         = 0x0080 #  Code Integrity checks are enforced.
const IMAGE_DLL_CHARACTERISTICS_NX_COMPAT               = 0x0100 #  Image is NX compatible.
const IMAGE_DLLCHARACTERISTICS_NO_ISOLATION             = 0x0200 #  Isolation aware, but do not isolate the image.
const IMAGE_DLLCHARACTERISTICS_NO_SEH                   = 0x0400 #  Does not use structured exception (SE) handling. No SE handler may be called in this image.
const IMAGE_DLLCHARACTERISTICS_NO_BIND                  = 0x0800 #  Do not bind the image.
#                                                       = 0x1000 #  Reserved, must be zero
const IMAGE_DLLCHARACTERISTICS_WDM_DRIVER               = 0x2000 #  A WDM driver.
const IMAGE_DLLCHARACTERISTICS_TERMINAL_SERVER_AWARE    = 0x8000 #  Terminal Server aware.

# # # Section Flags
@constants IMAGE_SCN_CHARACTERISTICS "IMAGE_SCN_" begin
    #                                         = 0x00000000 #  Reserved for future use.
    #                                         = 0x00000001 #  Reserved for future use.
    #                                         = 0x00000002 #  Reserved for future use.
    #                                         = 0x00000004 #  Reserved for future use.
    const IMAGE_SCN_TYPE_NO_PAD               = 0x00000008 #  The section should not be padded to the next boundary. This flag is obsolete and is replaced by IMAGE_SCN_ALIGN_1BYTES. This is valid only for object files.
    #                                         = 0x00000010 #  Reserved for future use.
    const IMAGE_SCN_CNT_CODE                  = 0x00000020 #  The section contains executable code.
    const IMAGE_SCN_CNT_INITIALIZED_DATA      = 0x00000040 #  The section contains initialized data.
    const IMAGE_SCN_CNT_UNINITIALIZED_DATA    = 0x00000080 #  The section contains uninitialized data.
    const IMAGE_SCN_LNK_OTHER                 = 0x00000100 #  Reserved for future use.
    const IMAGE_SCN_LNK_INFO                  = 0x00000200 #  The section contains comments or other information. The .drectve section has this type. This is valid for object files only.
    #                                         = 0x00000400 #  Reserved for future use.
    const IMAGE_SCN_LNK_REMOVE                = 0x00000800 #  The section will not become part of the image. This is valid only for object files.
    const IMAGE_SCN_LNK_COMDAT                = 0x00001000 #  The section contains COMDAT data. For more information, see section 5.5.6, “COMDAT Sections (Object Only).” This is valid only for object files.
    const IMAGE_SCN_GPREL                     = 0x00008000 #  The section contains data referenced through the global pointer (GP).
    const IMAGE_SCN_MEM_PURGEABLE             = 0x00020000 #  Reserved for future use.
    const IMAGE_SCN_MEM_16BIT                 = 0x00020000 #  For ARM machine types, the section contains Thumb code.  Reserved for future use with other machine types.
    const IMAGE_SCN_MEM_LOCKED                = 0x00040000 #  Reserved for future use.
    const IMAGE_SCN_MEM_PRELOAD               = 0x00080000 #  Reserved for future use.
    const IMAGE_SCN_ALIGN_1BYTES              = 0x00100000 #  Align data on a 1-byte boundary. Valid only for object files.
    const IMAGE_SCN_ALIGN_2BYTES              = 0x00200000 #  Align data on a 2-byte boundary. Valid only for object files.
    const IMAGE_SCN_ALIGN_4BYTES              = 0x00300000 #  Align data on a 4-byte boundary. Valid only for object files.
    const IMAGE_SCN_ALIGN_8BYTES              = 0x00400000 #  Align data on an 8-byte boundary. Valid only for object files.
    const IMAGE_SCN_ALIGN_16BYTES             = 0x00500000 #  Align data on a 16-byte boundary. Valid only for object files.
    const IMAGE_SCN_ALIGN_32BYTES             = 0x00600000 #  Align data on a 32-byte boundary. Valid only for object files.
    const IMAGE_SCN_ALIGN_64BYTES             = 0x00700000 #  Align data on a 64-byte boundary. Valid only for object files.
    const IMAGE_SCN_ALIGN_128BYTES            = 0x00800000 #  Align data on a 128-byte boundary. Valid only for object files.
    const IMAGE_SCN_ALIGN_256BYTES            = 0x00900000 #  Align data on a 256-byte boundary. Valid only for object files.
    const IMAGE_SCN_ALIGN_512BYTES            = 0x00A00000 #  Align data on a 512-byte boundary. Valid only for object files.
    const IMAGE_SCN_ALIGN_1024BYTES           = 0x00B00000 #  Align data on a 1024-byte boundary. Valid only for object files.
    const IMAGE_SCN_ALIGN_2048BYTES           = 0x00C00000 #  Align data on a 2048-byte boundary. Valid only for object files.
    const IMAGE_SCN_ALIGN_4096BYTES           = 0x00D00000 #  Align data on a 4096-byte boundary. Valid only for object files.
    const IMAGE_SCN_ALIGN_8192BYTES           = 0x00E00000 #  Align data on an 8192-byte boundary. Valid only for object files.
    const IMAGE_SCN_LNK_NRELOC_OVFL           = 0x01000000 #  The section contains extended relocations.
    const IMAGE_SCN_MEM_DISCARDABLE           = 0x02000000 #  The section can be discarded as needed.
    const IMAGE_SCN_MEM_NOT_CACHED            = 0x04000000 #  The section cannot be cached.
    const IMAGE_SCN_MEM_NOT_PAGED             = 0x08000000 #  The section is not pageable.
    const IMAGE_SCN_MEM_SHARED                = 0x10000000 #  The section can be shared in memory.
    const IMAGE_SCN_MEM_EXECUTE               = 0x20000000 #  The section can be executed as code.
    const IMAGE_SCN_MEM_READ                  = 0x40000000 #  The section can be read.
    const IMAGE_SCN_MEM_WRITE                 = 0x80000000 #  The section can be written to.
end
    const IMAGE_SCN_ALIGN_MASK                = 0x00F00000

# # # AMD64 Relocations
@constants IMAGE_REL_AMD64 "IMAGE_REL_AMD64_" begin
    const IMAGE_REL_AMD64_ABSOLUTE    = 0x0000 #  The relocation is ignored.
    const IMAGE_REL_AMD64_ADDR64      = 0x0001 #  The 64-bit VA of the relocation target.
    const IMAGE_REL_AMD64_ADDR32      = 0x0002 #  The 32-bit VA of the relocation target.
    const IMAGE_REL_AMD64_ADDR32NB    = 0x0003 #  The 32-bit address without an image base (RVA).
    const IMAGE_REL_AMD64_REL32       = 0x0004 #  The 32-bit relative address from the byte following the relocation.
    const IMAGE_REL_AMD64_REL32_1     = 0x0005 #  The 32-bit address relative to byte distance 1 from the relocation.
    const IMAGE_REL_AMD64_REL32_2     = 0x0006 #  The 32-bit address relative to byte distance 2 from the relocation.
    const IMAGE_REL_AMD64_REL32_3     = 0x0007 #  The 32-bit address relative to byte distance 3 from the relocation.
    const IMAGE_REL_AMD64_REL32_4     = 0x0008 #  The 32-bit address relative to byte distance 4 from the relocation.
    const IMAGE_REL_AMD64_REL32_5     = 0x0009 #  The 32-bit address relative to byte distance 5 from the relocation.
    const IMAGE_REL_AMD64_SECTION     = 0x000A #  The 16-bit section index of the section that contains the target. This is used to support debugging information.
    const IMAGE_REL_AMD64_SECREL      = 0x000B #  The 32-bit offset of the target from the beginning of its section. This is used to support debugging information and static thread local storage.
    const IMAGE_REL_AMD64_SECREL7     = 0x000C #  A 7-bit unsigned offset from the base of the section that contains the target.
    const IMAGE_REL_AMD64_TOKEN       = 0x000D #  CLR tokens.
    const IMAGE_REL_AMD64_SREL32      = 0x000E #  A 32-bit signed span-dependent value emitted into the object.
    const IMAGE_REL_AMD64_PAIR        = 0x000F #  A pair that must immediately follow every span-dependent value.
    const IMAGE_REL_AMD64_SSPAN32     = 0x0010 #  A 32-bit signed span-dependent value that is applied at link time.
end

# # # ARM Relocations
@constants IMAGE_REL_ARM "IMAGE_REL_ARM_" begin
    const IMAGE_REL_ARM_ABSOLUTE      = 0x0000 #  The relocation is ignored.
    const IMAGE_REL_ARM_ADDR32        = 0x0001 #  The 32-bit VA of the target.
    const IMAGE_REL_ARM_ADDR32NB      = 0x0002 #  The 32-bit RVA of the target.
    const IMAGE_REL_ARM_BRANCH24      = 0x0003 #  The most significant 24 bits of the signed 26-bit relative displacement of the target.  Applied to a B or BL instruction in ARM mode.
    const IMAGE_REL_ARM_BRANCH11      = 0x0004 #  The most significant 22 bits of the signed 23-bit relative displacement of the target.  Applied to a contiguous 16-bit B+BL pair in Thumb mode prior to ARMv7.
    const IMAGE_REL_ARM_TOKEN         = 0x0005 #  CLR tokens.
    const IMAGE_REL_ARM_BLX24         = 0x0008 #  The most significant 24 or 25 bits of the signed 26-bit relative displacement of the target.  Applied to an unconditional BL instruction in ARM mode.  The BL is transformed to a BLX during relocation if the target is in Thumb mode.
    const IMAGE_REL_ARM_BLX11         = 0x0009 #  The most significant 21 or 22 bits of the signed 23-bit relative displacement of the target.  Applied to a contiguous 16-bit B+BL pair in Thumb mode prior to ARMv7.  The BL is transformed to a BLX during relocation if the target is in ARM mode.
    const IMAGE_REL_ARM_SECTION       = 0x000E #  The 16-bit section index of the section that contains the target. This is used to support debugging information.
    const IMAGE_REL_ARM_SECREL        = 0x000F #  The 32-bit offset of the target from the beginning of its section. This is used to support debugging information and static thread local storage.
    const IMAGE_REL_ARM_MOV32A        = 0x0010 #  The 32-bit VA of the target.  Applied to a contiguous MOVW+MOVT pair in ARM mode.  The 32-bit VA is added to the existing value that is encoded in the immediate fields of the pair.
    const IMAGE_REL_ARM_MOV32T        = 0x0011 #  The 32-bit VA of the target.  Applied to a contiguous MOVW+MOVT pair in Thumb mode.  The 32-bit VA is added to the existing value that is encoded in the immediate fields of the pair.
    const IMAGE_REL_ARM_BRANCH20T     = 0x0012 #  The most significant 20 bits of the signed 21-bit relative displacement of the target.  Applied to a 32-bit conditional B instruction in Thumb mode.
    const IMAGE_REL_ARM_BRANCH24T     = 0x0014 #  The most significant 24 bits of the signed 25-bit relative displacement of the target.  Applied to a 32-bit unconditional B or BL instruction in Thumb mode.
    const IMAGE_REL_ARM_BLX23T        = 0x0015 #  The most significant 23 or 24 bits of the signed 25-bit relative displacement of the target.  Applied to a 32-bit BL instruction in Thumb mode.  The BL is transformed to a BLX during relocation if the target is in ARM mode.
end

# # # ARM64 Relocations
@constants IMAGE_REL_ARM64 "IMAGE_REL_ARM64_" begin
    const IMAGE_REL_ARM64_ABSOLUTE          = 0x0000 #  The relocation is ignored.
    const IMAGE_REL_ARM64_ADDR32            = 0x0001 #  The 32-bit VA of the target.
    const IMAGE_REL_ARM64_ADDR32NB          = 0x0002 #  The 32-bit RVA of the target.
    const IMAGE_REL_ARM64_BRANCH26          = 0x0003 #  The 26-bit relative displacement to the target.
    const IMAGE_REL_ARM64_PAGEBASE_REL21    = 0x0004 #  The 21-bit page base of the target.
    const IMAGE_REL_ARM64_REL21             = 0x0005 #  The 21-bit relative displacement to the target.
    const IMAGE_REL_ARM64_PAGEOFFSET_12A    = 0x0006 #  The 12-bit page offset of the target address, used for instruction ADDS.
    const IMAGE_REL_ARM64_PAGEOFFSET_12L    = 0x0007 #  The 12-bit page offset of the target address, used for instruction LDR.
    const IMAGE_REL_ARM64_SECREL            = 0x0008 #  The 32-bit offset of the target from the beginning of its section. This is used to support debugging information.
    const IMAGE_REL_ARM64_SECREL_LOW12A     = 0x0009 #  The low 12-bit offset of the target from the beginning of its section. This is used for static thread local storage and for instruction ADDS.
    const IMAGE_REL_ARM64_SECREL_HIGH12A    = 0x000A #  The 12-bit (bit 12 to bit 23) offset of the target from the beginning of its section. This is used for static thread local storage and for instruction ADDS.
    const IMAGE_REL_ARM64_SECREL_LOW12L     = 0x000B #  The low 12-bit offset of the target from the beginning of its section. This is used for static thread local storage and for instruction LDR.
    const IMAGE_REL_ARM64_TOKEN             = 0x000C #  CLR token.
    const IMAGE_REL_ARM64_SECTION           = 0x000D #  The 16-bit section index of the section that contains the target. This is used to support debugging information.
    const IMAGE_REL_ARM64_ADDR64            = 0x000E #  The 64-bit VA of the relocation target.
end

# # # Hitachi SuperH relocations
@constants IMAGE_REL_SUPERH "IMAGE_REL_" begin
    const IMAGE_REL_SH3_ABSOLUTE            = 0x0000 #  The relocation is ignored.
    const IMAGE_REL_SH3_DIRECT16            = 0x0001 #  A reference to the 16-bit location that contains the VA of the target symbol.
    const IMAGE_REL_SH3_DIRECT32            = 0x0002 #  The 32-bit VA of the target symbol.
    const IMAGE_REL_SH3_DIRECT8             = 0x0003 #  A reference to the 8-bit location that contains the VA of the target symbol.
    const IMAGE_REL_SH3_DIRECT8_WORD        = 0x0004 #  A reference to the 8-bit instruction that contains the effective 16-bit VA of the target symbol.
    const IMAGE_REL_SH3_DIRECT8_LONG        = 0x0005 #  A reference to the 8-bit instruction that contains the effective 32-bit VA of the target symbol.
    const IMAGE_REL_SH3_DIRECT4             = 0x0006 #  A reference to the 8-bit location whose low 4 bits contain the VA of the target symbol.
    const IMAGE_REL_SH3_DIRECT4_WORD        = 0x0007 #  A reference to the 8-bit instruction whose low 4 bits contain the effective 16-bit VA of the target symbol.
    const IMAGE_REL_SH3_DIRECT4_LONG        = 0x0008 #  A reference to the 8-bit instruction whose low 4 bits contain the effective 32-bit VA of the target symbol.
    const IMAGE_REL_SH3_PCREL8_WORD         = 0x0009 #  A reference to the 8-bit instruction that contains the effective 16-bit relative offset of the target symbol.
    const IMAGE_REL_SH3_PCREL8_LONG         = 0x000A #  A reference to the 8-bit instruction that contains the effective 32-bit relative offset of the target symbol.
    const IMAGE_REL_SH3_PCREL12_WORD        = 0x000B #  A reference to the 16-bit instruction whose low 12 bits contain the effective 16-bit relative offset of the target symbol.
    const IMAGE_REL_SH3_STARTOF_SECTION     = 0x000C #  A reference to a 32-bit location that is the VA of the section that contains the target symbol.
    const IMAGE_REL_SH3_SIZEOF_SECTION      = 0x000D #  A reference to the 32-bit location that is the size of the section that contains the target symbol.
    const IMAGE_REL_SH3_SECTION             = 0x000E #  The 16-bit section index of the section that contains the target. This is used to support debugging information.
    const IMAGE_REL_SH3_SECREL              = 0x000F #  The 32-bit offset of the target from the beginning of its section. This is used to support debugging information and static thread local storage.
    const IMAGE_REL_SH3_DIRECT32_NB         = 0x0010 #  The 32-bit RVA of the target symbol.
    const IMAGE_REL_SH3_GPREL4_LONG         = 0x0011 #  GP relative.
    const IMAGE_REL_SH3_TOKEN               = 0x0012 #  CLR token.
    const IMAGE_REL_SHM_PCRELPT             = 0x0013 #  The offset from the current instruction in longwords. If the NOMODE bit is not set, insert the inverse of the low bit at bit 32 to select PTA or PTB.
    const IMAGE_REL_SHM_REFLO               = 0x0014 #  The low 16 bits of the 32-bit address.
    const IMAGE_REL_SHM_REFHALF             = 0x0015 #  The high 16 bits of the 32-bit address.
    const IMAGE_REL_SHM_RELLO               = 0x0016 #  The low 16 bits of the relative address.
    const IMAGE_REL_SHM_RELHALF             = 0x0017 #  The high 16 bits of the relative address.
    const IMAGE_REL_SHM_PAIR                = 0x0018 #  The relocation is valid only when it immediately follows a REFHALF, RELHALF, or RELLO relocation. The SymbolTableIndex field of the relocation contains a displacement and not an index into the symbol table.
    const IMAGE_REL_SHM_NOMODE              = 0x8000 #  The relocation ignores section mode.
end

# # # PowerPC Relocations
@constants IMAGE_REL_PPC "IMAGE_REL_PPC_" begin
    const IMAGE_REL_PPC_ABSOLUTE    = 0x0000 #  The relocation is ignored.
    const IMAGE_REL_PPC_ADDR64      = 0x0001 #  The 64-bit VA of the target.
    const IMAGE_REL_PPC_ADDR32      = 0x0002 #  The 32-bit VA of the target.
    const IMAGE_REL_PPC_ADDR24      = 0x0003 #  The low 24 bits of the VA of the target. This is valid only when the target symbol is absolute and can be sign-extended to its original value.
    const IMAGE_REL_PPC_ADDR16      = 0x0004 #  The low 16 bits of the target’s VA.
    const IMAGE_REL_PPC_ADDR14      = 0x0005 #  The low 14 bits of the target’s VA. This is valid only when the target symbol is absolute and can be sign-extended to its original value.
    const IMAGE_REL_PPC_REL24       = 0x0006 #  A 24-bit PC-relative offset to the symbol’s location.
    const IMAGE_REL_PPC_REL14       = 0x0007 #  A 14-bit PC-relative offset to the symbol’s location.
    const IMAGE_REL_PPC_ADDR32NB    = 0x000A #  The 32-bit RVA of the target.
    const IMAGE_REL_PPC_SECREL      = 0x000B #  The 32-bit offset of the target from the beginning of its section. This is used to support debugging information and static thread local storage.
    const IMAGE_REL_PPC_SECTION     = 0x000C #  The 16-bit section index of the section that contains the target. This is used to support debugging information.
    const IMAGE_REL_PPC_SECREL16    = 0x000F #  The 16-bit offset of the target from the beginning of its section. This is used to support debugging information and static thread local storage.
    const IMAGE_REL_PPC_REFHI       = 0x0010 #  The high 16 bits of the target’s 32-bit VA. This is used for the first instruction in a two-instruction sequence that loads a full address. This relocation must be immediately followed by a PAIR relocation whose SymbolTableIndex contains a signed 16-bit displacement that is added to the upper 16 bits that was taken from the location that is being relocated.
    const IMAGE_REL_PPC_REFLO       = 0x0011 #  The low 16 bits of the target’s VA.
    const IMAGE_REL_PPC_PAIR        = 0x0012 #  A relocation that is valid only when it immediately follows a REFHI or SECRELHI relocation. Its SymbolTableIndex contains a displacement and not an index into the symbol table.
    const IMAGE_REL_PPC_SECRELLO    = 0x0013 #  The low 16 bits of the 32-bit offset of the target from the beginning of its section.
    const IMAGE_REL_PPC_GPREL       = 0x0015 #  The 16-bit signed displacement of the target relative to the GP register.
    const IMAGE_REL_PPC_TOKEN       = 0x0016 #  The CLR token.
end

# # # i386 Relocations
@constants IMAGE_REL_I386 "IMAGE_REL_I386_" begin
    const IMAGE_REL_I386_ABSOLUTE = 0x0000 #  The relocation is ignored.
    const IMAGE_REL_I386_DIR16    = 0x0001 #  Not supported.
    const IMAGE_REL_I386_REL16    = 0x0002 #  Not supported.
    const IMAGE_REL_I386_DIR32    = 0x0006 #  The target’s 32-bit VA.
    const IMAGE_REL_I386_DIR32NB  = 0x0007 #  The target’s 32-bit RVA.
    const IMAGE_REL_I386_SEG12    = 0x0009 #  Not supported.
    const IMAGE_REL_I386_SECTION  = 0x000A #  The 16-bit section index of the section that contains the target. This is used to support debugging information.
    const IMAGE_REL_I386_SECREL   = 0x000B #  The 32-bit offset of the target from the beginning of its section. This is used to support debugging information and static thread local storage.
    const IMAGE_REL_I386_TOKEN    = 0x000C #  The CLR token.
    const IMAGE_REL_I386_SECREL7  = 0x000D #  A 7-bit offset from the base of the section that contains the target.
    const IMAGE_REL_I386_REL32    = 0x0014 #  The 32-bit relative displacement of the target. This supports the x86 relative branch and call instructions.
end

# # # IA64 Relocation
@constants IMAGE_REL_IA64 "IMAGE_REL_IA64_" begin
    const IMAGE_REL_IA64_ABSOLUTE     = 0x0000 #  The relocation is ignored.
    const IMAGE_REL_IA64_IMM14        = 0x0001 #  The instruction relocation can be followed by an ADDEND relocation whose value is added to the target address before it is inserted into the specified slot in the IMM14 bundle. The relocation target must be absolute or the image must be fixed.
    const IMAGE_REL_IA64_IMM22        = 0x0002 #  The instruction relocation can be followed by an ADDEND relocation whose value is added to the target address before it is inserted into the specified slot in the IMM22 bundle. The relocation target must be absolute or the image must be fixed.
    const IMAGE_REL_IA64_IMM64        = 0x0003 #  The slot number of this relocation must be one (1). The relocation can be followed by an ADDEND relocation whose value is added to the target address before it is stored in all three slots of the IMM64 bundle.
    const IMAGE_REL_IA64_DIR32        = 0x0004 #  The target’s 32-bit VA. This is supported only for /LARGEADDRESSAWARE:NO images.
    const IMAGE_REL_IA64_DIR64        = 0x0005 #  The target’s 64-bit VA.
    const IMAGE_REL_IA64_PCREL21B     = 0x0006 #  The instruction is fixed up with the 25-bit relative displacement of the 16-bit aligned target. The low 4 bits of the displacement are zero and are not stored.
    const IMAGE_REL_IA64_PCREL21M     = 0x0007 #  The instruction is fixed up with the 25-bit relative displacement of the 16-bit aligned target. The low 4 bits of the displacement, which are zero, are not stored.
    const IMAGE_REL_IA64_PCREL21F     = 0x0008 #  The LSBs of this relocation’s offset must contain the slot number whereas the rest is the bundle address. The bundle is fixed up with the 25-bit relative displacement of the 16-bit aligned target. The low 4 bits of the displacement are zero and are not stored.
    const IMAGE_REL_IA64_GPREL22      = 0x0009 #  The instruction relocation can be followed by an ADDEND relocation whose value is added to the target address and then a 22-bit GP-relative offset that is calculated and applied to the GPREL22 bundle.
    const IMAGE_REL_IA64_LTOFF22      = 0x000A #  The instruction is fixed up with the 22-bit GP-relative offset to the target symbol’s literal table entry. The linker creates this literal table entry based on this relocation and the ADDEND relocation that might follow.
    const IMAGE_REL_IA64_SECTION      = 0x000B #  The 16-bit section index of the section contains the target. This is used to support debugging information.
    const IMAGE_REL_IA64_SECREL22     = 0x000C #  The instruction is fixed up with the 22-bit offset of the target from the beginning of its section. This relocation can be followed immediately by an ADDEND relocation, whose Value field contains the 32-bit unsigned offset of the target from the beginning of the section.
    const IMAGE_REL_IA64_SECREL64I    = 0x000D #  The slot number for this relocation must be one (1). The instruction is fixed up with the 64-bit offset of the target from the beginning of its section. This relocation can be followed immediately by an ADDEND relocation whose Value field contains the 32-bit unsigned offset of the target from the beginning of the section.
    const IMAGE_REL_IA64_SECREL32     = 0x000E #  The address of data to be fixed up with the 32-bit offset of the target from the beginning of its section.
    const IMAGE_REL_IA64_DIR32NB      = 0x0010 #  The target’s 32-bit RVA.
    const IMAGE_REL_IA64_SREL14       = 0x0011 #  This is applied to a signed 14-bit immediate that contains the difference between two relocatable targets. This is a declarative field for the linker that indicates that the compiler has already emitted this value.
    const IMAGE_REL_IA64_SREL22       = 0x0012 #  This is applied to a signed 22-bit immediate that contains the difference between two relocatable targets. This is a declarative field for the linker that indicates that the compiler has already emitted this value.
    const IMAGE_REL_IA64_SREL32       = 0x0013 #  This is applied to a signed 32-bit immediate that contains the difference between two relocatable values. This is a declarative field for the linker that indicates that the compiler has already emitted this value.
    const IMAGE_REL_IA64_UREL32       = 0x0014 #  This is applied to an unsigned 32-bit immediate that contains the difference between two relocatable values. This is a declarative field for the linker that indicates that the compiler has already emitted this value.
    const IMAGE_REL_IA64_PCREL60X     = 0x0015 #  A 60-bit PC-relative fixup that always stays as a BRL instruction of an MLX bundle.
    const IMAGE_REL_IA64_PCREL60B     = 0x0016 #  A 60-bit PC-relative fixup. If the target displacement fits in a signed 25-bit field, convert the entire bundle to an MBB bundle with NOP.B in slot 1 and a 25-bit BR instruction (with the 4 lowest bits all zero and dropped) in slot 2.
    const IMAGE_REL_IA64_PCREL60F     = 0x0017 #  A 60-bit PC-relative fixup. If the target displacement fits in a signed 25-bit field, convert the entire bundle to an MFB bundle with NOP.F in slot 1 and a 25-bit (4 lowest bits all zero and dropped) BR instruction in slot 2.
    const IMAGE_REL_IA64_PCREL60I     = 0x0018 #  A 60-bit PC-relative fixup. If the target displacement fits in a signed 25-bit field, convert the entire bundle to an MIB bundle with NOP.I in slot 1 and a 25-bit (4 lowest bits all zero and dropped) BR instruction in slot 2.
    const IMAGE_REL_IA64_PCREL60M     = 0x0019 #  A 60-bit PC-relative fixup. If the target displacement fits in a signed 25-bit field, convert the entire bundle to an MMB bundle with NOP.M in slot 1 and a 25-bit (4 lowest bits all zero and dropped) BR instruction in slot 2.
    const IMAGE_REL_IA64_IMMGPREL64   = 0x001a #  A 64-bit GP-relative fixup.
    const IMAGE_REL_IA64_TOKEN        = 0x001b #  A CLR token.
    const IMAGE_REL_IA64_GPREL32      = 0x001c #  A 32-bit GP-relative fixup.
    const IMAGE_REL_IA64_ADDEND       = 0x001F #  The relocation is valid only when it immediately follows one of the following relocations: IMM14, IMM22, IMM64, GPREL22, LTOFF22, LTOFF64, SECREL22, SECREL64I, or SECREL32. Its value contains the addend to apply to instructions within a bundle, not for data.
end

# # # MIPS Relocations
@constants IMAGE_REL_MIPS "IMAGE_REL_MIPS_" begin
    const IMAGE_REL_MIPS_ABSOLUTE     = 0x0000 #  The relocation is ignored.
    const IMAGE_REL_MIPS_REFHALF      = 0x0001 #  The high 16 bits of the target’s 32-bit VA.
    const IMAGE_REL_MIPS_REFWORD      = 0x0002 #  The target’s 32-bit VA.
    const IMAGE_REL_MIPS_JMPADDR      = 0x0003 #  The low 26 bits of the target’s VA. This supports the MIPS J and JAL instructions.
    const IMAGE_REL_MIPS_REFHI        = 0x0004 #  The high 16 bits of the target’s 32-bit VA. This is used for the first instruction in a two-instruction sequence that loads a full address. This relocation must be immediately followed by a PAIR relocation whose SymbolTableIndex contains a signed 16-bit displacement that is added to the upper 16 bits that are taken from the location that is being relocated.
    const IMAGE_REL_MIPS_REFLO        = 0x0005 #  The low 16 bits of the target’s VA.
    const IMAGE_REL_MIPS_GPREL        = 0x0006 #  A 16-bit signed displacement of the target relative to the GP register.
    const IMAGE_REL_MIPS_LITERAL      = 0x0007 #  The same as IMAGE_REL_MIPS_GPREL.
    const IMAGE_REL_MIPS_SECTION      = 0x000A #  The 16-bit section index of the section contains the target. This is used to support debugging information.
    const IMAGE_REL_MIPS_SECREL       = 0x000B #  The 32-bit offset of the target from the beginning of its section. This is used to support debugging information and static thread local storage.
    const IMAGE_REL_MIPS_SECRELLO     = 0x000C #  The low 16 bits of the 32-bit offset of the target from the beginning of its section.
    const IMAGE_REL_MIPS_SECRELHI     = 0x000D #  The high 16 bits of the 32-bit offset of the target from the beginning of its section. An IMAGE_REL_MIPS_PAIR relocation must immediately follow this one. The SymbolTableIndex of the PAIR relocation contains a signed 16-bit displacement that is added to the upper 16 bits that are taken from the location that is being relocated.
    const IMAGE_REL_MIPS_JMPADDR16    = 0x0010 #  The low 26 bits of the target’s VA. This supports the MIPS16 JAL instruction.
    const IMAGE_REL_MIPS_REFWORDNB    = 0x0022 #  The target’s 32-bit RVA.
    const IMAGE_REL_MIPS_PAIR         = 0x0025 #  The relocation is valid only when it immediately follows a REFHI or SECRELHI relocation. Its SymbolTableIndex contains a displacement and not an index into the symbol table.
end

# # # M32R Relocations
@constants IMAGE_REL_M32R "IMAGE_REL_M32R_" begin
    const IMAGE_REL_M32R_ABSOLUTE     = 0x0000 #  The relocation is ignored.
    const IMAGE_REL_M32R_ADDR32       = 0x0001 #  The target’s 32-bit VA.
    const IMAGE_REL_M32R_ADDR32NB     = 0x0002 #  The target’s 32-bit RVA.
    const IMAGE_REL_M32R_ADDR24       = 0x0003 #  The target’s 24-bit VA.
    const IMAGE_REL_M32R_GPREL16      = 0x0004 #  The target’s 16-bit offset from the GP register.
    const IMAGE_REL_M32R_PCREL24      = 0x0005 #  The target’s 24-bit offset from the program counter (PC), shifted left by 2 bits and sign-extended 
    const IMAGE_REL_M32R_PCREL16      = 0x0006 #  The target’s 16-bit offset from the PC, shifted left by 2 bits and sign-extended
    const IMAGE_REL_M32R_PCREL8       = 0x0007 #  The target’s 8-bit offset from the PC, shifted left by 2 bits and sign-extended
    const IMAGE_REL_M32R_REFHALF      = 0x0008 #  The 16 MSBs of the target VA.
    const IMAGE_REL_M32R_REFHI        = 0x0009 #  The 16 MSBs of the target VA, adjusted for LSB sign extension. This is used for the first instruction in a two-instruction sequence that loads a full 32-bit address. This relocation must be immediately followed by a PAIR relocation whose SymbolTableIndex contains a signed 16-bit displacement that is added to the upper 16 bits that are taken from the location that is being relocated.
    const IMAGE_REL_M32R_REFLO        = 0x000A #  The 16 LSBs of the target VA.
    const IMAGE_REL_M32R_PAIR         = 0x000B #  The relocation must follow the REFHI relocation. Its SymbolTableIndex contains a displacement and not an index into the symbol table.
    const IMAGE_REL_M32R_SECTION      = 0x000C #  The 16-bit section index of the section that contains the target. This is used to support debugging information.
    const IMAGE_REL_M32R_SECREL       = 0x000D #  The 32-bit offset of the target from the beginning of its section. This is used to support debugging information and static thread local storage.
    const IMAGE_REL_M32R_TOKEN        = 0x000E #  The CLR token.
end

const MachineRelocationMap = Dict(
    IMAGE_FILE_MACHINE_IA64 => IMAGE_REL_IA64,
    IMAGE_FILE_MACHINE_MIPS16 => IMAGE_REL_MIPS,
    IMAGE_FILE_MACHINE_MIPSFPU16 => IMAGE_REL_MIPS,
    IMAGE_FILE_MACHINE_MIPSFPU => IMAGE_REL_MIPS,
    IMAGE_FILE_MACHINE_M32R => IMAGE_REL_M32R,
    IMAGE_FILE_MACHINE_ARM64 => IMAGE_REL_ARM64,
    IMAGE_FILE_MACHINE_ARM => IMAGE_REL_ARM,
    IMAGE_FILE_MACHINE_SH3 => IMAGE_REL_SUPERH,
    IMAGE_FILE_MACHINE_SH3DSP => IMAGE_REL_SUPERH,
    IMAGE_FILE_MACHINE_SH4 => IMAGE_REL_SUPERH,
    IMAGE_FILE_MACHINE_SH5 => IMAGE_REL_SUPERH,
    IMAGE_FILE_MACHINE_AMD64 => IMAGE_REL_AMD64,
    IMAGE_FILE_MACHINE_POWERPC => IMAGE_REL_PPC,
    IMAGE_FILE_MACHINE_POWERPCFP => IMAGE_REL_PPC,
    IMAGE_FILE_MACHINE_AMD64 => IMAGE_REL_AMD64,
    IMAGE_FILE_MACHINE_I386 => IMAGE_REL_I386
)

# # # Type representations
@constants IMAGE_SYM_TYPE "IMAGE_SYM_TYPE_" begin
    const IMAGE_SYM_TYPE_NULL         = 0 # No type information or unknown base type. Microsoft tools use this setting
    const IMAGE_SYM_TYPE_VOID         = 1 # No valid type; used with void pointers and functions
    const IMAGE_SYM_TYPE_CHAR         = 2 # A character (signed byte)
    const IMAGE_SYM_TYPE_SHORT        = 3 # A 2-byte signed integer
    const IMAGE_SYM_TYPE_INT          = 4 # A natural integer type (normally 4 bytes in Windows)
    const IMAGE_SYM_TYPE_LONG         = 5 # A 4-byte signed integer
    const IMAGE_SYM_TYPE_FLOAT        = 6 # A 4-byte floating-point number
    const IMAGE_SYM_TYPE_DOUBLE       = 7 # An 8-byte floating-point number
    const IMAGE_SYM_TYPE_STRUCT       = 8 # A structure
    const IMAGE_SYM_TYPE_UNION        = 9 # A union
    const IMAGE_SYM_TYPE_ENUM         = 10 #  An enumerated type
    const IMAGE_SYM_TYPE_MOE          = 11 #  A member of enumeration (a specific value)
    const IMAGE_SYM_TYPE_BYTE         = 12 #  A byte; unsigned 1-byte integer
    const IMAGE_SYM_TYPE_WORD         = 13 #  A word; unsigned 2-byte integer
    const IMAGE_SYM_TYPE_UINT         = 14 #  An unsigned integer of natural size (normally, 4 bytes)
    const IMAGE_SYM_TYPE_DWORD        = 15 #  An unsigned 4-byte intege
end

@constants IMAGE_SYM_DTYPE "IMAGE_SYM_DTYPE_" begin
    const IMAGE_SYM_DTYPE_NULL        = 0 #  No derived type; the symbol is a simple scalar variable. 
    const IMAGE_SYM_DTYPE_POINTER     = 1 #  The symbol is a pointer to base type.
    const IMAGE_SYM_DTYPE_FUNCTION    = 2 #  The symbol is a function that returns a base type.
    const IMAGE_SYM_DTYPE_ARRAY       = 3 #  The symbol is an array of base type.
end

# # # Storage Class
@constants IMAGE_SYM_CLASS "IMAGE_SYM_CLASS_" begin
    const IMAGE_SYM_CLASS_END_OF_FUNCTION   = 0xFF   # A special symbol that represents the end of function, for debugging purposes.
    const IMAGE_SYM_CLASS_NULL              = 0      # No assigned storage class.
    const IMAGE_SYM_CLASS_AUTOMATIC         = 1      # The automatic (stack) variable. The Value field specifies the stack frame offset.
    const IMAGE_SYM_CLASS_EXTERNAL          = 2      # A value that Microsoft tools use for external symbols. The Value field indicates the size if the section number is IMAGE_SYM_UNDEFINED (0). If the section number is not zero, then the Value field specifies the offset within the section.
    const IMAGE_SYM_CLASS_STATIC            = 3      # The offset of the symbol within the section. If the Value field is zero, then the symbol represents a section name.
    const IMAGE_SYM_CLASS_REGISTER          = 4      # A register variable. The Value field specifies the register number.
    const IMAGE_SYM_CLASS_EXTERNAL_DEF      = 5      # A symbol that is defined externally.
    const IMAGE_SYM_CLASS_LABEL             = 6      # A code label that is defined within the module. The Value field specifies the offset of the symbol within the section.
    const IMAGE_SYM_CLASS_UNDEFINED_LABEL   = 7      # A reference to a code label that is not defined.
    const IMAGE_SYM_CLASS_MEMBER_OF_STRUCT  = 8      # The structure member. The Value field specifies the nth member.
    const IMAGE_SYM_CLASS_ARGUMENT          = 9      # A formal argument (parameter) of a function. The Value field specifies the nth argument.
    const IMAGE_SYM_CLASS_STRUCT_TAG        = 10     #   The structure tag-name entry.
    const IMAGE_SYM_CLASS_MEMBER_OF_UNION   = 11     #   A union member. The Value field specifies the nth member.
    const IMAGE_SYM_CLASS_UNION_TAG         = 12     #   The Union tag-name entry.
    const IMAGE_SYM_CLASS_TYPE_DEFINITION   = 13     #   A Typedef entry.
    const IMAGE_SYM_CLASS_UNDEFINED_STATIC  = 14     #   A static data declaration.
    const IMAGE_SYM_CLASS_ENUM_TAG          = 15     #   An enumerated type tagname entry.
    const IMAGE_SYM_CLASS_MEMBER_OF_ENUM    = 16     #   A member of an enumeration. The Value field specifies the nth member.
    const IMAGE_SYM_CLASS_REGISTER_PARAM    = 17     #   A register parameter.
    const IMAGE_SYM_CLASS_BIT_FIELD         = 18     #   A bit-field reference. The Value field specifies the nth bit in the bit field.
    const IMAGE_SYM_CLASS_BLOCK             = 100    #    A .bb (beginning of block) or .eb (end of block) record. The Value field is the relocatable address of the code location.
    const IMAGE_SYM_CLASS_FUNCTION          = 101    # A value that Microsoft tools use for symbol records that define the extent of a function: begin function (.bf), end function (.ef), and lines in function (.lf). For .lf records, the Value field gives the number of source lines in the function. For .ef records, the Value field gives the size of the function code.
    const IMAGE_SYM_CLASS_END_OF_STRUCT     = 102    # An end-of-structure entry.
    const IMAGE_SYM_CLASS_FILE              = 103    # A value that Microsoft tools, as well as traditional COFF format, use for the source-file symbol record. The symbol is followed by auxiliary records that name the file.
    const IMAGE_SYM_CLASS_SECTION           = 104    # A definition of a section (Microsoft tools use STATIC storage class instead).
    const IMAGE_SYM_CLASS_WEAK_EXTERNAL     = 105    # A weak external. For more information, see section 5.5.3, “Auxiliary Format 3: Weak Externals.”
    const IMAGE_SYM_CLASS_CLR_TOKEN         = 107    # A CLR token symbol. The name is an ASCII string that consists of the hexadecimal value of the token. For more information, see section 5.5.7, “CLR Token Definition (Object Only).”
end

# # # COMDAT Section
const IMAGE_COMDAT_SELECT_NODUPLICATES  = 1 #   If this symbol is already defined, the linker issues a “multiply defined symbol” error.
const IMAGE_COMDAT_SELECT_ANY           = 2 #   Any section that defines the same COMDAT symbol can be linked; the rest are removed.
const IMAGE_COMDAT_SELECT_SAME_SIZE     = 3 #   The linker chooses an arbitrary section among the definitions for this symbol. If all definitions are not the same size, a “multiply defined symbol” error is issued.
const IMAGE_COMDAT_SELECT_EXACT_MATCH   = 4 #   The linker chooses an arbitrary section among the definitions for this symbol. If all definitions do not match exactly, a “multiply defined symbol” error is issued.
const IMAGE_COMDAT_SELECT_ASSOCIATIVE   = 5 #   The section is linked if a certain other COMDAT section is linked. This other section is indicated by the Number field of the auxiliary symbol record for the section definition. This setting is useful for definitions that have components in multiple sections (for example, code in one and data in another), but where all must be linked or discarded as a set. The other section with which this section is associated must be a COMDAT section; it cannot be another associative COMDAT section (that is, the other section cannot have IMAGE_COMDAT_SELECT_ASSOCIATIVE set).
const IMAGE_COMDAT_SELECT_LARGEST       = 6 #   The linker chooses the largest definition from among all of the definitions for this symbol. If multiple definitions have this size, the choice between them is arbitrary.

# # # Win Cert
const WIN_CERT_REVISION_1_0 = 0x100  # Version 1, legacy version of the Win_Certificate structure. It is supported only for purposes of verifying legacy Authenticode signatures
const WIN_CERT_REVISION_2_0 = 0x200  # Version 2 is the current version of the Win_Certificate structure. 

const WIN_CERT_TYPE_X509                = 0x0001 # b_certificate contains an X.509 Certificate  (Not Supported)
const WIN_CERT_TYPE_PKCS_SIGNED_DATA    = 0x0002 # b_certificate contains a PKCS#7 SignedData structure
const WIN_CERT_TYPE_RESERVED_1          = 0x0003 # Reserved 
const WIN_CERT_TYPE_TS_STACK_SIGNED     = 0x0004 # Terminal Server Protocol Stack Certificate signing (Not Supported)

# # # Debug Type
const IMAGE_DEBUG_TYPE_UNKNOWN          = 0  # An unknown value that is ignored by all tools.
const IMAGE_DEBUG_TYPE_COFF             = 1  # The COFF debug information (line numbers, symbol table, and string table). This type of debug information is also pointed to by fields in the file headers.
const IMAGE_DEBUG_TYPE_CODEVIEW         = 2  # The Visual C++ debug information. 
const IMAGE_DEBUG_TYPE_FPO              = 3  # The frame pointer omission (FPO) information. This information tells the debugger how to interpret nonstandard stack frames, which use the EBP register for a purpose other than as a frame pointer.
const IMAGE_DEBUG_TYPE_MISC             = 4  # The location of DBG file.
const IMAGE_DEBUG_TYPE_EXCEPTION        = 5  # A copy of .pdata section.
const IMAGE_DEBUG_TYPE_FIXUP            = 6  # Reserved.
const IMAGE_DEBUG_TYPE_OMAP_TO_SRC      = 7  # The mapping from an RVA in image to an RVA in source image.
const IMAGE_DEBUG_TYPE_OMAP_FROM_SRC    = 8  # The mapping from an RVA in source image to an RVA in image.
const IMAGE_DEBUG_TYPE_BORLAND          = 9  # Reserved for Borland.
const IMAGE_DEBUG_TYPE_RESERVED10       = 10 # Reserved.
const IMAGE_DEBUG_TYPE_CLSID            = 11 # Reserved.

# # # Base Relocations
const IMAGE_REL_BASED_ABSOLUTE          = 0  # The base relocation is skipped. This type can be used to pad a block.
const IMAGE_REL_BASED_HIGH              = 1  # The base relocation adds the high 16 bits of the difference to the 16-bit field at offset. The 16-bit field represents the high value of a 32-bit word.
const IMAGE_REL_BASED_LOW               = 2  # The base relocation adds the low 16 bits of the difference to the 16-bit field at offset. The 16-bit field represents the low half of a 32-bit word. 
const IMAGE_REL_BASED_HIGHLOW           = 3  # The base relocation applies all 32 bits of the difference to the 32-bit field at offset.
const IMAGE_REL_BASED_HIGHADJ           = 4  # The base relocation adds the high 16 bits of the difference to the 16-bit field at offset. The 16-bit field represents the high value of a 32-bit word. The low 16 bits of the 32-bit value are stored in the 16-bit word that follows this base relocation. This means that this base relocation occupies two slots.
const IMAGE_REL_BASED_MIPS_JMPADDR      = 5  # For MIPS machine types, the base relocation applies to a MIPS jump instruction.
const IMAGE_REL_BASED_ARM_MOV32A        = 5  # For ARM machine types, the base relocation applies the difference to the 32-bit value encoded in the immediate fields of a contiguous MOVW+MOVT pair in ARM mode at offset.
#                                       = 6  # Reserved, must be zero.
const IMAGE_REL_BASED_ARM_MOV32T        = 7  # The base relocation applies the difference to the 32-bit value encoded in the immediate fields of a contiguous MOVW+MOVT pair in Thumb mode at offset.
const IMAGE_REL_BASED_MIPS_JMPADDR16    = 9  # The base relocation applies to a MIPS16 jump instruction.
const IMAGE_REL_BASED_DIR64             = 10 #The base relocation applies the difference to the 64-bit field at offset.

@enum METALLIB_TARGET::UInt16 begin
    METALLIB_TARGET_MACOS = 0x8001
    METALLIB_TARGET_IOS = 0x0001
end

@enum METALLIB_FILETYPE::UInt8 begin
    METALLIB_FILETYPE_EXECUTABLE = 0x00
    METALLIB_FILETYPE_COREIMAGE = 0x01
    METALLIB_FILETYPE_DYNAMIC = 0x02
    METALLIB_FILETYPE_SYMBOLCOMPANION = 0x03
end

@enum METALLIB_TARGET_OS::UInt8 begin
    METALLIB_TARGET_OS_UNKNOWN = 0x00
    METALLIB_TARGET_OS_MACOS = 0x81
    METALLIB_TARGET_OS_IOS = 0x82
    METALLIB_TARGET_OS_TVOS = 0x83
    METALLIB_TARGET_OS_WATCHOS = 0x84
    METALLIB_TARGET_OS_BRIDGEOS = 0x85
    METALLIB_TARGET_OS_MACCATALYST = 0x86
    METALLIB_TARGET_OS_IOS_SIMULATOR = 0x87
    METALLIB_TARGET_OS_TVOS_SIMULATOR = 0x88
    METALLIB_TARGET_OS_WATCHOS_SIMULATOR = 0x89
end

@io struct MetallibHeader{H <: ObjectHandle} <: MachOHeader{H}
    magic::UInt32
    target::METALLIB_TARGET
    ver_major::UInt16
    ver_minor::UInt16
    filetype::METALLIB_FILETYPE
    target_os::METALLIB_TARGET_OS
    os_major::UInt16
    os_minor::UInt16
    size::UInt64
    funclist_offset::UInt64
    funclist_size::UInt64
    public_md_offset::UInt64
    public_md_size::UInt64
    private_md_offset::UInt64
    private_md_size::UInt64
    bitcode_offset::UInt64
    bitcode_size::UInt64
end

function show(io::IO, header::MetallibHeader)
    println(io, "Metallib Header")
    println(io, "  Target ", header.target)
    println(io, "  Version ", header.ver_major, ".", header.ver_minor)
    println(io, "  File Type ", header.filetype)
    println(io, "  Target OS ", header.target_os)
    println(io, "  OS Version ", header.os_major, ".", header.os_minor)
    println(io, "  Size ", Base.format_bytes(header.size))
    println(io, "  Function List ", Base.format_bytes(header.funclist_size), " at 0x", string(header.funclist_offset; base=16))
    println(io, "  Public Metadata ", Base.format_bytes(header.public_md_size), " at 0x", string(header.public_md_offset; base=16))
    println(io, "  Private Metadata ", Base.format_bytes(header.private_md_size), " at 0x", string(header.private_md_offset; base=16))
    println(io, "  Bitcode ", Base.format_bytes(header.bitcode_size), " at 0x", string(header.bitcode_offset; base=16))
end

# Export Sections API
export Sections,
       getindex, length, lastindex, iterate, keys, eltype,
       findall, findfirst,
       handle, header, format_string

# Export Section API
export Section,
       deref, section_name, section_size, section_offset,
       section_address

# Export Datatypes
export SectionRef,
       read, seekstart, seek, eof, section_number

# Import Base methods for extension
import Base: read, seek, seekstart, eof, length, eltype, findall,
             findfirst, iterate, keys, lastindex

"""
    Sections

An abstraction over the concept of a collection of `Section` types within an
object file.  One can think of the `Sections` object containing the table of
section headers within the object file, whereas the `Section`/`SectionRef`
objects contain the actual section data itself.  The list of available API
operations is given below, with methods that subclasses must implement marked
in emphasis:

### Creation
  - *Sections()*

### Iteration
  - getindex()
  - *lastindex()*
  - length()
  - iterate()
  - keys()
  - eltype()

### Search
  - findall()
  - findfirst()

### Misc.
  - *handle()*
"""
abstract type Sections{H<:ObjectHandle} end

# Fairly simple iteration interface specification
@mustimplement lastindex(sections::Sections)
length(sections::Sections) = lastindex(sections)
keys(sections::Sections) = 1:length(sections)
iterate(sections::Sections, idx=1) = idx > length(sections) ? nothing : (sections[idx], idx+1)
eltype(::Type{S}) where {S <: Sections} = SectionRef

function getindex(sections::Sections, idx)
    # Punt off to `getindex_ref`
    oh = handle(sections)
    return getindex_ref(
        sections,
        section_header_offset(oh),
        section_header_size(oh),
        section_header_type(oh),
        SectionRef,
        idx
    )
end

"""
    findall(sections::Sections, name::String)

Return a list of sections that match the given `name`.
"""
function findall(sections::Sections, name::AbstractString)
    return findall(sections, [name])
end

"""
    findall(sections::Sections, name::String)

Return a list of sections that match one of the given `names`.
"""
function findall(sections::Sections, names::Vector{S}) where {S <: AbstractString}
    return [s for s in sections if section_name(s) in names]
end

"""
    findfirst(sections::Sections, name::String)

Return the first section that matches the given `name`.
"""
function findfirst(sections::Sections, name::AbstractString)
    return findfirst(sections, [name])
end

"""
    findfirst(sections::Sections, names::Vector{String})

Return the first section that matches on of the given `names`.
"""
function findfirst(sections::Sections, names::Vector{String})
    results = findall(sections, names)
    isempty(results) && return nothing
    return first(results)
end


"""
    handle(sections::Sections)

Return the `ObjectHandle` that this `Sections` object belongs to
"""
@mustimplement handle(sections::Sections)


"""
    Section

An abstraction over the concept of a `Section` within an object file.  Because
many operations upon sections require global operations (access to the string
table, knowledge of position within the file, etc...) some operations are
defined only upon the `SectionRef` datatype.  As a user, the `SectionRef` type
should be the primary method of interacting with sections, as a developer
adding new object file formats, some methods must support `Section`s, others
must support only `SectionRef`s.  Note that any method that works on a
`Section` must also work with a `SectionRef`, see the `@derefmethod` macro for
a convenient helper macro to generate `SectionRef` -> `Section` wrapper
methods. The list of available API operations is given below, with methods that
subclasses must implement marked in emphasis:

### Creation:
  - *read()*

### Utility:
  - deref()

### IO-like operations:
  - read()

### Format-specific properties:
  - *section_name()*
  - *section_size()*
  - *section_offset()*
  - *section_address()*
"""
abstract type Section{H<:ObjectHandle} end

# read() is how we construct a `Section`
@mustimplement read(oh::ObjectHandle, ::Type{Section})

deref(section::Section) = section

"""
    read(oh::ObjectHandle, section::Section)

Read the contents of the section referred to by `section` from the given
`ObjectHandle`, returning a `Vector{UInt8}`.
"""
function read(oh::H, section::Section{H}) where {H<:ObjectHandle}
    # Seek to the section's location, then read it in!
    seek(oh, section_offset(section))
    return read(oh, section_size(section))
end

"""
    section_name(section::Section)

Return the name of the given section as a string.  In order to return a true
name, it is necessary to perform a lookup within the object's string table,
which cannot be done using just a `Section` object; use a `SectionRef` object
instead if you need that.  For sanity sake, this method will return a string,
but the contents of the string may be something like the offset within the
string table pointing to this `Section`'s name, e.g. "@strtab.123"
"""
@mustimplement section_name(section::Section)

"""
    section_size(section::Section)

The size of the actual data contained in the section. This should exclude any
padding mandated by the file format e.g. due to alignment rules
"""
@mustimplement section_size(section::Section)

"""
    section_offset(section::Section)

The offset of the section in the file, in bytes
"""
@mustimplement section_offset(section::Section)

"""
    section_address(section::Section)

The address of the section in virtual memory.
"""
@mustimplement section_address(section::Section)


"""
    SectionRef

Provides a reference to a `Section`, along with a reference to the
`ObjectHandle` this `Section` comes from.  This should be the primary method by
which users interact with sections inside object files.  The list of available
API operations is given below, with methods that subclasses must implement
marked in emphasis.  Note that this overlaps heavily with the `Section` object
API, this is by design as many of the methods are simply passthroughs to the
underlying `Section` API calls for ease of use.

### Creation:
  - *SectionRef()*

### Utility
  - *deref()*
  - *handle()*
  - *Sections()*

### IO-like operations:
  - read()
  - seekstart()
  - seek()
  - eof()

### Format-specific properties:
  - section_name()
  - *section_number()*
  - section_type()
  - section_size()
  - section_offset()
  - section_address()
"""
abstract type SectionRef{H<:ObjectHandle} end

"""
    SectionRef(sections::Sections, section::Section, idx)

Construct a `SectionRef` object pointing to the given `Section`, which itself
represents the `idx`'th section within the given `Sections`.
"""
@mustimplement SectionRef(sections::Sections, section::Section, idx)


"""
    deref(section::SectionRef)

Dereference the given `SectionRef` object to a `Section`.
"""
@mustimplement deref(section::SectionRef)

"""
    handle(section::SectionRef)

Return the `ObjectHandle` this `SectionRef` belongs to.  This method is
`SectionRef`-only.
"""
@mustimplement handle(section::SectionRef)

"""
    Sections(section::SectionRef)

Return the `Sections` collection this `section` belongs to.
"""
@mustimplement Sections(section::SectionRef)

"""
    section_number(section::SectionRef)

The index of the given section within the section header table.
"""
@mustimplement section_number(section::SectionRef)

@derefmethod section_name(section::SectionRef)
@derefmethod section_size(section::SectionRef)
@derefmethod section_offset(section::SectionRef)
@derefmethod section_address(section::SectionRef)



"""
    read(section::SectionRef)

Read the contents of the section referred to by `section`, returning a
`Vector{UInt8}`.
"""
function read(section::SectionRef)
    return read(handle(section), deref(section))
end

"""
    seekstart(section::SectionRef)

Seek to the beginning of `section` in the `ObjectHandle` it was loaded from.
"""
function seekstart(section::SectionRef)
    return seek(handle(section), section_offset(section))
end

"""
    seek(section::SectionRef, offset)

Seek to `offset` relative to `section` in the `ObjectHandle` that this
`SectionRef` refers to
"""
function seek(section::SectionRef, offset)
    return seek(handle(section), section_offset(section) + offset)
end

"""
    eof(section::SectionRef)

Returns `true` if the `ObjectHandle` that this `SectionRef` refers to has read
beyond the current section's extent
"""
function eof(section::SectionRef)
    # If the handle itself thinks it's an eof(), then yeah let's quit out
    if eof(handle(section))
        return true
    end

    # If we are beyond this section, then we also consider this the end of the
    # current section
    section_end = section_offset(section) + section_size(section)
    return position(handle(section)) >= section_end
end



# Common Printing
function show(io::IO, s::Union{Section{H},SectionRef{H}}) where {H <: ObjectHandle}
    print(io, "$(format_string(H)) Section")

    if !get(io, :compact, false)
        println(io)
        println(io, "       Name: $(section_name(s))")
        println(io, "       Size: 0x$(string(section_size(s), base=16))")
        println(io, "     Offset: 0x$(string(section_offset(s), base=16))")
        print(io,   "    Address: 0x$(string(section_address(s), base=16))")
    else
        print(io, " \"$(section_name(s))\"")
    end
end

show(io::IO, sects::Sections{H}) where {H <: ObjectHandle} = show_collection(io, sects, H)

# Export Segments API
export Segments, handle

# Export Segment API
export Segment, deref, segment_name, segment_offset, segment_file_size,
       segment_memory_size, segment_address

export SegmentRef, segment_number

# Import Base stuff for extension
import Base: getindex, length, eltype, findfirst, findall, iterate, keys, lastindex

"""
    Segments

An abstraction over the concept of a collection of `Segment` types within an
object file.  One can think of the `Segments` object containing the table of
segment headers within the object file, whereas the `Segment`/`SegmentRef`
objects contain the actual segment data itself.  The list of available API
operations is given below, with methods that subclasses must implement marked
in emphasis:

### Creation
  - *Segments()*

### Iteration
  - *getindex()*
  - *lastindex()*
  - length()
  - iterate()
  - keys()
  - eltype()

### Search
  - findall()
  - findfirst()

### Misc.
  - *handle()*
"""
abstract type Segments{H<:ObjectHandle} end

# Fairly simple iteration interface specification
@mustimplement lastindex(segs::Segments)
length(segs::Segments) = lastindex(segs)
keys(segs::Segments) = 1:length(segs)
iterate(segs::Segments, idx=1) = idx > length(segs) ? nothing : (segs[idx], idx+1)
eltype(::Type{S}) where {S <: Segments} = SegmentRef

function getindex(segs::Segments, idx)
    # Punt off to `getindex_ref`
    oh = handle(segs)
    return getindex_ref(
        segs,
        segment_header_offset(oh),
        segment_header_size(oh),
        segment_header_type(oh),
        SegmentRef,
        idx
    )
end




"""
    Segment

An abstraction over the concept of a `Segment` within an object file.  A
`Segment` is a portion of an object file that is given instruction on its
layout in virtual memory; this is in contrast to a `Section`, which delineates
different portions of an object file on disk.  ELF files have the strictest
separation here, with a single executable file containing multiple `Segment`
and `Section` objects, with `Section`s being assigned to one or more `Segment`s
for virtual memory placement.  Mach-O files typically have two `Segment`s, one
called `__TEXT`, one called `__DATA`.  COFF files do not have `Segment`.

Just like with `Section` objects, many operations upon segments require global
operations (access to the string table, knowledge of position within the file,
etc...) which causes some operations to be defined only upon the `SegmentRef`
datatype.  As a user, the `SegmentRef` type should be the primary method of
interacting with segments, as a developer adding new object file formats,
some methods must support `Segment`s, others must support only `SegmentRef`s.
Note that any method that works on a `Segment` must also work with a
`SegmentRef`, see the `@derefmethod` macro for a convenient helper macro to
generate `SegmentRef` -> `Section` wrapper methods. The list of available API
operations is given below, with methods that subclasses must implement marked
in emphasis:

### Creation:
  - *read()*

### Utility:
  - deref()

### Format-specific properties:
  - *segment_name()*
  - *segment_offset()*
  - *segment_file_size()*
  - *segment_memory_size()*
  - *segment_address()*
"""
abstract type Segment{H <: ObjectHandle} end

deref(seg::Segment) = seg
@mustimplement read(oh::ObjectHandle, ::Type{Segment})
@mustimplement segment_name(seg::Segment)
@mustimplement segment_offset(seg::Segment)
@mustimplement segment_file_size(seg::Segment)
@mustimplement segment_memory_size(seg::Segment)
@mustimplement segment_address(seg::Segment)



"""
    SegmentRef

Provides a reference to a `Segment`, along with a reference to the
`ObjectHandle` this `Segment` comes from.  This should be the primary method by
which users interact with segments inside object files.  The list of available
API operations is given below, with methods that subclasses must implement
marked in emphasis.  Note that this overlaps heavily with the `Segment` object
API, this is by design as many of the methods are simply passthroughs to the
underlying `Segment` API calls for ease of use.

### Creation:
  - *SegmentRef()*

### Utility
  - *deref()*
  - *Segments()*
  - handle()

### Format-specific properties:
  - *segment_name()*
  - *segment_number()*
  - segment_offset()
  - segment_file_size()
  - segment_memory_size()
  - segment_address()
"""
abstract type SegmentRef{H<:ObjectHandle} end

@mustimplement SegmentRef(segs::Segments, seg::Segment, idx)


"""
    deref(seg::SegmentRef)

Dereference the given `SegmentRef` object to a `Segment`.
"""
@mustimplement deref(seg::SegmentRef)

"""
    Segments(seg::SegmentRef)

Return the `Segments` collection this `Segment` belongs to.
"""
@mustimplement Segments(seg::SegmentRef)

"""
    handle(seg::SegmentRef)

Return the `ObjectHandle` this `SegmentRef` belongs to.  This method is
`SegmentRef`-only.
"""
handle(seg::SegmentRef) = handle(Segments(seg))


"""
    segment_name(seg::SegmentRef)

The name of the given `Segment`, returned as a string.  This method often
performs some kind of lookup within the string table of the object to get the
full name of the segment.
"""
@mustimplement segment_name(seg::SegmentRef)

"""
    segment_number(seg::SegmentRef)

Return the index of the referred segment.
"""
@mustimplement segment_number(seg::SegmentRef)

@derefmethod segment_type(seg::SegmentRef)
@derefmethod segment_offset(seg::SegmentRef)
@derefmethod segment_file_size(seg::SegmentRef)
@derefmethod segment_memory_size(seg::SegmentRef)
@derefmethod segment_address(seg::SegmentRef)



## Printing
show(io::IO, segs::Segments{H}) where {H <: ObjectHandle} = show_collection(io, segs, H)

# Export Datatypes
export ELFHandle

# Import Base methods
import Base: getindex


"""
    ELFHandle

An `ObjectHandle` subclass for ELF files, this is the primary object by which
client applications will interact with ELF files.
"""
struct ELFHandle{T<:IO} <: ObjectHandle
    # Backing IOS and start point within the IOStream of this ELF object
    io::T
    start::Int64

    # Elf Internal data such as endianness, version, OS ABI, etc...
    ei::ELFInternal

    # The parsed-out header of the ELF object
    header::ELFHeader

    # The path of the file this was created with
    path::String
end

## Define creation methods
function readmeta(io::IO, ::Type{H}) where {H <: ELFHandle}
    # This is the magic that we know we must find
    elven_magic = UInt8['\177', 'E', 'L', 'F']

    # Save the starting position of `io`
    start = position(io)

    # Check for magic bytes
    magic = [read(io, UInt8) for idx in 1:4]
    if any(magic .!= elven_magic)
        msg = """
        Magic Number 0x$(join(string.(magic, base=16),"")) does not match expected ELF
        magic number 0x$(join("", string.(elven_magic, base=16)))
        """
        throw(MagicMismatch(replace(strip(msg), "\n" => " ")))
    end

    # Read the ELF Internal data, then skip its padding
    ei = unpack(io, ELFInternal)
    skip(io, 7)

    # Build different Header objects for 32 or 64-bit ELF
    header_type = elf_internal_is64bit(ei) ? ELFHeader64{H} : ELFHeader32{H}

    # Unpack the header, but pretend we didn't by rewinding `io`
    header = unpack(io, header_type, elf_internal_endianness(ei))
    seek(io, start)

    # Construct our ELFHandle, pilfering the filename from the IOStream
    return [ELFHandle(io, Int64(start), ei, header, path(io))]
end


## IOStream-like operations:
startaddr(oh::ELFHandle) = oh.start
iostream(oh::ELFHandle) = oh.io

# We don't try to inspect dynamic libraries to figure out if this is a glibc or musl dynamic object
function strip_libc_tag(p::Platform)
    delete!(tags(p), "libc")
    return p
end

## Format-specific properties:
header(oh::ELFHandle) = oh.header
function Platform(oh::ELFHandle)
    arch = elf_machine_to_arch(oh.header.e_machine)
    if oh.ei.osabi == ELFOSABI_LINUX || oh.ei.osabi == ELFOSABI_NONE
        return strip_libc_tag(Platform(arch, "linux"))
    elseif oh.ei.osabi == ELFOSABI_FREEBSD
        return Platform(arch, "freebsd")
    else
        throw(ArgumentError("Unknown ELF OSABI $(oh.ei.osabi)"))
    end
end
endianness(oh::ELFHandle) = elf_internal_endianness(oh.ei)
is64bit(oh::ELFHandle) = elf_internal_is64bit(oh.ei)
isrelocatable(oh::ELFHandle) = header(oh).e_type == ET_REL
isexecutable(oh::ELFHandle) = header(oh).e_type == ET_EXEC
islibrary(oh::ELFHandle) = header(oh).e_type == ET_DYN
isdynamic(oh::ELFHandle) = !isempty(findall(Sections(oh), ".dynamic"))
mangle_section_name(oh::ELFHandle, name::AbstractString) = string(".", name)
mangle_symbol_name(oh::ELFHandle, name::AbstractString) = name
format_string(::Type{H}) where {H <: ELFHandle} = "ELF"

# Section information
section_header_offset(oh::ELFHandle) = header(oh).e_shoff
section_header_size(oh::ELFHandle) = header(oh).e_shentsize
function section_header_type(oh::H) where {H <: ELFHandle}
    if is64bit(oh)
        return ELFSection64{H}
    else
        return ELFSection32{H}
    end
end


# Segment information (Note this is NOT a part of the generic ObjectFile API,
# this is an ELF-only extension)
"""
    segment_header_offset(oh::ELFHandle)

Return the offset of the segment header table within the given ELF object.
"""
segment_header_offset(oh::ELFHandle) = header(oh).e_phoff

"""
    segment_header_offset(oh::ELFHandle)

Return the size of a segment header within the given ELF object.
"""
segment_header_size(oh::ELFHandle) = header(oh).e_phentsize

"""
    segment_header_type(oh::ELFHandle)

Return the type of a segment header within the given ELF object.  E.g. within a
64-bit ELF object, this will return `ELFSegment64`.
"""
function segment_header_type(oh::H) where {H <: ELFHandle}
    if is64bit(oh)
        return ELFSegment64{H}
    else
        return ELFSegment32{H}
    end
end


# Symbol information
symtab_entry_offset(oh::ELFHandle) = section_offset(Symbols(oh).section_ref)
symtab_entry_size(oh::ELFHandle) = sizeof(symtab_entry_type(oh))
function symtab_entry_type(oh::H) where {H <: ELFHandle}
    if is64bit(oh)
        return ELFSymtabEntry64{H}
    else
        return ELFSymtabEntry32{H}
    end
end

# Dynamic Linkage information
function dyn_entry_type(oh::H) where {H <: ELFHandle}
    if is64bit(oh)
        return ELFDynEntry64{H}
    else
        return ELFDynEntry32{H}
    end
end


## Misc. operations
path(oh::ELFHandle) = oh.path

export MachHeader, MachHeader32, MachHeader64

import Base: show

"""
    MachHeader

Mach-O Header type, containing metadata about the Mach object itself, such as
its CPU target, the number of Load Commands within the file, etc...
"""
abstract type MachOHeader{H <: ObjectHandle} end

@io struct MachOHeader32{H <: ObjectHandle} <: MachOHeader{H}
    magic::UInt32
    cputype::UInt32
    cpusubtype::UInt32
    filetype::UInt32
    ncmds::UInt32
    sizeofcmds::UInt32
    flags::UInt32
end

@io struct MachOHeader64{H <: ObjectHandle} <: MachOHeader{H}
    magic::UInt32
    cputype::UInt32
    cpusubtype::UInt32
    filetype::UInt32
    ncmds::UInt32
    sizeofcmds::UInt32
    flags::UInt32
    reserved::UInt32
end

"""
    macho_header_type(magic::UInt32)

Given the `magic` field from a Mach-O file header, return the type of the
Mach-O header.
"""
function macho_header_type(magic::UInt32)
    if magic in (MH_MAGIC, MH_CIGAM)
        return MachOHeader32{MachOHandle}
    elseif magic in (MH_MAGIC_64, MH_CIGAM_64)
        return MachOHeader64{MachOHandle}
    elseif magic in (FAT_MAGIC, FAT_CIGAM, FAT_MAGIC_64, FAT_CIGAM_64, FAT_MAGIC_METAL, FAT_CIGAM_METAL)
        return MachOFatHeader{MachOHandle}
    elseif magic in (METALLIB_MAGIC,)
        return MetallibHeader{MachOHandle}
    else
        throw(MagicMismatch("Invalid Magic ($(string(magic, base=16)))!"))
    end
end

"""
    macho_is64bit(magic::UInt32)

Given the `magic` field from a Mach-O file header, return the bitwidth of the
Mach-O header.
"""
function macho_is64bit(magic::UInt32)
    if magic in (MH_MAGIC_64, MH_CIGAM_64, FAT_MAGIC_64, FAT_CIGAM_64)
        return true
    elseif magic in (MH_MAGIC, MH_CIGAM, FAT_MAGIC, FAT_CIGAM, FAT_MAGIC_METAL, FAT_CIGAM_METAL, METALLIB_MAGIC)
        return false
    else
        throw(MagicMismatch("Invalid Magic ($(string(magic, base=16)))!"))
    end
end

"""
    macho_endianness(magic::UInt32)

Given the `magic` field from a Mach-O file header, return the endianness of the
Mach-O header.
"""
function macho_endianness(magic::UInt32)
    if magic in (MH_CIGAM, MH_CIGAM_64, FAT_CIGAM, FAT_CIGAM_METAL)
        return :BigEndian
    elseif magic in (MH_MAGIC, MH_MAGIC_64, FAT_MAGIC, FAT_MAGIC_METAL, METALLIB_MAGIC)
        return :LittleEndian
    else
        throw(MagicMismatch("Invalid Magic ($(string(magic, base=16)))!"))
    end
end

function show(io::IO, header::MachOHeader)
    println(io, "MachO Header")
    println(io, "  CPU Type ", header.cputype)
    println(io, "  CPU Subtype ", header.cpusubtype)
    println(io, "  File Type ", header.filetype)
    println(io, "  Number of load commands ", header.ncmds)
    println(io, "  Flags ", header.flags)
end

# Export DynamicLinks API
export DynamicLinks,
       getindex, length, iterate, keys, lastindex, eltype,
       handle, header
       
# Export Dynamic Link API
export DynamicLink,
       DynamicLinks, handle, path

# Export RPath API
export RPath,
       handle, rpaths, canonical_rpaths, find_library
       
# Import iteration protocol
import Base: iterate, keys, length, lastindex

"""
    DynamicLinks

This type encapsulates the list of dynamic links within an object, holding a
collection of `DynamicLink` objects.  The list of available API operations is
given below, with methods that subclasses must implement marked in emphasis:

### Creation
  - *DynamicLinks()*

### Iteration
  - *getindex()*
  - *lastindex()*
  - iterate()
  - keys()
  - eltype()

### Misc.
  - *handle()*
"""
abstract type DynamicLinks{H <: ObjectHandle} end

@mustimplement lastindex(dls::DynamicLinks)
keys(dls::DynamicLinks) = 1:length(dls)
iterate(dls::DynamicLinks, idx=1) = idx > length(dls) ? nothing : (dls[idx], idx+1)
length(dls::DynamicLinks) = lastindex(dls)
eltype(::Type{D}) where {D <: DynamicLinks} = DynamicLink
@mustimplement getindex(dls::DynamicLinks, idx)

"""
    DynamicLink
  
This type encapsulates the linkage of one object file to another.  The list of
available API operations is given below, with methods that subclasses must
implement marked in emphasis:

### Creation:
  - *DynamicLink()*

### Accessors:
  - *DynamicLinks()*
  - *handle()*
  - *path()*
"""
abstract type DynamicLink{H <: ObjectHandle} end

@mustimplement path(dl::DynamicLink)


"""
    RPath

This type encapsulates the search path used by an object file when looking for
a shared library.  This class enables not only looking at the path, but
querying the path for matches for given library names.  The list of available
API operations is given below, with methods that subclasses must implement
marked in emphasis:

### Creation:
  - *RPath()*

### Utility
  - *handle()*

### RPath operations
  - *rpaths()*
  - canonical_rpaths()
  - find_library()
  - lastindex()
  - iterate()
"""
abstract type RPath{H <: ObjectHandle} end

"""
    RPath(oh::ObjectHandle)

Construct an `RPath` object from the given `ObjectHandle`.
"""
@mustimplement RPath(oh::ObjectHandle)

"""
    handle(rpath::RPath)

Return the handle that this `RPath` object refers to.
"""
@mustimplement handle(rpath::RPath)

"""
    rpaths(rpath::RPath)

Return the list of paths that will be searched for shared libraries.
"""
@mustimplement rpaths(rpath::RPath)

lastindex(rpath::RPath) = lastindex(rpaths(rpath))
keys(rpath::RPath) = 1:length(rpath)
iterate(rpath::RPath, idx=1) = idx > length(rpath) ? nothing : (rpath[idx], idx+1)
length(rpath::RPath) = lastindex(rpath)
eltype(::Type{D}) where {D <: RPath} = String
getindex(rpath::RPath, idx) = rpaths(rpath)[idx]


"""
    canonical_rpaths(rpath::RPath)

Return a canonicalized list of paths that will be searched.
"""
function canonical_rpaths(rpath::RPath)
    origin = dirname(path(handle(rpath)))
    paths = rpaths(rpath)
    for idx in 1:length(paths)
        # Substitute the path of the containing handle for `$ORIGIN` and
        # `@loader_path`.  Do the same for `@executable_path` even though
        # that's technically incorrect, because we don't have a good way to
        # track the web of dependencies right now.
        paths[idx] = replace(paths[idx], "\$ORIGIN" => origin)
        paths[idx] = replace(paths[idx], "@loader_path" => origin)
        paths[idx] = replace(paths[idx], "@executable_path" => origin)
        paths[idx] = abspath(paths[idx])

        # Make sure that if it's a directory, it _always_ has a trailing path separator.
        if isdir(paths[idx]) && paths[idx][end:end] != Base.Filesystem.path_separator
            paths[idx] = paths[idx] * Base.Filesystem.path_separator
        end
    end
    return paths
end

"""
    find_library(rpath::RPath, soname::String)

Return the full path to a library, searching the given `RPath`, and then the
default library search paths.  This method takes the given `soname` and joins
it to the end of every path within the given `RPath`, returning the resultant
path if it exists, returning back the original `soname` if it doesn't.
"""
function find_library(rpath::RPath, soname::AbstractString)
    for path in canonical_rpaths(rpath)
        libpath = joinpath(path, soname)
        if isfile(libpath)
            return libpath
        end
    end
    return soname
end


### Printing
function show(io::IO, dl::DynamicLink{H}) where {H <: ObjectHandle}
    print(io, "$(format_string(H)) DynamicLink \"$(path(dl))\"")
end

show(io::IO, dls::DynamicLinks{H}) where {H <: ObjectHandle} = show_collection(io, dls, H)
show(io::IO, rp::RPath{H}) where {H <: ObjectHandle} = show_collection(io, rp, H)

export COFFHeader

import Base: show

@io struct COFFHeader
    Machine::UInt16
    NumberOfSections::UInt16
    TimeDateStamp::UInt32
    PointerToSymbolTable::UInt32
    NumberOfSymbols::UInt32
    SizeOfOptionalHeader::UInt16
    Characteristics::UInt16
end

function coff_header_is64bit(h::COFFHeader)
    wide_machines = [
        IMAGE_FILE_MACHINE_AMD64,
        IMAGE_FILE_MACHINE_ARM64,
        IMAGE_FILE_MACHINE_IA64,
    ]
    return h.Machine in wide_machines
end

function coff_header_endianness(h::COFFHeader)
    # We don't ever process :BigEndian COFF files; but if we did, we'd probably
    # design a check against `h.Machine` here.
    return :LittleEndian
end

isexecutable(h::COFFHeader) = (h.Characteristics & IMAGE_FILE_EXECUTABLE_IMAGE) != 0
islibrary(h::COFFHeader) = (h.Characteristics & IMAGE_FILE_DLL) != 0
isrelocatable(h::COFFHeader) = !isexecutable(h) && !islibrary(h)

num_sections(h::COFFHeader) = h.NumberOfSections
num_symbols(h::COFFHeader) = h.NumberOfSymbols

function show(io::IO, header::COFFHeader)
    println(io, "COFF Header")
    println(io, "  Machine ", header.Machine)
    println(io, "  Number of Sections ", header.NumberOfSections)
    println(io, "  Time Date Stamp ", header.TimeDateStamp)
    println(io, "  Number of Symbols ", header.NumberOfSymbols)
end

# These constants are in glibc and llvm:
# * https://github.com/bminor/glibc/blob/969d7cf89966d55fbf0732ae7bc0949a970c837d/elf/elf.h
# * https://github.com/llvm/llvm-project/blob/b2d7312d52f299a2f854c673796ad1a699e0d79f/llvm/include/llvm/BinaryFormat/ELF.h

# e_ident[EIBCLASS]
const ELFCLASSNONE = 0 #Invalid class
const ELFCLASS32 = 1 #32-bit objects
const ELFCLASS64 = 2 #64-bit objects

# e_ident[EI_DATA]
const ELFDATANONE = 0
const ELFDATA2LSB = 1
const ELFDATA2MSB = 2

# e_ident[EI_VERSION]
const EV_NONE = 0       #Invalid Version
const EV_CURRENT = 1    #Current Version

# e_ident[EI_OSABI]
const ELFOSABI_NONE         = 0   # No extensions or unspecified
const ELFOSABI_HPUX         = 1   # Hewlett-Packard HP-UX
const ELFOSABI_NETBSD       = 2   # NetBSD
const ELFOSABI_GNU          = 3   # GNU
const ELFOSABI_LINUX        = 3   # Linux historical - alias for ELFOSABI_GNU
const ELFOSABI_SOLARIS      = 6   # Sun Solaris
const ELFOSABI_AIX          = 7   # AIX
const ELFOSABI_IRIX         = 8   # IRIX
const ELFOSABI_FREEBSD      = 9   # FreeBSD
const ELFOSABI_TRU64        = 10  # Compaq TRU64 UNIX
const ELFOSABI_MODESTO      = 11  # Novell Modesto
const ELFOSABI_OPENBSD      = 12  # Open BSD
const ELFOSABI_OPENVMS      = 13  # Open VMS
const ELFOSABI_NSK          = 14  # Hewlett-Packard Non-Stop Kernel
const ELFOSABI_AROS         = 15  # Amiga Research OS
const ELFOSABI_FENIXOS      = 16  # FenixOS
const ELFOSABI_CLOUDABI     = 17  # Nuxi CloudABI
const ELFOSABI_OPENVOS      = 18  # Stratus Technologies OpenVOS
const ELFOSABI_C6000_ELFABI = 64  # Bare-metal TMS320C6000
const ELFOSABI_C6000_LINUX  = 65  # Linux TMS320C6000
const ELFOSABI_ARM	        = 97  # ARM
const ELFOSABI_STANDALONE   = 255 # Standalone (embedded) application

# e_type constants
@constants ET_TYPES "ET_" begin
    const ET_NONE = 0   #No file type
    const ET_REL  = 1   #Relocatable file
    const ET_EXEC = 2   #Executable file
    const ET_DYN  = 3   #Shared object file
    const ET_CORE = 4   #Core file
end
@constants ET_RANGES "ET_" begin
    const ET_LOOS       = 0xfe00  #Operating system-specific
    const ET_HIOS       = 0xfeff  #Operating system-specific
    const ET_LOPROC     = 0xff00  #Processor-specific
    const ET_HIPROC     = 0xffff  #Processor-specific
end

@constants EM_MACHINES "EM_" begin
    # e_machine constants
    const EM_NONE = 0   #No machine
    const EM_M32  = 1   #AT&T WE 32100
    const EM_SPARC    = 2   #SPARC
    const EM_386  = 3   #Intel 80386
    const EM_68K  = 4   #Motorola 68000
    const EM_88K  = 5   #Motorola 88000
    #6                  Reserved for future use (was EM_486)
    const EM_860  = 7   #Intel 80860
    const EM_MIPS = 8   #MIPS I Architecture
    const EM_S370 = 9   #IBM System/370 Processor
    const EM_MIPS_RS3_LE  = 10  #MIPS RS3000 Little-endian
    #11-14              Reserved for future use
    const EM_PARISC   = 15  #Hewlett-Packard PA-RISC
    #16  Reserved for future use
    const EM_VPP500   = 17  #Fujitsu VPP500
    const EM_SPARC32PLUS  = 18  #Enhanced instruction set SPARC
    const EM_960  = 19  #Intel 80960
    const EM_PPC  = 20  #PowerPC
    const EM_PPC64    = 21  #64-bit PowerPC
    const EM_S390 = 22  #IBM System/390 Processor
    const EM_SPU  = 23  #IBM SPU/SPC
    #24-35   Reserved for future use
    const EM_V800 = 36  #NEC V800
    const EM_FR20 = 37  #Fujitsu FR20
    const EM_RH32 = 38  #TRW RH-32
    const EM_RCE  = 39  #Motorola RCE
    const EM_ARM  = 40  #ARM 32-bit architecture (AARCH32)
    const EM_ALPHA    = 41  #Digital Alpha
    const EM_SH   = 42  #Hitachi SH
    const EM_SPARCV9  = 43  #SPARC Version 9
    const EM_TRICORE  = 44  #Siemens TriCore embedded processor
    const EM_ARC  = 45  #Argonaut RISC Core, Argonaut Technologies Inc.
    const EM_H8_300   = 46  #Hitachi H8/300
    const EM_H8_300H  = 47  #Hitachi H8/300H
    const EM_H8S  = 48  #Hitachi H8S
    const EM_H8_500   = 49  #Hitachi H8/500
    const EM_IA_64    = 50  #Intel IA-64 processor architecture
    const EM_MIPS_X   = 51  #Stanford MIPS-X
    const EM_COLDFIRE = 52  #Motorola ColdFire
    const EM_68HC12   = 53  #Motorola M68HC12
    const EM_MMA  = 54  #Fujitsu MMA Multimedia Accelerator
    const EM_PCP  = 55  #Siemens PCP
    const EM_NCPU = 56  #Sony nCPU embedded RISC processor
    const EM_NDR1 = 57  #Denso NDR1 microprocessor
    const EM_STARCORE = 58  #Motorola Star*Core processor
    const EM_ME16 = 59  #Toyota ME16 processor
    const EM_ST100    = 60  #STMicroelectronics ST100 processor
    const EM_TINYJ    = 61  #Advanced Logic Corp. TinyJ embedded processor family
    const EM_X86_64   = 62  #AMD x86-64 architecture
    const EM_PDSP = 63  #Sony DSP Processor
    const EM_PDP10    = 64  #Digital Equipment Corp. PDP-10
    const EM_PDP11    = 65  #Digital Equipment Corp. PDP-11
    const EM_FX66 = 66  #Siemens FX66 microcontroller
    const EM_ST9PLUS  = 67  #STMicroelectronics ST9+ 8/16 bit microcontroller
    const EM_ST7  = 68  #STMicroelectronics ST7 8-bit microcontroller
    const EM_68HC16   = 69  #Motorola MC68HC16 Microcontroller
    const EM_68HC11   = 70  #Motorola MC68HC11 Microcontroller
    const EM_68HC08   = 71  #Motorola MC68HC08 Microcontroller
    const EM_68HC05   = 72  #Motorola MC68HC05 Microcontroller
    const EM_SVX  = 73  #Silicon Graphics SVx
    const EM_ST19 = 74  #STMicroelectronics ST19 8-bit microcontroller
    const EM_VAX  = 75  #Digital VAX
    const EM_CRIS = 76  #Axis Communications 32-bit embedded processor
    const EM_JAVELIN  = 77  #Infineon Technologies 32-bit embedded processor
    const EM_FIREPATH = 78  #Element 14 64-bit DSP Processor
    const EM_ZSP  = 79  #LSI Logic 16-bit DSP Processor
    const EM_MMIX = 80  #Donald Knuth's educational 64-bit processor
    const EM_HUANY    = 81  #Harvard University machine-independent object files
    const EM_PRISM    = 82  #SiTera Prism
    const EM_AVR  = 83  #Atmel AVR 8-bit microcontroller
    const EM_FR30 = 84  #Fujitsu FR30
    const EM_D10V = 85  #Mitsubishi D10V
    const EM_D30V = 86  #Mitsubishi D30V
    const EM_V850 = 87  #NEC v850
    const EM_M32R = 88  #Mitsubishi M32R
    const EM_MN10300  = 89  #Matsushita MN10300
    const EM_MN10200  = 90  #Matsushita MN10200
    const EM_PJ   = 91  #picoJava
    const EM_OPENRISC = 92  #OpenRISC 32-bit embedded processor
    const EM_ARC_COMPACT  = 93  #ARC International ARCompact processor (old spelling/synonym: EM_ARC_A5)
    const EM_XTENSA   = 94  #Tensilica Xtensa Architecture
    const EM_VIDEOCORE    = 95  #Alphamosaic VideoCore processor
    const EM_TMM_GPP  = 96  #Thompson Multimedia General Purpose Processor
    const EM_NS32K    = 97  #National Semiconductor 32000 series
    const EM_TPC  = 98  #Tenor Network TPC processor
    const EM_SNP1K    = 99  #Trebia SNP 1000 processor
    const EM_ST200    = 100 #STMicroelectronics (www.st.com) ST200 microcontroller
    const EM_IP2K = 101 #Ubicom IP2xxx microcontroller family
    const EM_MAX  = 102 #MAX Processor
    const EM_CR   = 103 #National Semiconductor CompactRISC microprocessor
    const EM_F2MC16   = 104 #Fujitsu F2MC16
    const EM_MSP430   = 105 #Texas Instruments embedded microcontroller msp430
    const EM_BLACKFIN = 106 #Analog Devices Blackfin (DSP) processor
    const EM_SE_C33   = 107 #S1C33 Family of Seiko Epson processors
    const EM_SEP  = 108 #Sharp embedded microprocessor
    const EM_ARCA = 109 #Arca RISC Microprocessor
    const EM_UNICORE  = 110 #Microprocessor series from PKU-Unity Ltd. and MPRC of Peking University
    const EM_EXCESS   = 111 #eXcess: 16/32/64-bit configurable embedded CPU
    const EM_DXP  = 112 #Icera Semiconductor Inc. Deep Execution Processor
    const EM_ALTERA_NIOS2 = 113 #Altera Nios II soft-core processor
    const EM_CRX  = 114 #National Semiconductor CompactRISC CRX microprocessor
    const EM_XGATE    = 115 #Motorola XGATE embedded processor
    const EM_C166 = 116 #Infineon C16x/XC16x processor
    const EM_M16C = 117 #Renesas M16C series microprocessors
    const EM_DSPIC30F = 118 #Microchip Technology dsPIC30F Digital Signal Controller
    const EM_CE   = 119 #Freescale Communication Engine RISC core
    const EM_M32C = 120 #Renesas M32C series microprocessors
    #121-130 Reserved for future use
    const EM_TSK3000  = 131 #Altium TSK3000 core
    const EM_RS08 = 132 #Freescale RS08 embedded processor
    const EM_SHARC    = 133 #Analog Devices SHARC family of 32-bit DSP processors
    const EM_ECOG2    = 134 #Cyan Technology eCOG2 microprocessor
    const EM_SCORE7   = 135 #Sunplus S+core7 RISC processor
    const EM_DSP24    = 136 #New Japan Radio (NJR) 24-bit DSP Processor
    const EM_VIDEOCORE3   = 137 #Broadcom VideoCore III processor
    const EM_LATTICEMICO32    = 138 #RISC processor for Lattice FPGA architecture
    const EM_SE_C17   = 139 #Seiko Epson C17 family
    const EM_TI_C6000 = 140 #The Texas Instruments TMS320C6000 DSP family
    const EM_TI_C2000 = 141 #The Texas Instruments TMS320C2000 DSP family
    const EM_TI_C5500 = 142 #The Texas Instruments TMS320C55x DSP family
    #143-159 Reserved for future use
    const EM_MMDSP_PLUS   = 160 #STMicroelectronics 64bit VLIW Data Signal Processor
    const EM_CYPRESS_M8C  = 161 #Cypress M8C microprocessor
    const EM_R32C = 162 #Renesas R32C series microprocessors
    const EM_TRIMEDIA = 163 #NXP Semiconductors TriMedia architecture family
    const EM_QDSP6    = 164 #QUALCOMM DSP6 Processor
    const EM_8051 = 165 #Intel 8051 and variants
    const EM_STXP7X   = 166 #STMicroelectronics STxP7x family of configurable and extensible RISC processors
    const EM_NDS32    = 167 #Andes Technology compact code size embedded RISC processor family
    const EM_ECOG1    = 168 #Cyan Technology eCOG1X family
    const EM_ECOG1X   = 168 #Cyan Technology eCOG1X family
    const EM_MAXQ30   = 169 #Dallas Semiconductor MAXQ30 Core Micro-controllers
    const EM_XIMO16   = 170 #New Japan Radio (NJR) 16-bit DSP Processor
    const EM_MANIK    = 171 #M2000 Reconfigurable RISC Microprocessor
    const EM_CRAYNV2  = 172 #Cray Inc. NV2 vector architecture
    const EM_RX   = 173 #Renesas RX family
    const EM_METAG    = 174 #Imagination Technologies META processor architecture
    const EM_MCST_ELBRUS  = 175 #MCST Elbrus general purpose hardware architecture
    const EM_ECOG16   = 176 #Cyan Technology eCOG16 family
    const EM_CR16 = 177 #National Semiconductor CompactRISC CR16 16-bit microprocessor
    const EM_ETPU = 178 #Freescale Extended Time Processing Unit
    const EM_SLE9X    = 179 #Infineon Technologies SLE9X core
    const EM_L10M = 180 #Intel L10M
    const EM_K10M = 181 #Intel K10M
    #182 Reserved for future Intel use
    const EM_AARCH64  = 183 #ARM 64-bit architecture (AARCH64)
    #184 Reserved for future ARM use
    const EM_AVR32    = 185 #Atmel Corporation 32-bit microprocessor family
    const EM_STM8 = 186 #STMicroeletronics STM8 8-bit microcontroller
    const EM_TILE64   = 187 #Tilera TILE64 multicore architecture family
    const EM_TILEPRO  = 188 #Tilera TILEPro multicore architecture family
    const EM_MICROBLAZE   = 189 #Xilinx MicroBlaze 32-bit RISC soft processor core
    const EM_CUDA = 190 #NVIDIA CUDA architecture
    const EM_TILEGX   = 191 #Tilera TILE-Gx multicore architecture family
    const EM_CLOUDSHIELD  = 192 #CloudShield architecture family
    const EM_COREA_1ST    = 193 #KIPO-KAIST Core-A 1st generation processor family
    const EM_COREA_2ND    = 194 #KIPO-KAIST Core-A 2nd generation processor family
    const EM_ARC_COMPACT2 = 195 #Synopsys ARCompact V2
    const EM_OPEN8    = 196 #Open8 8-bit RISC soft processor core
    const EM_RL78 = 197 #Renesas RL78 family
    const EM_VIDEOCORE5   = 198 #Broadcom VideoCore V processor
    const EM_78KOR    = 199 #Renesas 78KOR family
    const EM_56800EX  = 200 #Freescale 56800EX Digital Signal Controller (DSC)
    const EM_BA1  = 201 #Beyond BA1 CPU architecture
    const EM_BA2  = 202 #Beyond BA2 CPU architecture
    const EM_XCORE    = 203 #XMOS xCORE processor family
    const EM_MCHP_PIC = 204 #Microchip 8-bit PIC(r) family
    #205-209 Reserved
    const EM_KM32        = 210 #KM211 KM32
    const EM_KMX32       = 211 #KM211 KMX32
    const EM_EMX16       = 212 #KM211 KMX16
    const EM_EMX8        = 213 #KM211 KMX8
    const EM_KVARC       = 214 #KM211 KVARC
    const EM_CDP         = 215 #Paneve CDP
    const EM_COGE        = 216 #Cognitive Smart Memory Processor
    const EM_COOL        = 217 #Bluechip CoolEngine
    const EM_NORC        = 218 #Nanoradio Optimized RISC
    const EM_CSR_KALIMBA = 219 #CSR Kalimba
    const EM_Z80         = 220 #Zilog Z80
    const EM_VISIUM      = 221 #Controls and Data Services VISIUMcore
    const EM_FT32        = 222 #FTDI Chip FT32
    const EM_MOXIE       = 223 #Moxie processor
    const EM_AMDGPU      = 224 #AMD GPU
    #225-242 Reserved
    const EM_RISCV       = 243 #RISC-V
    const EM_BPF         = 247 #Linux BPF -- in-kernel virtual machine
end

# Special Section Indices
const SHN_UNDEF   = 0
const SHN_LORESERVE   = 0xff00
const SHN_LOPROC  = 0xff00
const SHN_HIPROC  = 0xff1f
const SHN_LOOS    = 0xff20
const SHN_HIOS    = 0xff3f
const SHN_ABS     = 0xfff1
const SHN_COMMON  = 0xfff2
const SHN_XINDEX  = 0xffff
const SHN_HIRESERVE   = 0xffff
 
# sh_type constants
@constants SHT_TYPES "SHT_" begin
    const SHT_NULL          =  0
    const SHT_PROGBITS      =  1
    const SHT_SYMTAB        =  2
    const SHT_STRTAB        =  3
    const SHT_RELA          =  4
    const SHT_HASH          =  5
    const SHT_DYNAMIC       =  6
    const SHT_NOTE          =  7
    const SHT_NOBITS        =  8
    const SHT_REL           =  9
    const SHT_SHLIB         = 10
    const SHT_DYNSYM        = 11
    const SHT_INIT_ARRAY    = 14
    const SHT_FINI_ARRAY    = 15
    const SHT_PREINIT_ARRAY = 16
    const SHT_GROUP         = 17
    const SHT_SYMTAB_SHNDX  = 18
end
@constants SHT_MASKS "SHT_" begin
    const SHT_LOOS          = 0x60000000
    const SHT_HIOS          = 0x6fffffff
    const SHT_LOPROC        = 0x70000000
    const SHT_HIPROC        = 0x7fffffff
    const SHT_LOUSER        = 0x80000000
    const SHT_HIUSER        = 0xffffffff
end

# Section Attribute Flags
@constants SHF_FLAGS "SHF_" begin
    const SHF_WRITE                 =   0x1
    const SHF_ALLOC                 =   0x2
    const SHF_EXECINSTR             =   0x4
    const SHF_MERGE                 =  0x10
    const SHF_STRINGS               =  0x20
    const SHF_INFO_LINK             =  0x40
    const SHF_LINK_ORDER            =  0x80
    const SHF_OS_NONCONFORMING      = 0x100
    const SHF_GROUP                 = 0x200
    const SHF_TLS                   = 0x400
end
@constants SHF_MASKS "SHF_" begin
    const SHF_MASKOS                = 0x0f000000
    const SHF_MASKPROC              = 0xf0000000
end

# Section Group Flags
const GRP_COMDAT  = 0x1
const GRP_MASKOS  = 0x0ff00000
const GRP_MASKPROC    = 0xf0000000
 
# Symbol Binding
const STB_LOCAL   = 0
const STB_GLOBAL  = 1
const STB_WEAK    = 2
const STB_LOOS    = 10
const STB_HIOS    = 12
const STB_LOPROC  = 13
const STB_HIPROC  = 15
 
# Symbol Types
const STT_NOTYPE  = 0
const STT_OBJECT  = 1
const STT_FUNC    = 2
const STT_SECTION = 3
const STT_FILE    = 4
const STT_COMMON  = 5
const STT_TLS = 6
const STT_LOOS    = 10
const STT_HIOS    = 12
const STT_LOPROC  = 13
const STT_HIPROC  = 15
 
# Symbol Visibility
const STV_DEFAULT = 0
const STV_INTERNAL    = 1
const STV_HIDDEN  = 2
const STV_PROTECTED   = 3
 
# ptype constants
@constants P_TYPE "PT_" begin
    const PT_NULL           = 0
    const PT_LOAD           = 1
    const PT_DYNAMIC        = 2
    const PT_INTERP         = 3
    const PT_NOTE           = 4
    const PT_SHLIB          = 5
    const PT_PHDR           = 6
    const PT_TLS            = 7
    const PT_LOOS           = 0x60000000
    const PT_GNU_EH_FRAME   = 0x6474e550
    const PT_GNU_STACK      = 0x6474e551
    const PT_GNU_RELRO      = 0x6474e552
    const PT_PAX_FLAGS      = 0x65041580
    const PT_HIOS           = 0x6fffffff
    const PT_LOPROC         = 0x70000000
    const PT_HIPROC         = 0x7fffffff
end
 
# p_flags constants
const PF_X    = 0x1 #Execute
const PF_W    = 0x2 #Write
const PF_R    = 0x4 #Read
const PF_MASKOS   = 0x0ff00000  #Unspecified
const PF_MASKPROC = 0xf0000000  #Unspecified
 
# X86_64 relocations
@constants R_X86_64 "" begin
    const R_X86_64_NONE              =   0
    const R_X86_64_64                =   1
    const R_X86_64_PC32              =   2
    const R_X86_64_GOT32             =   3
    const R_X86_64_PLT32             =   4
    const R_X86_64_COPY              =   5
    const R_X86_64_GLOB_DAT          =   6
    const R_X86_64_JUMP_SLOT         =   7
    const R_X86_64_RELATIVE          =   8
    const R_X86_64_GOTPCREL          =   9
    const R_X86_64_32                =  10
    const R_X86_64_32S               =  11
    const R_X86_64_16                =  12
    const R_X86_64_PC16              =  13
    const R_X86_64_8                 =  14
    const R_X86_64_PC8               =  15
    const R_X86_64_DTPMOD64          =  16
    const R_X86_64_DTPOFF64          =  17
    const R_X86_64_TPOFF64           =  18
    const R_X86_64_TLSGD             =  19
    const R_X86_64_TLSLD             =  20
    const R_X86_64_DTPOFF32          =  21
    const R_X86_64_GOTTPOFF          =  22
    const R_X86_64_TPOFF32           =  23
    const R_X86_64_PC64              =  24
    const R_X86_64_GOTOFF64          =  25
    const R_X86_64_GOTPC32           =  26
    const R_X86_64_GOT64             =  27
    const R_X86_64_GOTPCREL64        =  28
    const R_X86_64_GOTPC64           =  29
    const R_X86_64_GOTPLT64          =  30
    const R_X86_64_PLTOFF64          =  31
    const R_X86_64_SIZE32            =  32
    const R_X86_64_SIZE64            =  33
    const R_X86_64_GOTPC32_TLSDESC   =  34
    const R_X86_64_TLSDESC_CALL      =  35
    const R_X86_64_TLSDESC           =  36
    const R_X86_64_IRELATIVE         =  37
end

@constants AUXV_TYPE "AT_" begin
    const AT_NULL         = 0
    const AT_IGNORE       = 1
    const AT_EXECFD       = 2
    const AT_PHDR         = 3
    const AT_PHENT        = 4
    const AT_PHNUM        = 5
    const AT_PAGESZ       = 6
    const AT_BASE         = 7
    const AT_FLAGS        = 8
    const AT_ENTRY        = 9
    const AT_NOTELF       = 10
    const AT_UID          = 11
    const AT_EUID         = 12
    const AT_GID          = 13
    const AT_EGID         = 14
    const AT_PLATFORM     = 15
    const AT_HWCAP        = 16
    const AT_CLKTCK       = 17
    const AT_SYSINFO      = 32
    const AT_SYSINFO_EHDR = 33
end

@constants DYNAMIC_TYPE "DT_" begin
    const DT_NULL         = 0
    const DT_NEEDED       = 1
    const DT_PLTRELSZ     = 2
    const DT_PLTGOT       = 3
    const DT_HASH         = 4
    const DT_STRTAB       = 5
    const DT_SYMTAB       = 6
    const DT_RELA         = 7
    const DT_RELASZ       = 8
    const DT_RELAENT      = 9
    const DT_STRSZ        = 10
    const DT_SYMENT       = 11
    const DT_INIT         = 12
    const DT_FINI         = 13
    const DT_SONAME       = 14
    const DT_RPATH        = 15
    const DT_SYMBOLIC     = 16
    const DT_REL          = 17
    const DT_RELSZ        = 18
    const DT_RELENT       = 19
    const DT_PLTREL       = 20
    const DT_DEBUG        = 21
    const DT_TEXTREL      = 22
    const DT_JMPREL       = 23
    const DT_BIND_NOW     = 24
    const DT_INIT_ARRAY	  = 25
    const DT_FINI_ARRAY	  = 26
    const DT_INIT_ARRAYSZ =	27
    const DT_FINI_ARRAYSZ =	28
    const DT_RUNPATH	  = 29
    const DT_FLAGS	      = 30
    const DT_ENCODING     = 32
    const OLD_DT_LOOS     = 0x60000000
    const DT_LOOS         = 0x6000000d
    const DT_HIOS         = 0x6ffff000
    const DT_VALRNGLO     = 0x6ffffd00
    const DT_VALRNGHI     = 0x6ffffdff
    const DT_ADDRRNGLO    = 0x6ffffe00
    const DT_CONFIG       = 0x6ffffefa
    const DT_DEPAUDIT     = 0x6ffffefb
    const DT_AUDIT        = 0x6ffffefc
    const DT_ADDRRNGHI    = 0x6ffffeff
    const DT_VERSYM       = 0x6ffffff0
    const DT_RELACOUNT    = 0x6ffffff9
    const DT_RELCOUNT     = 0x6ffffffa
    const DT_FLAGS_1      = 0x6ffffffb
    const DT_VERDEF       = 0x6ffffffc
    const DT_VERDEFNUM    = 0x6ffffffd
    const DT_VERNEED      = 0x6ffffffe
    const DT_VERNEEDNUM   = 0x6fffffff
    const OLD_DT_HIOS     = 0x6fffffff
    const DT_LOPROC       = 0x70000000
    const DT_AUXILIARY   = 0x7ffffffd
    const DT_FILTER       = 0x7fffffff
end

# Include our abstract base classes for everything
include("ObjectHandle.jl")
include("Printing.jl")
include("Section.jl")
include("Segment.jl")
include("StrTab.jl")
include("Symbol.jl")
include("DynamicLink.jl")

# These are holdovers from ObjFileBase and friends that I haven't ported over yet
#include("Relocation.jl")
#include("Debug.jl")
#include("JIT.jl")

export ELFStrTab

"""
    ELFStrTab

ELF string table type, containing information about a `Section` that contains
a string table.  Note that an ELF file may contain multiple string tables, use
the different constructors to reference the different string tables.
"""
struct ELFStrTab{H <: ELFHandle} <: StrTab{H}
    section_ref::SectionRef{H}

    # Do a little bit of section checking
    function ELFStrTab{H}(section::ELFSectionRef{H}) where {H <: ELFHandle}
        # If this isn't actually a string table section, warn the user!
        if section_type(section) != SHT_STRTAB
            section_idx = section_number(section)
            msg = strip("""
            Loading Section $(section_idx) as a StrTab, despite it having section
            type $(section_type_string(section)), not SHT_STRTAB.
            """)
            @warn(replace(msg, "\n" => " "), key=(handle(section), section_idx))
        end
        
        return new(section)
    end
end

"""
    StrTab(section::SectionRef{ELFHandle})

Special short-cut constructor to build an `StrTab` directly from an ELF
`Section`, without attempting to automatically discover the correct section for
a string table.
"""
StrTab(section::ELFSectionRef{H}) where {H <: ELFHandle} = ELFStrTab{H}(section)

"""
    StrTab(oh::ELFHandle)

Given an ELF object, construct an `ELFStrTab` that refers to the section
header string table.
"""
function StrTab(oh::H) where {H <: ELFHandle}
    section_index = section_header_strtab_index(oh)
    strtab_section = Sections(oh)[section_index]
    return ELFStrTab{H}(strtab_section)
end

handle(strtab::ELFStrTab) = handle(strtab.section_ref)

"""
    section_header_strtab_index(oh::ELFHandle)

In an ELF object file, the section header string table is located within a
designated ELF `Section`, this method returns the index of that section.  This
is used by `StrTab(::ELFHandle)` to locate the correct `SectionRef` to
construct an `StrTab` object from.  The returned value is an index (e.g. it is
1-based, not zero-based as the value within the ELF object itself).
"""
function section_header_strtab_index(oh::ELFHandle)
    return header(oh).e_shstrndx + 1
end

function strtab_lookup(strtab::ELFStrTab, index)
    seek(strtab.section_ref, index)
    return strip(readuntil(handle(strtab), '\0'), '\0')
end

# Magic numbers
@constants MAGICS "" begin
    const MH_MAGIC = 0xfeedface
    const MH_CIGAM = bswap(MH_MAGIC)

    const MH_MAGIC_64 = 0xfeedfacf
    const MH_CIGAM_64 = bswap(MH_MAGIC_64)

    const FAT_MAGIC = 0xCAFEBABE
    const FAT_CIGAM = bswap(FAT_MAGIC)

    const FAT_MAGIC_64 = 0xCAFEBABF
    const FAT_CIGAM_64 = bswap(FAT_MAGIC_64)

    const FAT_MAGIC_METAL = 0xCBFEBABE
    const FAT_CIGAM_METAL = bswap(FAT_MAGIC_METAL)

    const METALLIB_MAGIC = 0x424c544d   # "MTLB" in ascii
end

const CPU_ARCH_MASK     = 0xff000000
const CPU_ARCH_ABI64    = 0x01000000
const CPU_ARCH_ABI64_32 = 0x02000000

@constants CPUTYPES "CPU_TYPE_" begin
    const CPU_TYPE_ANY          = reinterpret(UInt32,Int32(-1))
    const CPU_TYPE_VAX          = 1
    # skip
    # skip
    # skip
    # skip
    const CPU_TYPE_MC680x0      = 6
    const CPU_TYPE_X86          = 7
    const CPU_TYPE_X86_64       = CPU_TYPE_X86 | CPU_ARCH_ABI64
    const CPU_TYPE_MIPS         = 8
    # skip
    const CPU_TYPE_MC98000      = 10
    const CPU_TYPE_HPPA         = 11
    const CPU_TYPE_ARM          = 12
    const CPU_TYPE_MC88000      = 13
    const CPU_TYPE_SPARC        = 14
    const CPU_TYPE_I860         = 15
    const CPU_TYPE_ALPHA        = 16
    # skip
    const CPU_TYPE_POWERPC      = 18
    const CPU_TYPE_POWERPC64    = CPU_TYPE_POWERPC | CPU_ARCH_ABI64
    const CPU_TYPE_ARM64        = CPU_TYPE_ARM | CPU_ARCH_ABI64
    const CPU_TYPE_ARM64_32     = CPU_TYPE_ARM | CPU_ARCH_ABI64_32
end

function macho_cpu_to_arch(cputype::UInt32)
    if cputype ∈ (CPU_TYPE_X86,)
        return "i686"
    elseif cputype ∈ (CPU_TYPE_X86_64,)
        return "x86_64"
    elseif cputype ∈ (CPU_TYPE_ARM,)
        return "armv7l"
    elseif cputype ∈ (CPU_TYPE_POWERPC64,)
        return "ppc64le"
    elseif cputype ∈ (CPU_TYPE_ARM64,)
        return "aarch64"
    end
end


# TODO subtype constants
@constants NLISTTYPES "N_" begin
    const N_STAB         = 0xe0
    const N_PEXT         = 0x10
    const N_TYPE         = 0x0e
    const N_EXT          = 0x01
    const N_UNDF         = 0x00
    const N_ABS          = 0x02
    const N_SECT         = 0x0e
    const N_PBUD         = 0x0c
    const N_INDR         = 0x0a
end

@constants NDESC "N_" begin
    const N_WEAK_REF      = 0x0040
    const N_WEAK_DEF      = 0x0080
    const N_ARM_THUMB_DEF = 0x0008
end

const N_REF_TO_WEAK = N_WEAK_DEF

const NO_SECT  = 0x0
const MAX_SECT = 0xff

@constants FILETYPES "MH_" begin
    const MH_OBJECT      = 0x1     # relocatable object file
    const MH_EXECUTE     = 0x2     # demand paged executable file
    const MH_FVMLIB      = 0x3     # fixed VM shared library file
    const MH_CORE        = 0x4     # core file
    const MH_PRELOAD     = 0x5     # preloaded executable file
    const MH_DYLIB       = 0x6     # dynamically bound shared library
    const MH_DYLINKER    = 0x7     # dynamic link editor
    const MH_BUNDLE      = 0x8     # dynamically bound bundle file
    const MH_DYLIB_STUB  = 0x9     # shared library stub for static linking only
    const MH_DSYM        = 0xa     # companion file with only debug sections
    const MH_KEXT_BUNDLE = 0xb     # x86_64 kexts
end

# Constants for the flags field of the mach_header

@constants FLAGS "MH_" begin
    # the object file has no undefined references
    const MH_NOUNDEFS                   = 0x1
    # the object file is the output of an incremental link
    # against a base file and can't be link edited again
    const MH_INCRLINK                   = 0x2
    # the object file is input for the dynamic linker
    # and can't be staticly link edited again
    const MH_DYLDLINK                   = 0x4
    # the object file's undefined references are bound
    # by the dynamic linker when loaded
    const MH_BINDATLOAD                 = 0x8
    # the file has its dynamic undefined references prebound
    const MH_PREBOUND                   = 0x10
    # the file has its read-only and read-write segments split
    const MH_SPLIT_SEGS                 = 0x20
    # the shared library init routine is to be run
    # lazily via catching memory faults to its writeable segments
    # (obsolete)
    const MH_LAZY_INIT                  = 0x40
    # the image is using two-level name space bindings
    const MH_TWOLEVEL                   = 0x80
    # the executable is forcing all image to use flat
    # name space bindings
    const MH_FORCE_FLAT                 = 0x100
    # this umbrella guarantees no multiple defintions of
    # symbols in its sub-images so the two-level namespace
    # hints can always be used
    const MH_NOMULTIDEFS                = 0x100
    # do not have dyld notify the prebinding agent about this
    # executable
    const MH_NOFIXPREBINDING            = 0x200
    # the binary is not prebound but can have its prebinding
    # redone. only used when MH_PREBOUND is not set.
    const MH_PREBINDABLE                = 0x400
    # indicates that this binary binds to all two-level
    # namespace modules of its dependent libraries.
    # only used when MH_PREBINDABLE and MH_TWOLEVEL are both set
    const MH_ALLMODSBOUND               = 0x800
    # safe to divide up the sections into sub-sections
    # via symbols for dead code stripping
    const MH_SUBSECTIONS_VIA_SYMBOLS    = 0x1000
    const MH_CANONICAL                  = 0x2000
    const MH_WEAK_DEFINES               = 0x4000
    const MH_BINDS_TO_WEAK              = 0x8000
    const MH_ALLOW_STACK_EXECUTION      = 0x10000
    const MH_ROOT_SAFE                  = 0x20000
    const MH_SETUID_SAFE                = 0x40000
    const MH_NO_REEXPORTED_DYLIBS       = 0x80000
    const MH_PIE                        = 0x100000
    const MH_DEAD_STRIPPABLE_DYLIB      = 0x200000
    const MH_HAS_TLV_DESCRIPTORS        = 0x400000
    const MH_NO_HEAP_EXECUTION          = 0x800000
end


# Load command types.  Note that we have dropped the LC_REQ_DYLD flag OR'ed
# into many of these types to aid in easy usage of these constants.  Since
# the meaning of LC_REQ_DYLD is to denote to the linker which load commands
# cannot be safely ignored when loading, this does not affect us much, and
# we disregard it entirely.

const LC_REQ_DYLD = 0x80000000
@constants LCTYPES "LC_" begin
    const LC_SEGMENT            = 0x1   # segment of this file to be mapped
    const LC_SYMTAB             = 0x2   # link-edit stab symbol table info
    const LC_SYMSEG             = 0x3   # link-edit gdb symbol table info (obsolete)
    const LC_THREAD             = 0x4   # thread
    const LC_UNIXTHREAD         = 0x5   # unix thread (includes a stack)
    const LC_LOADFVMLIB         = 0x6   # load a specified fixed VM shared library
    const LC_IDFVMLIB           = 0x7   # fixed VM shared library identification
    const LC_IDENT              = 0x8   # object identification info (obsolete)
    const LC_FVMFILE            = 0x9   # fixed VM file inclusion (internal use)
    const LC_PREPAGE            = 0xa   # prepage command (internal use)
    const LC_DYSYMTAB           = 0xb   # dynamic link-edit symbol table info
    const LC_LOAD_DYLIB         = 0xc   # load a dynamically linked shared library
    const LC_ID_DYLIB           = 0xd   # dynamically linked shared lib ident
    const LC_LOAD_DYLINKER      = 0xe   # load a dynamic linker
    const LC_ID_DYLINKER        = 0xf   # dynamic linker identification
    const LC_PREBOUND_DYLIB     = 0x10  # modules prebound for a dynamically linked shared library
    const LC_ROUTINES           = 0x11  # image routines
    const LC_SUB_FRAMEWORK      = 0x12  # sub framework
    const LC_SUB_UMBRELLA       = 0x13  # sub umbrella
    const LC_SUB_CLIENT         = 0x14  # sub client
    const LC_SUB_LIBRARY        = 0x15  # sub library
    const LC_TWOLEVEL_HINTS     = 0x16  # two-level namespace lookup hints
    const LC_PREBIND_CKSUM      = 0x17  # prebind checksum
    #
    # load a dynamically linked shared library that is allowed to be missing
    # (all symbols are weak imported).
    #
    const LC_LOAD_WEAK_DYLIB        = 0x18
    const LC_SEGMENT_64             = 0x19 # 64-bit segment of this file to be mapped
    const LC_ROUTINES_64            = 0x1a # 64-bit image routines
    const LC_UUID                   = 0x1b # the uuid
    const LC_RPATH                  = 0x1c # runpath additions
    const LC_CODE_SIGNATURE         = 0x1d # local of code signature
    const LC_SEGMENT_SPLIT_INFO     = 0x1e # local of info to split segments
    const LC_REEXPORT_DYLIB         = 0x1f # load and re-export dylib
    const LC_LAZY_LOAD_DYLIB        = 0x20 # delay load of dylib until first use
    const LC_ENCRYPTION_INFO        = 0x21 # encrypted segment information
    const LC_DYLD_INFO              = 0x22 # compressed dyld information
    const LC_DYLD_INFO_ONLY         = 0x22 # compressed dyld information only
    const LC_LOAD_UPWARD_DYLIB      = 0x23 # load upward dylib
    const LC_VERSION_MIN_MACOSX     = 0x24 # build for MacOSX min OS version
    const LC_VERSION_MIN_IPHONEOS   = 0x25 # build for iPhoneOS min OS version
    const LC_FUNCTION_STARTS        = 0x26 # compressed table of function start addresses
    const LC_DYLD_ENVIRONMENT       = 0x27 # string for dyld to treat like environment variable
    const LC_MAIN                   = 0x28 # replacement for LC_UNIXTHREAD
    const LC_DATA_IN_CODE           = 0x29 # table of non-instructions in __text
    const LC_SOURCE_VERSION         = 0x2A # source version used to build binary
    const LC_DYLIB_CODE_SIGN_DRS    = 0x2B # Code signing DRs copied from linked dylibs
    const LC_ENCRYPTION_INFO_64     = 0x2C # 64-bit encrypted segment information
    const LC_LINKER_OPTION          = 0x2D # linker options in MH_OBJECT files

end


const SECTION_TYPE          = 0x000000ff # 256 section types
const SECTION_ATTRIBUTES    = 0xffffff00 # 24 section attributes

@constants SECTYPES "" begin
    # regular section
    const S_REGULAR                                 = 0x0
    # zero fill on demand section
    const S_ZEROFILL                                = 0x1
    # section with only literal C string
    const S_CSTRING_LITERALS                        = 0x2
    # section with only 4 byte literals
    const S_4BYTE_LITERALS                          = 0x3
    # section with only 8 byte literals
    const S_8BYTE_LITERALS                          = 0x4
    # section with only pointers to literals
    const S_LITERAL_POINTERS                        = 0x5
#
#  For the two types of symbol pointers sections and the symbol stubs section
#  they have indirect symbol table entries.  For each of the entries in the
#  section the indirect symbol table entries, in corresponding order in the
#  indirect symbol table, start at the index stored in the reserved1 field
#  of the section structure.  Since the indirect symbol table entries
#  correspond to the entries in the section the number of indirect symbol table
#  entries is inferred from the size of the section divided by the size of the
#  entries in the section.  For symbol pointers sections the size of the entries
#  in the section is 4 bytes and for symbol stubs sections the byte size of the
#  stubs is stored in the reserved2 field of the section structure.

    # section with only non-lazy symbol pointers
    const S_NON_LAZY_SYMBOL_POINTERS                = 0x6
    # section with only lazy symbol
    const S_LAZY_SYMBOL_POINTERS                    = 0x7
    # section with only symbol stubs, byte
    # size of stub in the reserved2 field
    const S_SYMBOL_STUBS                            = 0x8
    # section with only function pointers
    # for initialization
    const S_MOD_INIT_FUNC_POINTERS                  = 0x9
    # section with only function pointers
    # for initialization
    const S_MOD_TERM_FUNC_POINTERS                  = 0xa
    # section contains symbols that
    # are to be coalesced
    const S_COALESCED                               = 0xb
    # zero fill on demand section
    # (that can be larger than 4 gigabytes)
    const S_GB_ZEROFILL                             = 0xc
    # section with only pairs of function
    # pointers for interposing
    const S_INTERPOSING                             = 0xd
    # section with only 16 byte literals
    const S_16BYTE_LITERALS                         = 0xe
    # section contains DTrace Object Format
    const S_DTRACE_DOF                              = 0xf
    # section with only lazy symbol pointers
    # to lazy loaded dylibs
    const S_LAZY_DYLIB_SYMBOL_POINTERS              = 0x10
    # template of initial values for TLVs
    const S_THREAD_LOCAL_REGULAR                    = 0x11
    # template of initial values for TLVs
    const S_THREAD_LOCAL_ZEROFILL                   = 0x12
    # TLV descriptors
    const S_THREAD_LOCAL_VARIABLES                  = 0x13
    # pointers to TLV descriptors
    const S_THREAD_LOCAL_VARIABLE_POINTERS          = 0x14
    # functions to call to initialize TLV values
    const S_THREAD_LOCAL_INIT_FUNCTION_POINTERS     = 0x15
end

const SECTION_ATTRIBUTES_USR = 0xff000000
const SECTION_ATTRIBUTES_SYS = 0x00ffff00

@constants SECATTRS "S_ATTR_" begin
    # section contains only true machine instructions
    const S_ATTR_PURE_INSTRUCTIONS      = 0x80000000
    # section contains coalesced symbols that are not to be
    # in a ranlib table of contents
    const S_ATTR_NO_TOC                 = 0x40000000
    # ok to strip static symbols in this section in files
    # with the MH_DYLDLINK flag
    const S_ATTR_STRIP_STATIC_SYMS      = 0x20000000
    # no dead stripping
    const S_ATTR_NO_DEAD_STRIP          = 0x10000000
    # blocks are live if they reference live blocks
    const S_ATTR_LIVE_SUPPORT           = 0x08000000
    # Used with i386 code stubs written on by dyld
    const S_ATTR_SELF_MODIFYING_CODE    = 0x04000000
    # a debug section
    const S_ATTR_DEBUG                  = 0x02000000
    # section contains some machine instructions
    const S_ATTR_SOME_INSTRUCTIONS      = 0x00000400
    # section has external relocation entries
    const S_ATTR_EXT_RELOC              = 0x00000200
    # section has local relocation entries
    const S_ATTR_LOC_RELOC              = 0x00000100
end

@constants UNWIND_FLAGS "UNWIND_" begin
    const UNWIND_IS_NOT_FUNCTION_START  = 0x80000000
    const UNWIND_HAS_LSDA               = 0x40000000
    const UNWIND_PERSONALITY_MASK       = 0x30000000
end

@constants UNWIND_X86 "UNWIND_X86_" begin
    const UNWIND_X86_MODE_MASK                          = 0x0F000000
    const UNWIND_X86_MODE_EBP_FRAME                     = 0x01000000
    const UNWIND_X86_MODE_STACK_IMMD                    = 0x02000000
    const UNWIND_X86_MODE_STACK_IND                     = 0x03000000
    const UNWIND_X86_MODE_DWARF                         = 0x04000000

    const UNWIND_X86_EBP_FRAME_REGISTERS                = 0x00007FFF
    const UNWIND_X86_EBP_FRAME_OFFSET                   = 0x00FF0000

    const UNWIND_X86_FRAMELESS_STACK_SIZE               = 0x00FF0000
    const UNWIND_X86_FRAMELESS_STACK_ADJUST             = 0x0000E000
    const UNWIND_X86_FRAMELESS_STACK_REG_COUNT          = 0x00001C00
    const UNWIND_X86_FRAMELESS_STACK_REG_PERMUTATION    = 0x000003FF

    const UNWIND_X86_DWARF_SECTION_OFFSET               = 0x00FFFFFF
end

@constants UNWIND_X86_REGS "UNWIND_X86_REG_" begin
    const UNWIND_X86_REG_NONE   = 0
    const UNWIND_X86_REG_EBX    = 1
    const UNWIND_X86_REG_ECX    = 2
    const UNWIND_X86_REG_EDX    = 3
    const UNWIND_X86_REG_EDI    = 4
    const UNWIND_X86_REG_ESI    = 5
    const UNWIND_X86_REG_EBP    = 6
end

@constants UNWIND_X86_64 "UNWIND_X86_64_" begin
    const UNWIND_X86_64_MODE_MASK                          = 0x0F000000
    const UNWIND_X86_64_MODE_EBP_FRAME                     = 0x01000000
    const UNWIND_X86_64_MODE_STACK_IMMD                    = 0x02000000
    const UNWIND_X86_64_MODE_STACK_IND                     = 0x03000000
    const UNWIND_X86_64_MODE_DWARF                         = 0x04000000

    const UNWIND_X86_64_EBP_FRAME_REGISTERS                = 0x00007FFF
    const UNWIND_X86_64_EBP_FRAME_OFFSET                   = 0x00FF0000

    const UNWIND_X86_64_FRAMELESS_STACK_SIZE               = 0x00FF0000
    const UNWIND_X86_64_FRAMELESS_STACK_ADJUST             = 0x0000E000
    const UNWIND_X86_64_FRAMELESS_STACK_REG_COUNT          = 0x00001C00
    const UNWIND_X86_64_FRAMELESS_STACK_REG_PERMUTATION    = 0x000003FF

    const UNWIND_X86_64_DWARF_SECTION_OFFSET               = 0x00FFFFFF
end

@constants UNWIND_X86_64_REGS "UNWIND_X86_64_REG_" begin
    const UNWIND_X86_64_REG_NONE    = 0
    const UNWIND_X86_64_REG_RBX     = 1
    const UNWIND_X86_64_REG_R12     = 2
    const UNWIND_X86_64_REG_R13     = 3
    const UNWIND_X86_64_REG_R14     = 4
    const UNWIND_X86_64_REG_R15     = 5
    const UNWIND_X86_64_REG_RBP     = 6
end

@constants UNWIND_SECOND_LEVEL "UNWIND_SECOND_LEVEL_" begin
    const UNWIND_SECOND_LEVEL_REGULAR       = 2
    const UNWIND_SECOND_LEVEL_COMPRESSED    = 3
end

@constants X86_64_RELOC "X86_64_RELOC_" begin
    const X86_64_RELOC_UNSIGNED        = 0
    const X86_64_RELOC_SIGNED          = 1
    const X86_64_RELOC_BRANCH          = 2
    const X86_64_RELOC_GOT_LOAD        = 3
    const X86_64_RELOC_GOT             = 4
    const X86_64_RELOC_SUBTRACTOR      = 5
    const X86_64_RELOC_SIGNED_1        = 6
    const X86_64_RELOC_SIGNED_2        = 7
    const X86_64_RELOC_SIGNED_4        = 8
    const X86_64_RELOC_TLV             = 9
end

@constants X86_THREAD_FLAVORS "" begin
    const x86_THREAD_STATE32    = 1
    const x86_FLOAT_STATE32     = 2
    const x86_EXCEPTION_STATE32 = 3
    const x86_THREAD_STATE64    = 4
    const x86_FLOAT_STATE64     = 5
    const x86_EXCEPTION_STATE64 = 6
    const x86_THREAD_STATE      = 7
    const x86_FLOAT_STATE       = 8
    const x86_EXCEPTION_STATE   = 9
    const x86_DEBUG_STATE32     = 10
    const x86_DEBUG_STATE64     = 11
    const x86_DEBUG_STATE       = 12
end

# Export datatypes
export ELFDynEntry, ELFDynEntry32, ELFDynEntry64, ELFDynEntryRef, ELFDynEntries

# Export methods
export dyn_entry_type, dyn_entry_is_string, dyn_entry_type_string

import Base: show

"""
    ELFDynEntry

ELF Dynamic table entry type.  This is comprised by a `d_tag` member and a
`d_val` member; the `d_tag` tells what kind of command this is to the dynamic
linker (e.g. `DT_NEEDED` denotes a shared library that must be loaded for this
ELF object to link properly), whereas `d_val` is a pointer to another data
structure that contains more information.  (E.g. for a `DT_NEEDED` entry,
`d_val` would represent an offset within the dynamic string table)
"""
abstract type ELFDynEntry{H <: ELFHandle} end

@io struct ELFDynEntry32{H <: ELFHandle} <: ELFDynEntry{H}
    d_tag::UInt32
    # We drop the `d_un` union, and use only `d_val`, omitting `d_ptr`.
    d_val::UInt32
end

@io struct ELFDynEntry64{H <: ELFHandle} <: ELFDynEntry{H}
    d_tag::UInt64
    # We drop the `d_un` union, and use only `d_val`, omitting `d_ptr`.
    d_val::UInt64
end

"""
    dyn_entry_type(d::ELFDynEntry)

Return the type of the given `ELFDynEntry`
"""
dyn_entry_type(d::ELFDynEntry) = d.d_tag

"""
    dyn_entry_is_string(d::ELFDynEntry)

Return `true` if the given `ELFDynEntry` represents an offset within the
dynamic string table, and therefore can be used in a `strtab_lookup()`
"""
function dyn_entry_is_string(d::ELFDynEntry)
    string_types = [
        DT_NEEDED,
        DT_SONAME,
        DT_RPATH,
        DT_RUNPATH,
        DT_AUXILIARY,
        DT_FILTER,
        DT_CONFIG,
        DT_DEPAUDIT,
        DT_AUDIT
    ]
    return dyn_entry_type(d) in string_types
end

"""
    dyn_entry_type_string(d::ELFDynEntry)

Return the given `ELFDynEntry`'s type as a string.
"""
function dyn_entry_type_string(d::ELFDynEntry)
    global DYNAMIC_TYPE

    d_type = dyn_entry_type(d)
    if haskey(DYNAMIC_TYPE, d_type)
        return DYNAMIC_TYPE[d_type]
    end
    return string("Unknown DynEntry Type (0x", string(d_type, base=16), ")")
end

struct ELFDynEntryRef{H <: ELFHandle}
    section_ref::SectionRef{H}
    entry::ELFDynEntry{H}
end

Section(d::ELFDynEntryRef) = d.section_ref
handle(d::ELFDynEntryRef) = handle(Section(d))
deref(d::ELFDynEntryRef) = d.entry
@derefmethod dyn_entry_type(d::ELFDynEntryRef)
@derefmethod dyn_entry_is_string(d::ELFDynEntryRef)
strtab_lookup(d::ELFDynEntryRef) = strtab_lookup(StrTab(d), deref(d).d_val)


function show(io::IO, d::DT) where {DT <: ELFDynEntry}
    print(io, "ELFDynEntry", DT <: ELFDynEntry64 ? " (64 bit)" : "")
    print(io, " $(dyn_entry_type_string(d))")
end

function show(io::IO, d::ELFDynEntryRef)
    show(io, deref(d))
    if dyn_entry_is_string(d)
        print(io, ", \"$(strtab_lookup(d))\"")
    end
end

"""
    StrTab(d::ELFDynEntryRef)

Given an `ELFDynEntryRef`, construct an `ELFStrTab` that refers to the
associated dynamic string table.
"""
function StrTab(d::ELFDynEntryRef{H}) where {H <: ObjectHandle}
    # The `sh_link` field in a ".dynamic" section always points to the
    # dynamic string table (usually called ".dynstr")
    section_idx = deref(Section(d)).sh_link+1
    strtab_section = Sections(handle(d))[section_idx]
    return ELFStrTab{H}(strtab_section)
end


"""
    ELFDynEntries(oh::ELFHandle)

Read all `ELFDynEntry` objects from an ELF object, returning them as an array.
"""
function ELFDynEntries(oh::ELFHandle)
    dyn_section = findfirst(Sections(oh), ".dynamic")

    # Figure out what kind of DynEntry objects we're going to read in
    DT = dyn_entry_type(oh)

    # Seek to the proper spot, and read 'em in until we reach a DT_NULL
    seekstart(dyn_section)
    dts = [ELFDynEntryRef(dyn_section, unpack(oh, DT))]

    while dyn_entry_type(dts[end]) != DT_NULL
        push!(dts, ELFDynEntryRef(dyn_section, unpack(oh, DT)))
    end
    
    return dts
end

"""
    ELFDynEntries(oh::ELFHandle, kinds::Vector)

Read all `ELFDynEntry` objects from an ELF object, returning them as an array
if they are one of the `kinds` passed in, such as `DT_NEEDED`.
"""
function ELFDynEntries(oh::ELFHandle, kinds::Vector)
    return [d for d in ELFDynEntries(oh) if dyn_entry_type(d) in kinds]
end

export MachOSegmentCmd, MachOSegment32Cmd, MachOSegment64Cmd

export segment_name, segment_offset, segment_file_size, segment_memory_size,
       segment_num_sections

"""
    MachOSegmentCmd

Mach-O Segment load command type, containing information about the virtual
memory layout of a chunk of the program.  This type is very MachO-specific, so
it is not comparable to other object file formats directly.  However, note that
this data structure is the gateway through which the file sections are
accessed, and while there is a convenience `Sections(::MachOHandle)` method
that will abstract all that away for you, you can also directly call
`Sections(::MachOLoadCmdRef{MachOSegmentCmd})` to get the sections belonging to
the given segment.  Note that the `Sections` call works only upon a
`MachOLoadCmdRef{MachOSegmentCmd}`, it will not work on the `MachOSegmentCmd`
itself directly.

### Creation:
  - MachOSegmentCmd()

### Format-specific properties:
  - segment_name()
  - segment_offset()
  - segment_file_size()
  - segment_memory_size()
  - segment_num_sections()
"""
abstract type MachOSegmentCmd{H <: MachOHandle} <: MachOLoadCmd{H} end 
@io struct MachOSegment32Cmd{H <: MachOHandle} <: MachOSegmentCmd{H}
    segname::fixed_string{UInt128}
    vmaddr::UInt32
    vmsize::UInt32
    fileoff::UInt32
    filesize::UInt32
    maxprot::UInt32
    initprot::UInt32
    nsects::UInt32
    flags::UInt32
end

@io struct MachOSegment64Cmd{H <: MachOHandle} <: MachOSegmentCmd{H}
    segname::fixed_string{UInt128}
    vmaddr::UInt64
    vmsize::UInt64
    fileoff::UInt64
    filesize::UInt64
    maxprot::UInt32
    initprot::UInt32
    nsects::UInt32
    flags::UInt32
end

show(io::IO, lc::MachOSegment32Cmd) = write(io, "Segment32Cmd \"$(segment_name(lc))\"")
show(io::IO, lc::MachOSegment64Cmd) = write(io, "Segment64Cmd \"$(segment_name(lc))\"")

segment_name(cmd::MachOSegmentCmd) = cmd.segname
segment_offset(cmd::MachOSegmentCmd) = cmd.fileoff
segment_file_size(cmd::MachOSegmentCmd) = cmd.filesize
segment_memory_size(cmd::MachOSegmentCmd) = cmd.vmsize
segment_num_sections(cmd::MachOSegmentCmd) = cmd.nsects

@derefmethod segment_name(cmd::MachOLoadCmdRef{H,S}) where {H <: MachOHandle} where {S <: MachOSegmentCmd}
@derefmethod segment_offset(cmd::MachOLoadCmdRef{H,S}) where {H <: MachOHandle} where {S <: MachOSegmentCmd}
@derefmethod segment_file_size(cmd::MachOLoadCmdRef{H,S}) where {H <: MachOHandle} where {S <: MachOSegmentCmd}
@derefmethod segment_memory_size(cmd::MachOLoadCmdRef{H,S}) where {H <: MachOHandle} where {S <: MachOSegmentCmd}
@derefmethod segment_num_sections(cmd::MachOLoadCmdRef{H,S}) where {H <: MachOHandle} where {S <: MachOSegmentCmd}

import Base: unsafe_string, show, print, isempty, length, *, ==, unsafe_string
export fixed_string
using StructIO

## Here we define various string-related utilities for MachO and COFF files
"""
    fixed_string{T}

A fixed-byte string, stored as an integer type (e.g. `T` = `UInt128`, or `T` =
`UInt64`) but displayed and treated as a string.
"""
@io struct fixed_string{T <: Integer}
    data::T
end


"""
    unsafe_string(x::fixed_string)

Convert a `fixed_string` object to a native-Julia `String`
"""
function unsafe_string(x::fixed_string{T}) where {T <: Integer}
    data_array = reinterpret(UInt8, [x.data])
    zero_idx = findfirst(isequal(0x00), data_array)
    if zero_idx === nothing
        zero_idx = sizeof(T) + 1
    end

    str = String(data_array[1:zero_idx-1])
    if !isvalid(str)
        return "$(zero_idx)-byte String of invalid UTF-8 data"
    end
    return str
end

## Various overrides for `fixed_string` that make it act like a `String`
show(io::IO, x::fixed_string) = show(io, unsafe_string(x))
print(io::IO, x::fixed_string) = print(io, unsafe_string(x))
isempty(x::fixed_string) = (x.data & 0xff) == 0
function length(x::fixed_string{T}) where {T <: Integer}
    for idx in 0:(sizeof(T)-1)
        if (x.data & (0xff << (idx*8))) == 0
            return idx
        end
    end
    return sizeof(T)
end

==(x::fixed_string, y::AbstractString) = unsafe_string(x) == y
==(x::AbstractString, y::fixed_string) = y==x
*(a::String, b::fixed_string) = a*unsafe_string(b)
*(a::fixed_string, b::String) = unsafe_string(a)*b



"""
    unsafe_string(io, max_len::Integer)

Read in a null-terminated string, stopping with a maximum length of `max_len`.
"""
function unsafe_string(io, max_len::T) where {T <: Integer}
    str = UInt8[]
    idx = 0
    c = read(io, UInt8)
    while c != 0x00 && idx < max_len
        push!(str, c)
        c = read(io, UInt8)
        idx += 1
    end
    return String(str)
end

export COFFOptionalHeaderStandard, COFFImageDataDirectory, COFFDataDirectories,
       COFFOptionalHeaderWindows32, COFFOptionalHeaderWindows64,
       COFFOptionalHeader32, COFFOptionalHeader64

@io struct COFFOptionalHeaderStandard
    Magic::UInt16
    MajorLinkerVersion::UInt8
    MinorLinkerVersion::UInt8
    SizeOfCode::UInt32
    SizeOfInitializedData::UInt32
    SizeOfUninitializedData::UInt32
    AddressOfEntryPoint::UInt32
    BaseOfCode::UInt32
end
const OPTHEADER_STANDARD_MAGIC32 = 0x10b
const OPTHEADER_STANDARD_MAGIC64 = 0x20b

@io struct COFFImageDataDirectory
    VirtualAddress::UInt32
    Size::UInt32
end

@io struct COFFDataDirectories
    ExportTable::COFFImageDataDirectory
    ImportTable::COFFImageDataDirectory
    ResourceTable::COFFImageDataDirectory
    ExceptionTable::COFFImageDataDirectory
    CertificateTable::COFFImageDataDirectory
    BaseRelocatioNTable::COFFImageDataDirectory
    Debug::COFFImageDataDirectory
    Architecture::COFFImageDataDirectory
    GlobalPtr::COFFImageDataDirectory
    TLSTable::COFFImageDataDirectory
    LoadConfigTable::COFFImageDataDirectory
    BoundImport::COFFImageDataDirectory
    IAT::COFFImageDataDirectory
    DelayImportDescriptor::COFFImageDataDirectory
    CLRRuntimeHeader::COFFImageDataDirectory
    Reserverd::COFFImageDataDirectory
end

@io struct COFFOptionalHeaderWindows32
    ImageBase::UInt32
    SectionAlignment::UInt32
    FileAlignment::UInt32
    MajorOperatingSystemVersion::UInt16
    MinorOperatingSystemVersion::UInt16
    MajorImageVersion::UInt16
    MinorImageVersion::UInt16
    MajorSubsystemVersion::UInt16
    MinorSubsystemVersion::UInt16
    Win32VersionValue::UInt32
    SizeOfImage::UInt32
    SizeOfHeaders::UInt32
    CheckSum::UInt32
    Subsystem::UInt16
    DllCharacteristics::UInt16
    SizeOfStackReserve::UInt32
    SizeOfStackCommit::UInt32
    SizeOfHeapReserve::UInt32
    SizeOfHeapCommit::UInt32
    LoaderFlag::UInt32
    NumberOfRvaAndSizes::UInt32
end

@io struct COFFOptionalHeaderWindows64
    ImageBase::UInt64
    SectionAlignment::UInt32
    FileAlignment::UInt32
    MajorOperatingSystemVersion::UInt16
    MinorOperatingSystemVersion::UInt16
    MajorImageVersion::UInt16
    MinorImageVersion::UInt16
    MajorSubsystemVersion::UInt16
    MinorSubsystemVersion::UInt16
    Win32VersionValue::UInt32
    SizeOfImage::UInt32
    SizeOfHeaders::UInt32
    CheckSum::UInt32
    Subsystem::UInt16
    DllCharacteristics::UInt16
    SizeOfStackReserve::UInt64
    SizeOfStackCommit::UInt64
    SizeOfHeapReserve::UInt64
    SizeOfHeapCommit::UInt64
    LoaderFlag::UInt32
    NumberOfRvaAndSizes::UInt32
end

abstract type COFFOptionalHeader end
@io struct COFFOptionalHeader32 <: COFFOptionalHeader
    standard::COFFOptionalHeaderStandard
    BaseOfData::UInt32
    windows::COFFOptionalHeaderWindows32
    directories::COFFDataDirectories
end

@io struct COFFOptionalHeader64 <: COFFOptionalHeader
    standard::COFFOptionalHeaderStandard
    windows::COFFOptionalHeaderWindows64
    directories::COFFDataDirectories
end

function read(io::IO, ::Type{COFFOptionalHeader})
    # First, unpack the standard bits
    standard = unpack(io, COFFOptionalHeaderStandard)

    # If it's a 32-bit header, read that out, otherwise, do the 64-bit dance
    if standard.Magic == OPTHEADER_STANDARD_MAGIC32
        BaseOfData = read(io, UInt32)
        windows = unpack(io, COFFOptionalHeaderWindows32)
        dirs = unpack(io, COFFDataDirectories)
        return COFFOptionalHeader32(standard, BaseOfData, windows, dirs)
    elseif standard.Magic == OPTHEADER_STANDARD_MAGIC64
        windows = unpack(io, COFFOptionalHeaderWindows64)
        dirs = unpack(io, COFFDataDirectories)
        return COFFOptionalHeader64(standard, windows, dirs)
    else
        error("Unknown COFF optional header magic 0x$(string(standard.Magic, base=16))")
    end
end

export COFFStrTab

"""
    COFFStrTab

COFF `StrTab` type, containing the metadata necessary to perform string table
lookups, via the `strtab_lookup()` method.
"""
struct COFFStrTab{H <: COFFHandle} <: StrTab{H}
    handle::COFFHandle
    offset::UInt32
end

StrTab(oh::H) where {H <: COFFHandle} = COFFStrTab{H}(oh, UInt32(strtab_offset(oh)))
handle(oh::COFFStrTab) = oh.handle

function strtab_lookup(strtab::COFFStrTab, index)
    seek(handle(strtab), strtab.offset + index)
    return strip(readuntil(handle(strtab), '\0'), '\0')
end

export COFFDynamicLinks, COFFDynamicLink, COFFRPath

struct COFFDynamicLink{H <: COFFHandle} <: DynamicLink{H}
    path::String
end
path(dl::COFFDynamicLink) = dl.path


@io struct COFFImageImportDescriptor
    Characteristics::UInt32
    TimeDateStamp::UInt32
    ForwarderChain::UInt32
    Name::UInt32
    FirstThunk::UInt32
end

struct COFFDynamicLinks{H <: COFFHandle} <: DynamicLinks{H}
    handle::H
    links::Vector
end

function import_name(oh::COFFHandle, idata::COFFSectionRef, iid)
    seek(oh, iid.Name - section_address(idata) + section_offset(idata))
    return strip(readuntil(oh, '\0'), '\0')
end

function find_section_for_rva(oh::H, rva) where {H <: COFFHandle}
    for s in Sections(oh)
        if section_address(s) <= rva && section_address(s) + section_size(s) > rva
            return s
        end
    end
    error("Unable to find section for RVA $(repr(rva))")
end

function COFFDynamicLinks(oh::H) where {H <: COFFHandle}
    # Start by finding the virtual address of the import table
    import_table_rva = oh.opt_header.directories.ImportTable.VirtualAddress

    # Next figure out which section that belongs to:
    s = find_section_for_rva(oh, import_table_rva)

    # We'll load in all the ImageImportDescriptors we can
    iids = COFFImageImportDescriptor[]

    # Read in ImageImportDescriptors until it's all NULL
    seek(oh, (import_table_rva - section_address(s)) +  section_offset(s))
    while true
        iid = unpack(oh, COFFImageImportDescriptor)
        if iid.Name == 0 && iid.FirstThunk == 0 && iid.Characteristics == 0 && iid.ForwarderChain == 0 && iid.TimeDateStamp == 0
            break
        else
            push!(iids, iid)
        end
    end

    # Now, jump around and get all the strings
    links = [COFFDynamicLink{H}(import_name(oh, s, iid)) for iid in iids]
    return COFFDynamicLinks(oh, links)
end
DynamicLinks(oh::COFFHandle) = COFFDynamicLinks(oh)

handle(dls::COFFDynamicLinks) = dls.handle
lastindex(dls::COFFDynamicLinks) = lastindex(dls.links)
getindex(dls::COFFDynamicLinks, idx) = getindex(dls.links, idx)


"""
    COFFRPath

COFF RPath object; note that while COFF files do not have an RPath within them,
they _do_ seach the same directory as the loading binary (e.g. the `\$ORIGIN`).
We use `COFFRPath` to effect this, although strictly speaking there is no such
thing as a "COFF RPath".
"""
struct COFFRPath{H <: COFFHandle} <: RPath{H}
    handle::H
end

RPath(oh::COFFHandle) = COFFRPath(oh)
handle(crp::COFFRPath) = crp.handle
rpaths(crp::COFFRPath) = String[]

# COFF files don't have an RPath, but they _do_ always search the $ORIGIN
function canonical_rpaths(crp::COFFRPath)
    return [abspath(dirname(path(handle(crp))) * "/")]
end

# Export StrTab API
export StrTab,
       handle, strtab_lookup

"""
    StrTab

This type encapsulates a string table within an object file, enabling queries
against the string table for symbol names, section names, etc... The list of
available API operations is given below, with methods that subclasses must
implement marked in emphasis:

### Creation
  - *StrTab()*

### Accessors
  - *handle()*
  - *strtab_lookup()*
"""
abstract type StrTab{H <: ObjectHandle} end


"""
    handle(s::StrTab)

Return the `ObjectHandle` this `StrTab` belongs to.
"""
@mustimplement handle(strtab::StrTab)

"""
    strtab_lookup(s::StrTab, index)

Reads a string from the given `StrTab` at `index`.
"""
@mustimplement strtab_lookup(s::StrTab, index)

module MachO

using StructIO, Base.BinaryPlatforms
import Base.BinaryPlatforms: Platform

# Bring in ObjectFile definitions
using ObjectFile
import ObjectFile: DynamicLink, DynamicLinks, RPath, ObjectHandle, Section, Sections, SectionRef,
                   Segment, Segments, SegmentRef, StrTab, Symbols, SymtabEntry, SymbolRef,
                   getindex, length, iterate, keys, lastindex, eltype, handle, header, path,
                   rpaths, canonical_rpaths, find_library, readmeta, seek, seekstart, skip,
                   iostream, position, read, readuntil, eof, endianness, is64bit, isrelocatable,
                   isexecutable, islibrary, isdynamic, mangle_section_name, mangle_symbol_name,
                   format_string, section_header_offset, section_header_size, section_header_type,
                   segment_header_offset, segment_header_size, segment_header_type, startaddr,
                   symtab_entry_offset, symtab_entry_size, symtab_entry_type, find_libraries,
                   findfirst, deref, section_name, section_size,
                   section_offset, section_address, section_number, segment_name, segment_offset,
                   segment_file_size, segment_memory_size, segment_address, strtab_lookup,
                   symbol_name, symbol_value, isundef, isglobal, islocal, isweak, symbol_number, symbol_section, symbol_offset
# Load in imported C #define constants
include("constants.jl")

# Start to bring in concrete types, in the order they're needed
include("MachOHeader.jl")
include("MachOHandle.jl")
include("MachOLoadCmd.jl")
include("MachOSegment.jl")
include("MachOSection.jl")
include("MachODynamicLink.jl")
include("MachOStrTab.jl")
include("MachOSymbol.jl")

# These aren't complete implementations of the API
include("MachOFat.jl")
include("MetalLibrary.jl")


end # module MachO

# Export datatypes
export ELFDynamicLinks, ELFDynamicLink, ELFRPath

# Export methods
export DynamicLinks, DynamicLink, StrTab, RPath

import Base: getindex, show

"""
    ELFDynamicLinks

ELF dynamic linkage table, contains the list dynamic loader commands, see the
`ELFDynEntry` type for an opaque and unhelpful detailing of these commands.
"""
struct ELFDynamicLinks{H <: ELFHandle} <: DynamicLinks{H}
    section_ref::SectionRef{H}
    links::Vector
end

"""
    DynamicLinks(oh::ELFHandle)

Return the `ELFDynamicLinks` object that is contained within the first
`.dynamic` section within the ELF object.
"""
function DynamicLinks(oh::ELFHandle)
    sections = Sections(oh)
    dyn_section = findfirst(sections, ".dynamic")

    # Create half-initialized `DynamicLinks` object, so we have it around to
    # pass to the `DynamicLink()` constructor below
    dls = ELFDynamicLinks(dyn_section, DynamicLink[])

    # Find all our DT_NEEDED DynEntries
    des = ELFDynEntries(oh, [DT_NEEDED])

    # Now push those onto our half-initialized DynamicLinks object, linking
    # them back to it
    for idx in 1:length(des)
        push!(dls.links, DynamicLink(dls, des[idx]))
    end

    # Return our DynamicLinks object
    return dls
end
Section(dls::ELFDynamicLinks) = dls.section_ref
handle(dls::ELFDynamicLinks) = handle(Section(dls))
lastindex(dls::ELFDynamicLinks) = lastindex(dls.links)
getindex(dls::ELFDynamicLinks, idx) = getindex(dls.links, idx)

"""
    StrTab(dls::ELFDynamicLinks)

Given an ELF `DynamicLinks` container, construct an `ELFStrTab` that refers to
the associated dynamic string table.
"""
function StrTab(dls::ELFDynamicLinks{H}) where {H <: ELFHandle}
    # The `sh_link` field in a ".dynamic" section always points to the
    # dynamic string table (usually called ".dynstr")
    section_idx = deref(Section(dls)).sh_link+1
    strtab_section = Sections(handle(dls))[section_idx]
    return ELFStrTab{H}(strtab_section)
end


struct ELFDynamicLink{H <: ELFHandle} <: DynamicLink{H}
    dls::ELFDynamicLinks{H}
    dyn_entry::ELFDynEntryRef{H}
end

function DynamicLink(dls::ELFDynamicLinks{H},
                     dyn_entry::ELFDynEntryRef{H}) where {H <: ELFHandle}
    return ELFDynamicLink(dls, dyn_entry)
end

DynamicLinks(dl::ELFDynamicLink) = dl.dls
handle(dl::ELFDynamicLink) = handle(DynamicLinks(dl))

function path(dl::ELFDynamicLink)
    strtab = StrTab(DynamicLinks(dl))
    return strtab_lookup(dl.dyn_entry)
end


"""
    ELFRPath

Stores the RPath entries from an ELF object
"""
struct ELFRPath{H <: ELFHandle} <: RPath{H}
    section_ref::SectionRef{H}
    rpath::Vector{<:AbstractString}
end

"""
    RPath(oh::ELFHandle)

Return the `ELFRPath` object that is contained within the first `.dynamic`
section within the ELF object.
"""
function RPath(oh::ELFHandle)
    sections = Sections(oh)
    dyn_section = findfirst(sections, ".dynamic")

    # Get all dyn entries that are DT_RUNPATH or DT_RPATH
    des = ELFDynEntries(oh, [DT_RPATH, DT_RUNPATH])
    
    # Lookup each and every one of those strings, split them out into paths
    colon_paths = String[strtab_lookup(d) for d in des]
    paths = AbstractString[]
    for colon_path in colon_paths
        for component in split(colon_path, ':')
            push!(paths, component)
        end
    end

    # Return our RPath object
    return ELFRPath(dyn_section, paths)
end

Section(rpath::ELFRPath) = rpath.section_ref
handle(rpath::ELFRPath) = handle(Section(rpath))
rpaths(rpath::ELFRPath) = rpath.rpath

"""
    COFFSections

COFF Section header table type, containing information about the number of
sections within the COFF object, the location of the section headers, etc...
"""
struct COFFSections{H <: COFFHandle} <: Sections{COFFHandle}
    handle::H
end

Sections(oh::COFFHandle) = COFFSections(oh)

# Implement Sections API
handle(sections::COFFSections) = sections.handle
lastindex(sections::COFFSections) = num_sections(header(handle(sections)))


"""
    COFFSection

COFF Section header type, containing information about a `Section` of the COFF
file such as its name, its size, location within memory, etc...
"""
@io struct COFFSection{H <: COFFHandle} <: Section{H}
    Name::fixed_string{UInt64}
    VirtualSize::UInt32
    VirtualAddress::UInt32
    SizeOfRawData::UInt32
    PointerToRawData::UInt32
    PointerToRelocations::UInt32
    PointerToLinenumbers::UInt32
    NumberOfRelocations::UInt16
    NumberOfLinenumbers::UInt16
    Characteristics::UInt32
end

function section_name(s::COFFSection)
    name = unsafe_string(s.Name)
    if name[1] == '/'
        # Wow, COFF files are weird
        return string("strtab@", parse(Int, name[2:end]))
    end
    return name
end

section_size(s::COFFSection) = s.SizeOfRawData
section_address(s::COFFSection) = s.VirtualAddress
section_offset(s::COFFSection) = s.PointerToRawData


"""
    COFFSectionRef

COFF `SectionRef` type, containing a `COFFSection` and important metadata..
"""
struct COFFSectionRef{H <: COFFHandle} <: SectionRef{H}
    sections::COFFSections{H}
    section::COFFSection{H}
    idx::UInt32
end

function SectionRef(sections::COFFSections, s::COFFSection, idx)
    return COFFSectionRef(sections, s, UInt32(idx))
end
deref(s::COFFSectionRef) = s.section
sections(s::COFFSectionRef) = s.sections
handle(s::COFFSectionRef) = handle(sections(s))
section_number(s::COFFSectionRef) = s.idx
function section_name(s::COFFSectionRef)
    name = unsafe_string(deref(s).Name)
    if !isempty(name) && name[1] == '/'
        # Wow, COFF files are weird.
        strtab = StrTab(handle(s))
        return strtab_lookup(strtab, parse(Int, name[2:end]))
    end
    return name
end

export ELFSections, ELFSection, ELFSection32, ELFSection64, ELFSectionRef

# Export certain extensions to the base API
export section_type

"""
    ELFSections

ELF Section header table type, containing information about the number of
sections within the ELF object, the location of the section headers, etc...
"""
struct ELFSections{H <: ELFHandle} <: Sections{ELFHandle}
    handle::H
end

Sections(oh::ELFHandle) = ELFSections(oh)

# Implement Sections API
handle(sections::ELFSections) = sections.handle
lastindex(sections::ELFSections) = header(handle(sections)).e_shnum


"""
    ELFSection

ELF Section type, containing information about a `Section` within the ELF
object, such as the `Section`'s name, its size, etc...
"""
abstract type ELFSection{H <: ELFHandle} <: Section{H} end
@io struct ELFSection32{H <: ELFHandle} <: ELFSection{H}
    sh_name::UInt32
    sh_type::UInt32
    sh_flags::UInt32
    sh_addr::UInt32
    sh_offset::UInt32
    sh_size::UInt32
    sh_link::UInt32
    sh_info::UInt32
    sh_addralign::UInt32
    sh_entsize::UInt32
end
@io struct ELFSection64{H <: ELFHandle} <: ELFSection{H}
    sh_name::UInt32
    sh_type::UInt32
    sh_flags::UInt64
    sh_addr::UInt64
    sh_offset::UInt64
    sh_size::UInt64
    sh_link::UInt32
    sh_info::UInt32
    sh_addralign::UInt64
    sh_entsize::UInt64
end

# Implement Section API
function read(oh::ELFHandle, ::Type{ST}) where {ST <: ELFSection}
    type_func = section_header_type
    size_func = section_header_size
    return read_struct(oh, type_func, size_func, "Section Header")
end

section_name(s::ELFSection) = string("strtab@", s.sh_name)
section_type(s::ELFSection) = s.sh_type
section_size(s::ELFSection) = s.sh_size
section_offset(s::ELFSection) = s.sh_offset
section_address(s::ELFSection) = s.sh_addr



"""
    ELFSectionRef

ELF `SectionRef` type, containing an `ELFSection` and important metadata.
"""
struct ELFSectionRef{H<:ELFHandle} <: SectionRef{H}
    sections::ELFSections{H}
    section::ELFSection{H}
    idx::UInt32
end

function SectionRef(sections::ELFSections, s::ELFSection, idx)
    return ELFSectionRef(sections, s, UInt32(idx))
end
deref(s::ELFSectionRef) = s.section
sections(s::ELFSectionRef) = s.sections
handle(s::ELFSectionRef) = handle(sections(s))
section_number(s::ELFSectionRef) = s.idx
@derefmethod section_type(s::ELFSectionRef)

function section_name(section::ELFSectionRef)
    # Actually do the strtab lookup to get the name of this guy
    strtab = StrTab(handle(section))
    return strtab_lookup(strtab, deref(section).sh_name)
end



"""
    section_type_string(s::ELFSection)

Return the given `ELFSection`'s section type as a string.
"""
function section_type_string(s::ELFSection)
    global SHT_TYPES

    sh_type = section_type(s)
    if haskey(SHT_TYPES, sh_type)
        return SHT_TYPES[sh_type]
    end
    return string("Unknown Section Type (0x", string(sh_type, base=16), ")")
end
@derefmethod section_type_string(s::ELFSectionRef)

module ObjectFile
using Reexport
import Base.BinaryPlatforms: Platform

# Include base utilities
include("utils.jl")
include("string_utils.jl")

# Include our Abstract definitions
include("Abstract/Abstract.jl")

# Include ELF format
include("ELF/ELF.jl")
@reexport using .ELF

# Include MachO format
include("MachO/MachO.jl")
@reexport using .MachO

# Include COFF format
include("COFF/COFF.jl")
@reexport using .COFF

function __init__()
    global ObjTypes

    push!(ObjTypes, ELFHandle)
    push!(ObjTypes, MachOHandle)
    push!(ObjTypes, FatMachOHandle)
    push!(ObjTypes, COFFHandle)
end

end #module ObjectFile

struct MachOStrTab{H <: MachOHandle} <: StrTab{H}
    cmd::MachOLoadCmdRef{H,MachOSymtabCmd{H}}
end

function StrTab(cmd::MachOLoadCmdRef{H,MachOSymtabCmd{H}}) where {H <: MachOHandle}
    return MachOStrTab(cmd)
end
function StrTab(oh::MachOHandle)
    cmds = findall(MachOLoadCmds(oh), [MachOSymtabCmd])
    if isempty(cmds)
        error("Mach-O file does not contain Symtab load commands")
    end
    return StrTab(first(cmds))
end

handle(strtab::MachOStrTab) = handle(strtab.cmd)
strtab_lookup(strtab::MachOStrTab, index) = strtab_lookup(strtab.cmd, index)

export MachOSymtabEntry, MachOSymbolRef, MachOSymbols

"""
    MachOSymtabEntry

MachO Symbol Table entry type, internally represented as an `nlist` type.
"""
abstract type MachOSymtabEntry{H <: MachOHandle} <: SymtabEntry{H} end
@io struct nlist{H <: MachOHandle} <: MachOSymtabEntry{H}
    n_strx::UInt32
    n_type::UInt8
    n_sect::UInt8
    n_desc::UInt16
    n_value::UInt32
end

@io struct nlist_64{H <: MachOHandle} <: MachOSymtabEntry{H}
    n_strx::UInt32
    n_type::UInt8
    n_sect::UInt8
    n_desc::UInt16
    n_value::UInt64
end

symbol_name(sym::MachOSymtabEntry) = string("strtab@", sym.n_strx)
symbol_value(sym::MachOSymtabEntry) = sym.n_value
symbol_type(sym::MachOSymtabEntry) = sym.n_type
symbol_description(sym::MachOSymtabEntry) = sym.n_desc

function isglobal(sym::MachOSymtabEntry)
    return (symbol_type(sym) & N_EXT) != 0
end
function islocal(sym::MachOSymtabEntry)
    return !isglobal(sym) && (symbol_type(sym) == N_UNDF)
end
function isweak(sym::MachOSymtabEntry)
    return (symbol_description(sym) & (N_WEAK_REF | N_WEAK_DEF)) != 0
end
function isundef(sym::MachOSymtabEntry)
    return (symbol_type(sym) == N_UNDF) ||
           (isglobal(sym) && sym.n_sect == NO_SECT)
end



"""
    MachOSymbols

MachO container type for `SymtabEntry` objects.
"""
struct MachOSymbols{H <: MachOHandle} <: Symbols{H}
    cmd::MachOLoadCmdRef{H,MachOSymtabCmd{H}}
end

function MachOSymbols(oh::MachOHandle)
    cmds = findall(MachOLoadCmds(oh), [MachOSymtabCmd])
    if isempty(cmds)
        error("Mach-O file does not contain Symtab load commands")
    end
    return MachOSymbols(first(cmds))
end

Symbols(oh::MachOHandle) = MachOSymbols(oh::MachOHandle)
function Symbols(cmd::MachOLoadCmdRef{H,MachOSymtabCmd{H}}) where {H <: MachOHandle}
    return MachOSymbols(cmd)
end

handle(syms::MachOSymbols) = handle(syms.cmd)
lastindex(syms::MachOSymbols) = symtab_num_symbols(syms.cmd)

symtab_entry_offset(syms::MachOSymbols) = symtab_symbols_offset(syms.cmd)
symtab_entry_size(syms::MachOSymbols) = sizeof(symtab_entry_type(syms))
function symtab_entry_type(syms::MachOSymbols{H}) where {H <: MachOHandle}
    if is64bit(handle(syms))
        return nlist_64{H}
    else
        return nlist{H}
    end
end

function getindex(syms::MachOSymbols, idx)
    # Punt off to `getindex_ref`
    return getindex_ref(
        syms,
        symtab_entry_offset(syms),
        symtab_entry_size(syms),
        symtab_entry_type(syms),
        SymbolRef,
        idx
    )
end


# Add an StrTab() override to be able to load the symbol string table
"""
    StrTab(syms::MachOSymbols)

Given a MachO `Symbols` container, construct a `MachOStrTab` that refers to the
associated symbol string table.
"""
StrTab(syms::MachOSymbols) = StrTab(syms.cmd)


struct MachOSymbolRef{H <: MachOHandle} <: SymbolRef{H}
    syms::MachOSymbols{H}
    entry::MachOSymtabEntry{H}
    idx::UInt32
end

function SymbolRef(syms::MachOSymbols, entry::MachOSymtabEntry, idx)
    return MachOSymbolRef(syms, entry, UInt32(idx))
end

deref(sym::MachOSymbolRef) = sym.entry
Symbols(sym::MachOSymbolRef) = sym.syms
symbol_number(sym::MachOSymbolRef) = sym.idx

function symbol_section(sym::MachOSymbolRef)
    # MachO uses 0 to indicate no section, so we use NO_SECT
    if deref(sym).n_sect == 0
        return NO_SECT
    end
    return Sections(handle(sym))[deref(sym).n_sect]
end

function symbol_name(sym::MachOSymbolRef)
    return strtab_lookup(StrTab(Symbols(sym)), sym.entry.n_strx)
end

function symbol_offset(sym::MachOSymbolRef)
    addr = symbol_value(sym)
    sect = symbol_section(sym)
    virtual_offset =  section_address(sect) - section_offset(sect)
    return addr - virtual_offset
end

export ELFHeader, ELFHeader32, ELFHeader64

import Base: show

"""
    ELFHeader

ELF Header type, containing metadata about the ELF object itself, such as its
type, offsets for the Program and Section headers, the number of other header
entries, etc...
"""
abstract type ELFHeader{H <: ObjectHandle} end
@io struct ELFHeader32{H <: ObjectHandle} <: ELFHeader{H}
    e_type::UInt16
    e_machine::UInt16
    e_version::UInt32
    e_entry::UInt32
    e_phoff::UInt32
    e_shoff::UInt32
    e_flags::UInt32
    e_ehsize::UInt16
    e_phentsize::UInt16
    e_phnum::UInt16
    e_shentsize::UInt16
    e_shnum::UInt16
    e_shstrndx::UInt16
end
@io struct ELFHeader64{H <: ObjectHandle} <: ELFHeader{H}
    e_type::UInt16
    e_machine::UInt16
    e_version::UInt32
    e_entry::UInt64
    e_phoff::UInt64
    e_shoff::UInt64
    e_flags::UInt32
    e_ehsize::UInt16
    e_phentsize::UInt16
    e_phnum::UInt16
    e_shentsize::UInt16
    e_shnum::UInt16
    e_shstrndx::UInt16
end

function filetype(e_type)
    if haskey(ET_TYPES, e_type)
        return ET_TYPES[e_type]
    end
    return string("Unknown (0x",string(e_type, base=16),")")
end


function machinetype(e_machine)
    if haskey(EM_MACHINES, e_machine)
        return EM_MACHINES[e_machine]
    end
    return string("Unknown (0x",string(e_machine, base=16),")")
end

function elf_machine_to_arch(machine::UInt16)
    if machine ∈ (EM_386,)
        return "i686"
    elseif machine ∈ (EM_IA_64, EM_X86_64)
        return "x86_64"
    elseif machine ∈ (EM_ARM,)
        return "armv7l"
    elseif machine ∈ (EM_AARCH64,)
        return "aarch64"
    elseif machine ∈ (EM_PPC64,)
        return "ppc64le"
    elseif machine ∈ (EM_RISCV,)
        return "riscv64"
    end
end


function show(io::IO, header::ELFHeader)
    println(io, "ELF Header")
    println(io, "  Type ", filetype(header.e_type))
    println(io, "  Machine ", machinetype(header.e_machine))
    # Skip e_version (not particularly useful)
    println(io, "  Entrypoint ", "0x", string(header.e_entry, base=16))
    println(io, "  PH Offset ", "0x", string(header.e_phoff, base=16))
    println(io, "  SH Offset ", "0x", string(header.e_shoff, base=16))
    # Skip flags
    println(io, "  Header Size ", "0x", string(header.e_ehsize, base=16))
    println(io, "  PH Entry Size ", "0x", string(header.e_phentsize, base=16))
    println(io, "  PH Entry Count ", string(header.e_phnum, base=10))
    println(io, "  SH Entry Size ", "0x", string(header.e_shentsize, base=16))
    println(io, "  SH Entry Count ", string(header.e_shnum, base=10))
    println(io, "  Strtab Index ", string(header.e_shstrndx, base=10))
end

export COFFHandle

"""
    COFFHandle

An `ObjectHandle` subclass for COFF files, this is the primary object by which
client applications will interact with COFF files.
"""
struct COFFHandle{T<:IO} <: ObjectHandle
    # Backing IOS and start point within the IOStream of this COFF object
    io::T
    start::Int64

    # The parsed-out header of the COFF object
    header::COFFHeader

    # The location of the header (because of MZ confusion, we must store this)
    header_offset::UInt32

    # The "Optional" header, which isn't actually optional
    opt_header::COFFOptionalHeader

    # The path of the file this was created with
    path::String
end

## Define creation methods
function readmeta(io::IO, ::Type{H}) where {H <: COFFHandle}
    # This is the magic that we know we must find
    PE_magic = UInt8['P','E','\0','\0']
    MZ_magic = UInt8['M','Z']

    # Save the starting position of `io`
    start = position(io)

    # Check to see if this is an 'MZ' file; if it is, we have to jump forward
    # into the file a bit to get to the PE header
    magic = [read(io, UInt8) for idx in 1:2]
    if all(magic .== MZ_magic)
        # Skip ahead to the PE header offset
        skip(io, 58)
        header_offset = read(io, UInt32)
        seek(io, start + header_offset)
    else
        # If it's not, assume the PE header starts at the beginning of the file
        skip(io, -2)
    end

    magic = [read(io, UInt8) for idx in 1:4]
    if any(magic .!= PE_magic)
        msg = """
        Magic Number 0x$(join(string.(magic, base=16),"")) does not match expected PE
        magic number 0x$(join("", string.(PE_magic, base=16)))
        """
        throw(MagicMismatch(replace(strip(msg), "\n" => " ")))
    end

    # Read the PE header and place the header offset just past the PE_magic
    header_offset = UInt32(position(io) - start)
    header = unpack(io, COFFHeader)

    # Next, read the optional header
    opt_header = read(io, COFFOptionalHeader)

    # Construct our COFFHandle, pilfering the filename from the IOStream
    return [COFFHandle(io, Int64(start), header, header_offset, opt_header, path(io))]
end


## IOStream-like operations:
startaddr(oh::COFFHandle) = oh.start
iostream(oh::COFFHandle) = oh.io

## Format-specific properties:
header(oh::COFFHandle) = oh.header
Platform(oh::COFFHandle) = Platform(coff_machine_to_arch(oh.header.Machine), "windows")
endianness(oh::COFFHandle) = coff_header_endianness(header(oh))
is64bit(oh::COFFHandle) = coff_header_is64bit(header(oh))
isrelocatable(oh::COFFHandle) = isrelocatable(header(oh))
isexecutable(oh::COFFHandle) = isexecutable(header(oh))
islibrary(oh::COFFHandle) = islibrary(header(oh))
isdynamic(oh::COFFHandle) = !isempty(findall(Sections(oh), [".idata"]))
mangle_section_name(oh::COFFHandle, name::AbstractString) = string(".", name)
function mangle_symbol_name(oh::COFFHandle, name::AbstractString)
    # sob
    if is64bit(oh)
        return name
    else
        return string("_", name)
    end
end
format_string(::Type{H}) where {H <: COFFHandle} = "COFF"

## Section information
function section_header_offset(oh::COFFHandle)
    h = header(oh)
    return oh.header_offset + sizeof(COFFHeader) + h.SizeOfOptionalHeader
end
section_header_size(oh::COFFHandle) = sizeof(section_header_type(oh))
section_header_type(oh::H) where {H <: COFFHandle} = COFFSection{H}

### Symbol properties
symtab_entry_offset(oh::COFFHandle) = header(oh).PointerToSymbolTable
symtab_entry_size(oh::COFFHandle) = packed_sizeof(symtab_entry_type(oh))
symtab_entry_type(oh::H) where {H <: COFFHandle} = COFFSymtabEntry{H}

### Strtab properties
function strtab_offset(oh::H) where {H <: COFFHandle}
    h = header(oh)
    return h.PointerToSymbolTable + h.NumberOfSymbols*symtab_entry_size(oh)
end

### Misc. stuff
path(oh::COFFHandle) = oh.path

export MachODynamicLinks, MachODynamicLink, MachORPath

struct MachODynamicLinks{H <: MachOHandle, C <: MachOLoadCmdRef{H,MachOLoadDylibCmd{H}}} <: DynamicLinks{H}
    handle::H
    cmds::Vector{C}
end

function MachODynamicLinks(lcs::MachOLoadCmds)
    ld_cmds = findall(lcs, [MachOLoadDylibCmd])
    return MachODynamicLinks(handle(lcs), ld_cmds)
end
MachODynamicLinks(oh::MachOHandle) = MachODynamicLinks(MachOLoadCmds(oh))

DynamicLinks(oh::MachOHandle) = MachODynamicLinks(oh)
DynamicLinks(lcs::MachOLoadCmds) = MachODynamicLinks(lcs)

lastindex(dls::MachODynamicLinks) = lastindex(dls.cmds)
function getindex(dls::MachODynamicLinks, idx)
    return MachODynamicLink(dls, dls.cmds[idx])
end
handle(dls::MachODynamicLinks) = dls.handle

"""
    MachODynamicLink

MachO type representing a dynamic link between a MachO file and one of its
dynamic dependencies.  Although Mach-O encodes more than just the path of the
dependency, in order to get at it you will need to dig into the LoadCmd that
describes it.
"""
struct MachODynamicLink{H <: MachOHandle} <: DynamicLink{H}
    dls::MachODynamicLinks
    cmd_ref::MachOLoadCmdRef{H,MachOLoadDylibCmd{H}}
end

DynamicLinks(dl::MachODynamicLink) = dl.dls
handle(dl::MachODynamicLink) = handle(DynamicLinks(dl))
path(dl::MachODynamicLink) = dylib_name(deref(dl.cmd_ref))


struct MachORPath{H <: MachOHandle} <: RPath{H}
    handle::H
    cmds::Vector
end

function MachORPath(lcs::MachOLoadCmds)
    cmds = findall(lcs, [MachORPathCmd])
    return MachORPath(handle(lcs), cmds)
end

RPath(oh::MachOHandle) = MachORPath(oh)
MachORPath(oh::MachOHandle) = MachORPath(MachOLoadCmds(oh))
handle(mrp::MachORPath) = mrp.handle

function rpaths(mrp::MachORPath)
    return [rpath(c) for c in mrp.cmds]
end

export ELFSegments, ELFSegment, ELFSegment32, ELFSegment64

"""
    ELFSegments

ELF segment header table type, containing information about the number of
segments within the ELF object, the location of the segment headers, etc...
"""
struct ELFSegments{H <: ELFHandle} <: Segments{H}
    handle::H
end
Segments(oh::ELFHandle) = ELFSegments(oh)
handle(segs::ELFSegments) = segs.handle
lastindex(segs::ELFSegments) = header(handle(segs)).e_phnum


"""
    ELFSegment

ELF Segment type, also known as a program header, containing information
about the virtual memory layout of a chunk of the program.
"""
abstract type ELFSegment{H <: ELFHandle} <: Segment{H} end

@io struct ELFSegment32{H <: ELFHandle} <: ELFSegment{H}
    p_type::UInt32
    p_offset::UInt32
    p_vaddr::UInt32
    p_paddr::UInt32
    p_filesz::UInt32
    p_memsz::UInt32
    p_flags::UInt32
    p_align::UInt32
end

@io struct ELFSegment64{H <: ELFHandle} <: ELFSegment{H}
    p_type::UInt32
    p_flags::UInt32
    p_offset::UInt64
    p_vaddr::UInt64
    p_paddr::UInt64
    p_filesz::UInt64
    p_memsz::UInt64
    p_align::UInt64
end


# Construction
function read(oh::ELFHandle, ::Type{ST}) where {ST <: ELFSegment}
    type_func = segment_header_type
    size_func = segment_header_size
    return read_struct(oh, type_func, size_func, "Segment Header")
end

function contents(oh::ELFHandle, seg::ELFSegment)
    # Allocate memory to hold this segment
    data = Array(UInt8, segment_file_size(seg))

    # Seek to where this segment starts
    seek(oh, segment_offset(seg))

    # Read and return it
    read(oh, data)
    return data
end


# Accessors
segment_type(seg::ELFSegment) = seg.p_type
segment_offset(seg::ELFSegment) = seg.p_offset
segment_file_size(seg::ELFSegment) = seg.p_filesz
segment_memory_size(seg::ELFSegment) = seg.p_memsz
segment_physical_address(seg::ELFSegment) = seg.p_paddr
segment_virtual_address(seg::ELFSegment) = seg.p_vaddr
segment_address(seg::ELFSegment) = segment_virtual_address(seg)


"""
    ELFSegmentRef

Provides a reference to a `Segment`, along with a reference to the
`ObjectHandle` this `Segment` comes from.  This should be the primary method by
which users interact with segments inside object files.  The list of available
API operations is given below.  Note that this overlaps heavily with the
`Segment` object API, this is by design as many of the methods are simply
passthroughs to the underlying `Segment` API calls for ease of use.

### Creation:
  - SegmentRef()

### Utility
  - deref()
  - handle()
  - Segments()

### IO-like operations:
  - read()
  - seekstart()
  - seek()
  - eof()


### Format-specific properties:
  - segment_type()
  - segment_offset()
  - segment_file_size()
  - segment_memory_size()
  - segment_physical_address()
  - segment_virtual_address()
  - segment_number()
"""
struct ELFSegmentRef{H<:ELFHandle} <: SegmentRef{H}
    segments::ELFSegments{H}
    segment::ELFSegment{H}
    idx::UInt32
end

function SegmentRef(segments::ELFSegments{H},
                    segment::ELFSegment{H}, idx) where {H <: ELFHandle}
    return ELFSegmentRef(segments, segment, UInt32(idx))
end
deref(seg::ELFSegmentRef) = seg.segment
Segments(seg::ELFSegmentRef) = seg.segments

segment_number(seg::ELFSegmentRef) = seg.idx
@derefmethod segment_physical_address(seg::ELFSegmentRef)
@derefmethod segment_virtual_address(seg::ELFSegmentRef)
@derefmethod segment_type(seg::ELFSegmentRef)



# Printing
"""
    segment_type_string(s::ELFSegment)

Return the given `ELFSegment`'s segment type as a string.
"""
function segment_type_string(s::ELFSegment)
    global P_TYPE

    s_type = segment_type(s)
    if haskey(P_TYPE, s_type)
        return P_TYPE[s_type]
    end
    return string("Unknown Segment Type (0x", string(s_type, base=16), ")")
end
@derefmethod segment_type_string(s::ELFSegmentRef)

function show(io::IO, seg::Union{ELFSegment,ELFSegmentRef})
    print(io, "ELFSegment")

    if !get(io, :compact, false)
        fsz = string(segment_file_size(seg), base=16)
        msz = string(segment_memory_size(seg), base=16)
        paddr = string(segment_physical_address(seg), base=16)
        vaddr = string(segment_virtual_address(seg), base=16)

        println(io)
        println(io, "       Type: $(segment_type_string(seg))")
        println(io, "       Size: (File: 0x$(fsz),   Mem: 0x$(msz))")
        println(io, "     Offset: 0x$(string(segment_offset(seg), base=16))")
        print(io,   "    Address:  (Phy: 0x$(paddr) Virt: 0x$(vaddr))")
    else
        print(io, " $(segment_type_string(seg))")
    end
end

export MachOLoadDylibCmd, MachOIdDylibCmd

export dylib_name, dylib_timestamp, dylib_version, dylib_compatibility

"""
    MachODylibStub

MachO Load Commands have an annoying and nasty habit of shimming strings into
difficult-to-reach places, such as within the header itself.  Because the
strings are variable-length, it becomes difficult to go back and find the
strings after the fact; it's better to suck it into memory immediately.  This
doesn't lend itself to `StructIO`-based IO very nicely, and so we hack our way
around the problem by creating the `Stub` which contains the data which can be
read in by `StructIO` nicely, and then immediately expanding and reading in the
`LCStr` afterward within the "true" `MachOLoadDylibCmd`.
"""
@io struct MachODylibStub
    # Note this `offset` is technically a part of the `dylib` union, but we
    # don't bother to split it out into its own `struct`.
    name_offset::UInt32
    timestamp::UInt32
    current_version::UInt32
    compatibilty::UInt32
end

"""
    MachOLoadDylibCmd

The Load Command that gives information about a dylib that must be loaded for
this Mach-O file to link properly.  The API for this laod command is given as
follows:

### Creation:
  - MachOLoadCmd()

### Accessors:
  - dylib_name()
  - dylib_timestamp()
  - dylib_version()
  - dylib_compatibility()
"""
struct MachOLoadDylibCmd{H <: MachOHandle} <: MachOLoadCmd{H}
    stub::MachODylibStub
    name::String
end

show(io::IO, lc::MachOLoadDylibCmd) = write(io, "LoadDylibCmd: \"$(dylib_name(lc))\"")


"""
    MachOIdDylibCmd

MachO dylibs have an "identity", analogous to the SONAME of an ELF shared
library.  This Load Command tells the linker about the identity of this
particular shared library.  The API of this object is identical to that of the
`MachOLoadDylibCmd` object, as they are intrinsically identical, it is the
semantic meaning behind the data that changes, and so this object is all but a
typealias for `MachOLoadDylibCmd`.
"""
struct MachOIdDylibCmd{H <: MachOHandle} <: MachOLoadCmd{H}
    stub::MachODylibStub
    name::String
end
show(io::IO, lc::MachOIdDylibCmd) = write(io, "IdDylibCmd: \"$(dylib_name(lc))\"")

"""
    MachODylibCmd

We define some operations that work on either a `MachOLoadDylibCmd` or
`MachOIdDylibCmd` load command, and to make it all pretty and shiny we define
this union type that allows our operations to be generic.
"""
const DylibCmd = Union{MachOLoadDylibCmd, MachOIdDylibCmd}

"""
    MachOLoadCmd(oh::MachOHeader, CT::Type{MachOLoadDylibCmd}, header)
    MachOLoadCmd(oh::MachOHeader, CT::Type{MachOIdDylibCmd}, header)

Manual override to unpack a `MachOLoadDylibCmd` from a MachO file and
immediately read in the associated name string.  See `MachODylibStub` for more.
"""
function MachOLoadCmd(oh::H, CT::Type{CTT}, header) where {CTT <: DylibCmd} where {H <: MachOHandle}
    # First, unpack the stub
    stub = unpack(oh, MachODylibStub)

    # Next, read in the string, telling it to not read in more than the total
    # load command size, and not before the DylibStub object finishes.
    offset = stub.name_offset - sizeof(MachODylibStub) - sizeof(MachOLoadCmdHeader{H})
    name = unpack_lcstr(oh, offset, load_cmd_size(header))

    # Finally, return our DylibCmd
    return CT(stub, name)
end

"""
    dylib_name(cmd)

Return the name of the dylib referred to by the given Load Command.
"""
dylib_name(cmd::DylibCmd) = cmd.name

"""
    dylib_timestamp(cmd)

Return the build timestamp of the dylib referred to by the given Load Command.
"""
dylib_timestamp(cmd::DylibCmd) = cmd.stub.timestamp

"""
    dylib_version(cmd)

Return the version of the dylib referred to by the given Load Command.
"""
dylib_version(cmd::DylibCmd) = cmd.stub.current_version

"""
    dylib_compatibility(cmd)

Return the compatibility version of the dylib referred to by the given Load
Command.
"""
dylib_compatibilty(cmd::DylibCmd) = cmd.stub.compatibilty

@derefmethod dylib_name(cmd::MachOLoadCmdRef{H, T}) where {H <: MachOHandle} where {T <: DylibCmd}
@derefmethod dylib_timestamp(cmd::MachOLoadCmdRef{H, T}) where {H <: MachOHandle} where {T <: DylibCmd}
@derefmethod dylib_version(cmd::MachOLoadCmdRef{H, T}) where {H <: MachOHandle} where {T <: DylibCmd}
@derefmethod dylib_compatibilty(cmd::MachOLoadCmdRef{H, T}) where {H <: MachOHandle} where {T <: DylibCmd}


"""
    MachORPathCmd

The Load Command that holds the RPATH of this object.
"""
struct MachORPathCmd{H <: MachOHandle} <: MachOLoadCmd{H}
    rpath_offset::UInt32
    rpath::String
end

show(io::IO, lc::MachORPathCmd) = write(io, "RPathCmd: \"$(rpath(lc))\"")

"""
    MachOLoadCmd(oh::MachOHeader, CT::Type{MachORPathCmd}, header)

Manual override to unpack a `MachORPathCmd` from a MachO file and
immediately read in the associated rpath string.
"""
function MachOLoadCmd(oh::H, CT::Type{CTT}, header) where {CTT <: MachORPathCmd} where {H <: MachOHandle}
    rpath_offset = read(oh, UInt32)

    # Next, read in the string, telling it to not read in more than the total
    # load command size, and not before the DylibStub object finishes.
    offset = rpath_offset - sizeof(UInt32) - sizeof(MachOLoadCmdHeader{H})
    name = unpack_lcstr(oh, offset, load_cmd_size(header))

    # Finally, return our RPathCmd
    return CT(rpath_offset, name)
end

rpath(cmd::MachORPathCmd) = cmd.rpath
@derefmethod rpath(cmd::MachOLoadCmdRef{H,MachORPathCmd{H}}) where {H <: MachOHandle}

export ELFInternal

@io struct ELFInternal
    # ELF object class (32bit/64bit)
    class::UInt8

    # Data (used to check for endianness)
    data::UInt8

    # ELF version
    version::UInt8

    # OS ABI version
    osabi::UInt8

    # ELF ABI version
    abiversion::UInt8
end align_packed

"""
ELFInternal

Internal datastructure used within the ELF file format to convey fundamental
information such as the endianness of the file, whether it's a 32-bit or 64-bit
ELF file, etc...
"""
ELFInternal

# Define some helper functions on ELFInternal stuff
function elf_internal_endianness(ei::ELFInternal)
    if ei.data == ELFDATA2MSB
        :BigEndian
    elseif ei.data == ELFDATA2LSB
        :LittleEndian
    else
        error("Invalid Data Specification")
    end
end

function elf_internal_is64bit(ei::ELFInternal)
    if ei.class == ELFCLASS32
        return false
    elseif ei.class == ELFCLASS64
        return true
    else
        error("Invalid ELF Class ($(class))")
    end
end

# DWARF support
#=
function read(io::IO,file::ELFFile,h::ELFSectionHeader,::Type{DWARF.ARTable})
    seek(io,h.sh_offset)
    ret = DWARF.ARTable(Array(DWARF.ARTableSet,0))
    while position(io) < h.sh_offset + h.sh_size
        push!(ret.sets,read(io,DWARF.ARTableSet,f.endianness))
    end
    ret
end

function read(io::IO,file::ELFFile,h::ELFSectionHeader,::Type{DWARF.PUBTable})
    seek(io,h.sh_offset)
    ret = DWARF.PUBTable(Array(DWARF.PUBTableSet,0))
    while position(io) < h.sh_offset + h.sh_size
        push!(ret.sets,read(io,DWARF.PUBTableSet,f.endianness))
    end
    ret
end

function read(io::IO,f::ELFFile,h::ELFSectionHeader,::Type{DWARF.AbbrevTableSet})
    seek(io,h.sh_offset)
    read(io,AbbrevTableSet,f.endianness)
end

function read(io::IO,f::ELFFile,h::ELFSectionHeader,s::DWARF.PUBTableSet,::Type{DWARF.DWARFCUHeader})
    seek(io,h.sh_offset+s.header.debug_info_offset)
    read(io,DWARF.DWARFCUHeader,f.endianness)
end

function read(io::IO,f::ELFFile,debug_info::ELFSectionHeader,debug_abbrev::ELFSectionHeader,
    s::DWARF.PUBTableSet,e::DWARF.PUBTableEntry,header::DWARF.DWARFCUHeader,::Type{DWARF.DIE})
    ats = read(io,f,debug_abbrev,header,DWARF.AbbrevTableSet)
    seek(io,debug_info.sh_offset+s.header.debug_info_offset+e.offset)
    read(io,header,ats,DWARF.DIE)
end

function read(io::IO,f::ELFFile,h::ELFSectionHeader,s::DWARF.DWARFCUHeader,::Type{DWARF.AbbrevTableSet})
    seek(io,h.sh_offset+s.debug_abbrev_offset)
    read(io,AbbrevTableSet,f.endianness)
end

function debugsections(io::IO,f::ELFFile)
    snames = names(io,f,f.sheaders)
    sections = Dict{String,ELFSectionHeader}()
    for i in 1:length(snames)
        # Remove leading "."
        ind = findfirst(DEBUG_SECTIONS,snames[i][2:end])
        if ind != 0
            sections[DEBUG_SECTIONS[ind]] = f.sheaders[ind]
        end
    end
    sections
end

function read(io::IO,f::ELFFile,debug_info::ELFSectionHeader,debug_abbrev::ELFSectionHeader,
    s::DWARF.PUBTableSet,e::DWARF.PUBTableEntry,header::DWARF.DWARFCUHeader,::Type{DWARF.DIETree})
    ats = read(io,f,debug_abbrev,header,DWARF.AbbrevTableSet)
    seek(io,debug_info.sh_offset+s.header.debug_info_offset+e.offset)
    ret = DIETree(Array(DWARF.DIETreeNode,0))
    read(io,header,ats,ret,DWARF.DIETreeNode,f.endianness)
    ret
end
=#

struct dl_phdr_info
    dlpi_addr::UInt64
    dlpi_name::Ptr{UInt8}
    dlpi_phdr::Ptr{Cvoid}
    dlpi_phnum::UInt16
end

function callback(info::Ptr{dl_phdr_info},size::Csize_t, data::Ptr{Cvoid})
    push!(unsafe_pointer_to_objref(data),unsafe_load(info))
    convert(Cint,0)
end

function loaded_libraries()
    x = Array(dl_phdr_info,0)
    ccall(:dl_iterate_phdr, Cint, (Ptr{Cvoid}, Any), cfunction(callback, Cint, (Ptr{dl_phdr_info},Csize_t,Ptr{Cvoid})), x)
    x
end

## DWARF Support
function debugsections(h::ELFHandle)
    sects = collect(Sections(h))
    strt = strtab(h)
    snames = map(s->sectionname(s.header;strtab=strt),sects)
    sections = Dict{String,SectionRef}()
    for i in 1:length(snames)
        # remove leading "."
        ind = findfirst(ObjFileBase.DEBUG_SECTIONS,string(snames[i])[2:end])
        if ind != 0
            sections[ObjFileBase.DEBUG_SECTIONS[ind]] = sects[i]
        end
    end
    ObjFileBase.DebugSections(h,sections)
end

export MachOSection, MachOSections, MachOSectionRef

"""
    MachOSection

Mach-O `Section` type, containing information about the section name, segment
name, size, address, etc... of the `Section.`
"""
abstract type MachOSection{H <: MachOHandle} <: Section{H} end
@io struct MachOSection32{H <: MachOHandle} <: MachOSection{H}
    sectname::fixed_string{UInt128}
    segname::fixed_string{UInt128}
    addr::UInt32
    size::UInt32
    offset::UInt32
    align::UInt32
    reloff::UInt32
    nreloc::UInt32
    flags::UInt32
    reserved1::UInt32
    reserved2::UInt32
end

@io struct MachOSection64{H <: MachOHandle} <: MachOSection{H}
    sectname::fixed_string{UInt128}
    segname::fixed_string{UInt128}
    addr::UInt64
    size::UInt64
    offset::UInt32
    align::UInt32
    reloff::UInt32
    nreloc::UInt32
    flags::UInt32
    reserved1::UInt32
    reserved2::UInt32
    reserved3::UInt32
end

function read(oh::MachOHandle, ::Type{ST}) where {ST <: MachOSection}
    type_func = section_header_type
    size_func = section_header_size
    return read_struct(oh, type_func, size_func, "Section Header")
end


section_name(s::MachOSection) = "$(s.segname),$(s.sectname)"
section_size(s::MachOSection) = s.size
section_offset(s::MachOSection) = s.offset
section_address(s::MachOSection) = s.addr
is64bit(s::MachOSection) = isa(s, MachOSection64)


"""
    MachOSections

Mach-O `Section` object collection type.  Mach-O sections are split out over
multiple segments, one per load command.  As an example, most executables have
at least two segments, `__DATA` and `__TEXT`, each of which have multiple
sections embedded within them.  A `MachOSections` object is created from
multiple segments (in this case, realized as multiple load commands) which
contain the necessary sections, and these sections can then be accessed as
desired.
"""
struct MachOSections{H <: MachOHandle, S <: MachOSection} <: Sections{H}
    handle::H
    sections::Vector{S}
end

# Special section_header_type() overrides for segments:
section_header_type(::MachOSegment32Cmd) = MachOSection32
section_header_type(::MachOSegment64Cmd) = MachOSection64
section_header_type(seg::MachOSegment) = section_header_type(MachOLoadCmd(seg))
@derefmethod section_header_type(seg::MachOSegmentRef)

function MachOSections(segs::MachOSegments)
    oh = handle(segs)

    # Now, load the sections off of each segment:
    sections = Any[]
    for seg in segs
        # Seek to the beginning of the section headers for this segment
        seg_size = packed_sizeof(typeof(MachOLoadCmd(deref(seg))))
        sections_pos = position(MachOLoadCmdRef(seg)) + seg_size
        seek(oh, sections_pos)

        # For each section header, read it in:
        for sect_idx in 1:segment_num_sections(seg)
            sect = read(oh, section_header_type(seg))
            push!(sections, sect)
        end
    end

    # Re-run type inference on this array, so it packs nicely
    sections = [s for s in sections]

    # Bake'em away, Toys!
    return MachOSections(oh, sections)
end

handle(sections::MachOSections) = sections.handle
lastindex(sections::MachOSections) = lastindex(sections.sections)
function getindex(sections::MachOSections{H}, idx) where {H <: MachOHandle}
    section = sections.sections[idx]
    return MachOSectionRef(sections, section, UInt32(idx))
end

Sections(segs::MachOSegments) = MachOSections(segs)
Sections(oh::MachOHandle) = Sections(Segments(oh))

"""
    MachOSectionRef

Mach-O `SectionRef` type
"""
struct MachOSectionRef{H <: MachOHandle} <: SectionRef{H}
    sections::MachOSections{H}
    section::MachOSection{H}
    idx::UInt32
end

function SectionRef(sections::MachOSections, s::MachOSection, idx)
    return MachOSectionRef(sections, s, UInt32(idx))
end
deref(s::MachOSectionRef) = s.section
sections(s::MachOSectionRef) = s.sections
handle(s::MachOSectionRef) = handle(sections(s))
section_number(s::MachOSectionRef) = s.idx
@derefmethod is64bit(s::MachOSectionRef)

# # # Higher level debug info support
struct DebugSections{T<:ObjectHandle, S}
    oh::T
    debug_abbrev::Nullable{S}
    debug_aranges::Nullable{S}
    debug_frame::Nullable{S}
    debug_info::Nullable{S}
    debug_line::Nullable{S}
    debug_loc::Nullable{S}
    debug_macinfo::Nullable{S}
    debug_pubnames::Nullable{S}
    debug_ranges::Nullable{S}
    debug_str::Nullable{S}
    debug_types::Nullable{S}
end
handle(dbgs::DebugSections) = dbgs.oh

function DebugSections(oh::H; debug_abbrev = nothing, debug_aranges = nothing,
        debug_frame = nothing, debug_info = nothing, debug_line = nothing,
        debug_macinfo = nothing, debug_pubnames = nothing, debug_loc= nothing,
        debug_ranges = nothing, debug_str = nothing, debug_types = nothing) where {H <: ObjectHandle}
    # Build Section typeunion
    S = Union{map(typeof, [debug_abbrev, debug_aranges, debug_frame, debug_info,
        debug_line, debug_loc, debug_macinfo, debug_pubnames, debug_ranges,
        debug_str, debug_types])...}
    DebugSections{T,S}(oh, debug_abbrev, debug_aranges, debug_frame, debug_info,
        debug_line, debug_loc, debug_macinfo, debug_pubnames, debug_ranges,
        debug_str, debug_types)
end

function DebugSections(oh::H, sections::Dict) where {H <: ObjectHandle}
    DebugSections(oh,
        debug_abbrev = get(sections, "debug_abbrev", nothing),
        debug_aranges = get(sections, "debug_aranges", nothing),
        debug_frame = get(sections, "debug_frame", nothing),
        debug_info = get(sections, "debug_info", nothing),
        debug_line = get(sections, "debug_line", nothing),
        debug_loc = get(sections, "debug_loc", nothing),
        debug_macinfo = get(sections, "debug_macinfo", nothing),
        debug_pubnames = get(sections, "debug_pubnames", nothing),
        debug_ranges = get(sections, "debug_ranges", nothing),
        debug_str = get(sections, "debug_str", nothing),
        debug_types = get(sections, "debug_types", nothing))
end

const DEBUG_SECTIONS = [
    "debug_abbrev",
    "debug_aranges",
    "debug_frame",
    "debug_info",
    "debug_line",
    "debug_loc",
    "debug_macinfo",
    "debug_pubnames",
    "debug_ranges",
    "debug_str",
    "debug_types"]

function show(io::IO, dsect::DebugSections)
    println(io, "Debug Sections for $(dsect.oh)")
    println(io, "========================= debug_abbrev =========================")
    println(io, dsect.debug_abbrev)
    println(io, "======================== debug_aranges =========================")
    println(io,  dsect.debug_aranges)
    println(io, "========================= debug_frame ==========================")
    println(io, dsect.debug_frame)
    println(io, "========================= debug_info ===========================")
    println(io, dsect.debug_info)
    println(io, "========================= debug_line ===========================")
    println(io, dsect.debug_line)
    println(io, "========================== debug_loc ===========================")
    println(io, dsect.debug_loc)
    println(io, "======================== debug_macinfo =========================")
    println(io, dsect.debug_macinfo)
    println(io, "======================= debug_pubnames =========================")
    println(io, dsect.debug_pubnames)
    println(io, "======================== debug_ranges ==========================")
    println(io, dsect.debug_ranges)
    println(io, "=========================== debug_str ==========================")
    println(io, dsect.debug_str)
    println(io, "========================= debug_types ==========================")
    println(io, dsect.debug_types)
end

"""
    debugsections(oh::ObjectHandle)

Return list of sections needed for debug info within given `ObjectHandle`
"""
@mustimplement debugsections(oh::ObjectHandle)

abstract type Relocation{T<:ObjectHandle} end
abstract type RelocationRef{T<:ObjectHandle} end


struct LOIByName
    addrs::Dict{Symbol, UInt64}
end
function getSectionLoadAddress(LOI::LOIByName, x::Union{Symbol, AbstractString})
    return LOI.addrs[symbol(x)]
end
function getSectionLoadAddress(LOI::LOIByName, sec)
    return getSectionLoadAddress(LOI, bytestring(sectionname(sec)))
end

using ObjectFile, Base.BinaryPlatforms
using Test

@testset "basic" begin
    # Test that an empty file is a magic mismatch
    mktempdir() do dir
        fpath = joinpath(dir, "empty")
        touch(fpath)
        @test_throws MagicMismatch readmeta(fpath) do ohs
            @test false
        end
    end
end

function test_libfoo_and_fooifier(fooifier_path, libfoo_path)
    # Actually read it in
    oh_exe = only(readmeta(open(fooifier_path, "r")))
    oh_lib = only(readmeta(open(libfoo_path, "r")))

    # Tease out some information from the containing folder name
    dir_path = basename(dirname(libfoo_path))
    types = Dict(
        "linux" => ELFHandle,
        "mac" => MachOHandle,
        "win" => COFFHandle,
    )

    platform = dir_path[1:end-2]
    H = types[platform]
    bits = dir_path[end-1:end]

    platforms = Dict(
        "linux32" => Platform("i686", "linux"),
        "linux64" => Platform("x86_64", "linux"),
        "mac64" => Platform("x86_64", "macos"),
        "win32" => Platform("i686", "windows"),
        "win64" => Platform("x86_64", "windows"),
    )

    @testset "$(dir_path)" begin
        @testset "General Properties" begin
            for oh in (oh_exe, oh_lib)
                # Test that we got the right type
                @test typeof(oh) <: H

                # Test that we got the right number of bits
                @test is64bit(oh) == (bits == "64")
                @test platforms_match(Platform(oh), platforms[dir_path])

                # Everything is always little endian
                @test endianness(oh) == :LittleEndian
            end

            # None of these are .o files
            @test !isrelocatable(oh_exe)
            @test !isrelocatable(oh_lib)

            # Ensure these are the kinds of files we thought they were
            @test isexecutable(oh_exe)
            @test islibrary(oh_lib)
            @test isdynamic(oh_exe) && isdynamic(oh_lib)
        end


        @testset "Dynamic Linking" begin
            # Ensure that `dir_path` is one of the RPath entries
            rpath = RPath(oh_exe)
            can_paths = canonical_rpaths(rpath)
            @test abspath(dir_path * Base.Filesystem.path_separator) in can_paths

            # Ensure that `fooifier` is going to try to load `libfoo`:
            foo_libs = find_libraries(oh_exe)
            @test !isempty(foo_libs)
            @test abspath(libfoo_path) in values(foo_libs)
        end

        # Ensure that `foo()` is referenced in both, defined in `libfoo`, and
        # not defined in `fooifier`.  Also ensure that `_main` is defined in
        # `fooifier` and is not present in `libfoo`.
        @testset "Symbols" begin
            syms_exe = collect(Symbols(oh_exe))
            syms_lib = collect(Symbols(oh_lib))

            syms_names_exe = symbol_name.(syms_exe)
            syms_names_lib = symbol_name.(syms_lib)

            # ELF stores the symbol name as "foo", MachO stores it as "_foo"
            foo_sym_name = mangle_symbol_name(oh_exe, "foo")
            main_sym_name = mangle_symbol_name(oh_exe, "main")

            @test foo_sym_name in syms_names_exe
            @test foo_sym_name in syms_names_lib
            @test main_sym_name in syms_names_exe
            @test !(main_sym_name in syms_names_lib)

            foo_idx_exe = findfirst(syms_names_exe .== foo_sym_name)
            main_idx_exe = findfirst(syms_names_exe .== main_sym_name)
            foo_idx_lib = findfirst(syms_names_lib .== foo_sym_name)

            @test foo_idx_exe != 0
            @test main_idx_exe != 0
            @test foo_idx_lib != 0

            # definedness doesn't seem to be for COFF files...
            if !isa(oh_exe, COFFHandle)
                @test isundef(syms_exe[foo_idx_exe])
                @test !isundef(syms_exe[main_idx_exe])
                @test !isundef(syms_lib[foo_idx_lib])
            end

            @test !islocal(syms_exe[foo_idx_exe])
            @test !islocal(syms_exe[main_idx_exe])
            @test !islocal(syms_lib[foo_idx_lib])

            # Global detection doesn't seem to be working on OSX...
            if !isa(oh_exe, MachOHandle)
                @test isglobal(syms_exe[foo_idx_exe])
                @test isglobal(syms_exe[main_idx_exe])
                @test isglobal(syms_lib[foo_idx_lib])
            end
        end

        @testset "Printing" begin
            # Print out to an IOContext that will limit long lists
            io = IOContext(stdout, :limit => true)

            # Helper that shows the type, then the value:
            function tshow(x)
                type_name = typeof(x).name.name
                println(io, "INFO: Showing $(type_name)")
                show(io, x)
                print(io, "\n")
            end

            # Show printing of a Handle
            tshow(oh_lib)

            # Test showing of the header
            tshow(header(oh_lib))

            # Test showing of Sections
            sects = Sections(oh_exe)
            tshow(sects)
            tshow(sects[1])

            # Test showing of Segments on non-COFF
            if !isa(oh_exe, COFFHandle)
                segs = Segments(oh_lib)
                tshow(segs)
                tshow(segs[1])
            end

            # Test showing of Symbols
            syms = Symbols(oh_exe)
            tshow(syms)
            tshow(syms[1])

            # Test showing of RPath and DynamicLinks
            rpath = RPath(oh_exe)
            tshow(rpath)

            dls = DynamicLinks(oh_exe)
            tshow(dls)
            tshow(dls[1])
        end
    end
end

function test_fat_libfoo(file)
    ohs = readmeta(open(file, "r"))
    @test isa(ohs, FatMachOHandle)
    @test length(ohs) == 2
    ntotal, n64 = 0, 0
    for oh in ohs
        ntotal += 1
        n64 += is64bit(oh)
    end
    @test ntotal == 2
    @test n64 == 1
end

function test_metal(file)
    ohs = readmeta(open(file, "r"))
    @test isa(ohs, FatMachOHandle)
    @test length(ohs) == 2

    let oh = ohs[1]
        @test oh.header isa MachO.MachOHeader64
        @test findfirst(Sections(oh), "__TEXT,__compute") !== nothing
    end

    let oh = ohs[2]
        @test oh.header isa MachO.MetallibHeader
    end
end

# Run ELF tests
test_libfoo_and_fooifier("./linux32/fooifier", "./linux32/libfoo.so")
test_libfoo_and_fooifier("./linux64/fooifier", "./linux64/libfoo.so")

# Run MachO tests
test_libfoo_and_fooifier("./mac64/fooifier", "./mac64/libfoo.dylib")
test_fat_libfoo("./mac64/libfoo_fat.dylib")
test_metal("./macmetal/dummy")

# Run COFF tests
test_libfoo_and_fooifier("./win32/fooifier.exe", "./win32/libfoo.dll")
test_libfoo_and_fooifier("./win64/fooifier.exe", "./win64/libfoo.dll")


# Ensure that ELF version stuff works
@testset "ELF Version Info Parsing" begin
    using ObjectFile.ELF

    # Assuming the version structs in the file are correct, test that we read
    # them correctly (and calculate hashes correctly).
    function check_verdef(v::ELF.ELFVersionEntry)
        @test v.ver_def.vd_version == 1
        @test v.ver_def.vd_cnt == length(v.names)
        if length(v.names) > 0
            @test v.ver_def.vd_hash == ELFHash(Vector{UInt8}(v.names[1]))
        end
    end
    function check_verneed(v::ELF.ELFVersionNeededEntry)
        @test v.ver_need.vn_version == 1
        @test v.ver_need.vn_cnt == length(v.auxes) == length(v.names)
        for i in 1:length(v.names)
            @test v.auxes[i].vna_hash == ELFHash(Vector{UInt8}(v.names[i]))
        end
    end

    libstdcxx_path = "./linux64/libstdc++.so.6"

    # Extract all pieces of `.gnu.version_d` from libstdc++.so, find the `GLIBCXX_*`
    # symbols, and use the maximum version of that to find the GLIBCXX ABI version number
    readmeta(libstdcxx_path) do ohs
        oh = only(ohs)
        verdef_symbols = unique(vcat((x -> x.names).(ELFVersionData(oh))...))
        verdef_symbols = filter(x -> startswith(x, "GLIBCXX_"), verdef_symbols)
        max_version = maximum([VersionNumber(split(v, "_")[2]) for v in verdef_symbols])
        @test max_version == v"3.4.25"
    end

    for p in ["./linux32/fooifier", "./linux32/libfoo.so",
              "./linux64/fooifier", "./linux64/libfoo.so",
              "./linux64/libstdc++.so.6"]
        readmeta(p) do ohs
            oh = only(ohs)
            foreach(check_verdef, ELFVersionData(oh))
            foreach(check_verneed, ELFVersionNeededData(oh))
        end
    end

end

# Ensure that these tricksy win32 files work
@testset "git win32 problems" begin
    # Test that 6a66694a8dd5ca85bd96fe6236f21d5b183e7de6 fix worked
    libmsobj_path = "./win32/msobj140.dll"

    dynamic_links = readmeta(libmsobj_path) do ohs
        oh = only(ohs)
        path.(DynamicLinks(oh))
    end

    @test "KERNEL32.dll" in dynamic_links
    @test "api-ms-win-crt-heap-l1-1-0.dll" in dynamic_links
    @test "api-ms-win-crt-convert-l1-1-0.dll" in dynamic_links
    @test "api-ms-win-crt-runtime-l1-1-0.dll" in dynamic_links

    whouses_exe = "./win32/WhoUses.exe"
    dynamic_links = readmeta(whouses_exe) do ohs
        oh = only(ohs)
        path.(DynamicLinks(oh))
    end

    @test "ADVAPI32.dll" in dynamic_links
    @test "KERNEL32.dll" in dynamic_links
    @test "libstdc++-6.dll" in dynamic_links
end

using Mmap
@testset "Finding dep_libs" begin
    function find_dep_libs(file)
        obj = only(readmeta(open(file, "r")))
        syms = collect(Symbols(obj))
        syms_names = symbol_name.(syms)
        sym = syms[findfirst(syms_names .== mangle_symbol_name(obj, "dep_libs"))]
        offset = symbol_offset(sym)
        filem = Mmap.mmap(file)
        data = String(filem[offset: (offset + 255)])
        @test contains(data, "libjulia-internal")
        @test contains(data, "libjulia-codegen")
        @test contains(data, "libopenlibm")
    end
    for file in readdir("./libjulias")
        find_dep_libs(joinpath("./libjulias", file))
    end
end

using Base.Meta
export @mustimplement, @derefmethod, @constants,
       read_struct, getindex_ref

"""
    @mustimplement

Macro to create fallthrough implementations of basic functions such as
`readheader(oh::ObjectHandle)`; these fallthrough implementations are meant to
be overridden by methods in packages such as `ELF.jl` or `MachO.jl`.
"""
macro mustimplement(sig)
    # Get information about the signature, including the type of the first
    # argument, which is typically the name of the relevant object.
    fname = sig.args[1]
    arg1 = sig.args[2]
    if isa(arg1, Expr)
        arg1 = arg1.args[1]
    end

    # Generate a method that just gives an error
    return quote
        $(esc(sig)) = error(typeof($(esc(arg1))), " must implement $($(fname))")
    end
end

"""
    @derefmethod

Macro to create a method that works on a reference type by generating a wrapper
call to `deref(x)` where `x` is the first argument in the call.  Example:

    @derefmethod foo(x::SectionRef)

Will generate the following code:

    foo(x::SectionRef, args...) = foo(deref(x), args...)
"""
macro derefmethod(sig)
    # Given an Expression, continually unwrap `:where` expressions
    function unwrap_where(e)
        while e.head == :where
            e = e.args[1]
        end
        return e
    end

    # Given an Expression, wrap it in `:where` expressions so that it has
    # the same UnionAll-ness as the original expression
    function rewrap_where(e, orig_e)
        if orig_e.head == :where
            e = rewrap_where(e, orig_e.args[1])
            e = Expr(:where, e, orig_e.args[2])
        end
        return e
    end

    # Get information from the method like the name of the first argument.
    func_sig = unwrap_where(sig)
    fname = func_sig.args[1]
    x_arg = func_sig.args[2]

    if isa(x_arg, Expr) && x_arg.head == :(::)
        x_arg = x_arg.args[1]
    end

    # Generate a method that calls another method with the same name, but with
    # the first argument passed through `deref()` first. Preserve UnionAll-ness
    # by recreating it, if necessary:
    lhs = :($(fname)($(func_sig.args[2]), args...))
    rhs = :($(fname)(deref($(x_arg)), args...))
    return esc(:($(rewrap_where(lhs, sig)) = $(rhs)))
end


"""
    @constants

Macro to create intelligent enum arrays in Julia.  Defines not only variables
mapping names to values within Julia, but also a dictionary mapping those
values back to a string representation of the variable names itself.
"""
macro constants(array, stripprefix, expr)
    # We will build up a chunk of code, we'll call that `ret`
    ret = Expr(:block)

    # Initialize the name lookup array
    push!(ret.args,:(const $array = Dict{UInt32,String}()))

    for e in expr.args
        # If it's not a `const` expression, skip it
        if !isexpr(e,:const)
            continue
        end
        
        # Ensure this `const` expression is assigning something
        eq = e.args[1]
        @assert isexpr(eq,:(=))

        # Strip out the prefix so our names are more interesting
        name = string(eq.args[1])
        name = replace(name, stripprefix => "", count=1)

        # Define the value, then slip its stripped prefix name into the name
        # lookup array right afterwards.
        push!(ret.args,e)
        push!(ret.args,:($array[UInt32($(eq.args[1]))] = $name))
    end

    # Return `ret`, the chunk of code we've built up
    return esc(ret)
end

"""
    read_struct(oh, type_func, size_func, name)

Given a `Type`, (such as `ELFSection64`), `unpack()` it from the given object
and return it, throwing errors as appropriate, and skipping over any excess
padding bytes as determined by `type_func` and `size_func`. Example invocation:

read_struct(oh, symtab_entry_type, symtab_entry_size, "Symbol Entry")
"""
function read_struct(oh, type_func, size_func, name)
    # Get calculated types and sizes
    ST = type_func(oh)
    max_size = size_func(oh)

    # Get the size of the object we're going to read in in memory
    calc_size = Core.sizeof(ST)

    # If that's larger than what the ELF object has, fail out
    if calc_size > max_size
        msg = strip("""
        Reported $(name) size ($(max_size) is smaller
        than calculated $(name) size ($(calc_size))
        """)
        error(replace(msg, "\n" => " "))
    end

    # If it's less than or equal to, read it in, then skip past extra data we
    # don't care about (future extensions to the ELF format, for instance)
    val = unpack(oh, ST)
    skip(oh, max_size - calc_size)

    # Return our ill-gotten goods
    return val
end


"""
    getindex_ref(collection, offset, stride, T, ref_type, idx)

Given a `collection`, such as `Sections`, `DynamicLinks`, etc... use the given
`offset`, `stride`, and `T` parameters to read in and construct a `ref_type`
object located at index `idx`.  Example invocation:

    getindex_ref(
        sections,
        section_header_offset(oh),
        section_header_size(oh),
        section_header_type(oh),
        SectionRef,
        idx
    )
"""
function getindex_ref(collection, offset, stride, T, ref_type, idx)
    # Ensure we're within the correct range
    if !(0 < idx <= length(collection))
        throw(BoundsError(collection, idx))
    end
    
    # If we are, seek, read it in, and return
    oh = handle(collection)
    seek(oh, offset + (idx-1)*stride)
    val = unpack(oh, T)

    # Return a SectionRef, as that's the more general object
    return ref_type(collection, val, idx)
end

export COFFSymbols, COFFSymtabEntry, COFFSymbolRef

"""
    COFFSymbols

COFF symbol table, contains the list of symbols defined within the object file.

Note that because COFF Symbols are variable-length, we store a table of offsets
at which the (non-auxilliary) symbols can be found.
"""
struct COFFSymbols{H<:COFFHandle} <: Symbols{H}
    handle::H
    symbol_offsets::Vector{UInt64}
end

"""
    scan_symbol_offsets(oh::COFFHandle)

Find the offsets for each Symbol within a COFFHandle, skipping over auxilliary
symbols as necessary.
"""
function scan_symbol_offsets(oh::H) where {H <: COFFHandle}
    # num_syms represents the number of total symbols, but we're only
    # interested in the non-auxiliary symbols
    num_syms = num_symbols(header(oh))
    offsets = UInt64[]

    curr_idx = 1
    idx = 1
    while idx < num_syms
        # Load in the next symbol and store its offset
        seek(oh, symtab_entry_offset(oh) + symtab_entry_size(oh)*(idx-1))

        sym = unpack(oh, COFFSymtabEntry{H})
        push!(offsets, idx)

        # Move our offset forward by 1 (because we just read in a SymtabEntry)
        # and again as many times as needed to skip over the auxilliary symbols
        idx += 1 + sym.NumberOfAuxSymbols
        curr_idx += 1
    end

    return offsets
end

function Symbols(oh::H) where {H <: COFFHandle}
    symbol_offsets = scan_symbol_offsets(oh)
    return COFFSymbols(oh, symbol_offsets)
end

handle(syms::COFFSymbols) = syms.handle
# function next(syms::COFFSymbols, idx)
#     # We skip over auxiliary symbols here
#     next_idx = idx + deref(syms[idx]).NumberOfAuxSymbols + 1
#     return (syms[idx], next_idx)
# end
lastindex(syms::COFFSymbols) = num_symbols(header(handle(syms)))

# We override `iteratorsize` so that list comprehensions and collect() calls on
# our Symbols don't have a bunch of #undef entries at the end of the array
# because it tries to pre-allocate an array of the proper size.
# iteratorsize(::Type{H}) where {H <: COFFSymbols} = SizeUnknown()

@io struct COFFSymtabEntry{H <: COFFHandle} <: SymtabEntry{H}
    Name::fixed_string{UInt64}
    Value::UInt32
    SectionNumber::Int16
    Type::UInt16
    StorageClass::UInt8
    NumberOfAuxSymbols::UInt8
end align_packed

function symbol_name(sym::COFFSymtabEntry)
    # COFF Symbols set the first four bytes of the name to zero to signify a
    # name that must be looked up in the string table
    if (sym.Name.data & 0xffffffff) == 0
        return string("strtab@", (sym.Name.data >> 32))
    end
    return unsafe_string(sym.Name)
end

symbol_value(sym::COFFSymtabEntry) = sym.Value
symbol_type(sym::COFFSymtabEntry) = sym.Type
function isundef(sym::COFFSymtabEntry)
    sym.StorageClass in (
        IMAGE_SYM_CLASS_EXTERNAL_DEF,
        IMAGE_SYM_CLASS_UNDEFINED_LABEL,
        IMAGE_SYM_CLASS_UNDEFINED_STATIC) ||
    (sym.StorageClass == IMAGE_SYM_CLASS_EXTERNAL &&
     sym.SectionNumber == IMAGE_SYM_CLASS_NULL)
end
isglobal(sym::COFFSymtabEntry) = isundef(sym) || sym.StorageClass == IMAGE_SYM_CLASS_EXTERNAL
islocal(sym::COFFSymtabEntry) = !isglobal(sym)
isweak(sym::COFFSymtabEntry) = sym.StorageClass == IMAGE_SYM_CLASS_WEAK_EXTERNAL


"""
    COFFSymbolRef

Contains a reference to an `COFFSymtabEntry`, as well as an `COFFSymbols`, etc...
"""
struct COFFSymbolRef{H<:COFFHandle} <: SymbolRef{H}
    syms::COFFSymbols{H}
    entry::COFFSymtabEntry{H}
    idx::UInt32
end
function SymbolRef(syms::COFFSymbols, entry::COFFSymtabEntry, idx)
    return COFFSymbolRef(syms, entry, UInt32(idx))
end

deref(sym::COFFSymbolRef) = sym.entry
Symbols(sym::COFFSymbolRef) = sym.syms
symbol_number(sym::COFFSymbolRef) = sym.idx
symbol_section(sym::COFFSymbolRef) = Sections(handle(sym))[deref(sym).SectionNumber]
@derefmethod symbol_type(sym::COFFSymbolRef)
function symbol_name(sym::COFFSymbolRef)
    # COFF Symbols set the first four bytes of the name to zero to signify a
    # name that must be looked up in the string table
    name = deref(sym).Name
    if (name.data & 0xffffffff) == 0
        # If it's zeroes all the way down, just return an empty string
        if name.data == 0
            return ""
        end
        return strtab_lookup(StrTab(handle(sym)), (name.data >> 32))
    end
    return unsafe_string(name)
end

function symbol_offset(sym::COFFSymbolRef)
    # Return the offset into the file that this symbol refers to
    return symbol_value(sym) + section_offset(symbol_section(sym))
end

# Symbol printing stuff
"""
    symbol_type_string(s::COFFSymtabEntry)

Return the given `COFFSymtabEntry`'s section type as a string.
"""
function symbol_type_string(sym::COFFSymtabEntry)
    global IMAGE_SYM_TYPE

    # fast-track a zero symbol type
    if sym.Type == 0
        return ""
    end

    # We have to construct a compound type string here
    type_string = ""

    # We start with the "derived" type, e.g. pointer, array, etc...
    dtype = (sym.Type & 0xf0) >> 4
    if haskey(IMAGE_SYM_DTYPE, dtype)
        type_string = string("(", IMAGE_SYM_DTYPE[dtype], ")")
    end

    # Then, move on to the "base" type, e.g. void, char, short...
    btype = sym.Type & 0x0f
    if haskey(IMAGE_SYM_TYPE, btype)
        type_string = "$(type_string) $(IMAGE_SYM_TYPE[btype])"
    end

    # If we didn't get ANY info, complain
    if isempty(type_string)
        string("Unknown Symbol Type (0x", string(sym.Type, base=16), ")")
    end

    return type_string
end
@derefmethod symbol_type_string(s::COFFSymbolRef)

using Documenter, ObjectFile

makedocs(modules = [ObjectFile],
         sitename = "ObjectFile.jl",
         pages = [
            "Home" => "index.md"
         ]
)

deploydocs(
    repo = "github.com/staticfloat/ObjectFile.jl.git",
    target = "build"
)

export ELFSymbols, ELFSymtabEntry, ELFSymtabEntry64, ELFSymtabEntry32, ELFSymbolRef

"""
    ELFSymbols

ELF symbol table, contains the list of symbols defined within the object file.
"""
struct ELFSymbols{H<:ELFHandle} <: Symbols{H}
    section_ref::SectionRef{H}
end

function Symbols(section::SectionRef{H}) where {H <: ELFHandle}
    return ELFSymbols(section)
end

"""
    Symbols(oh::ELFHandle)

Return the `ELFSymbols` object that is contained within the first `.dynsym` or
`.symtab` section within the ELF object.
"""
function Symbols(oh::H) where {H <: ELFHandle}
    sections = Sections(oh)
    # First, try to load `.symtab`.  If we can't load that guy, we'll fall back
    # to `.dynsym` which has less information, but is more likely to exist.
    dyn_sections = findall(sections, ".symtab")
    if !isempty(dyn_sections)
        return ELFSymbols(first(dyn_sections))
    end

    dyn_sections = findall(sections, ".dynsym")
    if !isempty(dyn_sections)
        return ELFSymbols(first(dyn_sections))
    end
    error("Could not find a .dynsym or .symtab section in object file")
end

"""
    Section(syms::ELFSymbols)

Return the `Section` that contains this ELF symbol table.
"""
Section(syms::ELFSymbols) = syms.section_ref
handle(syms::ELFSymbols) = handle(Section(syms))
symtab_entry_type(syms::ELFSymbols) = symtab_entry_type(handle(syms))

function lastindex(syms::ELFSymbols{H}) where {H <: ELFHandle}
    sect_size = section_size(Section(syms))
    sym_size = sizeof(symtab_entry_type(syms))
    return div(sect_size, sym_size)
end


# Add an StrTab() override to be able to load the symbol string table
"""
    StrTab(syms::ELFSymbols)

Given an ELF `Symbols` container, construct an `ELFStrTab` that refers to the
associated symbol string table.
"""
function StrTab(syms::ELFSymbols{H}) where {H <: ELFHandle}
    # The `sh_link` field in a symbol section always points to the symbol table
    section_idx = deref(Section(syms)).sh_link+1
    strtab_section = Sections(handle(syms))[section_idx]
    return ELFStrTab{H}(strtab_section)
end



"""
    ELFSymtabEntry

ELF Symtab Entry type, contains the data relevant to a symbol defined within
this ELF file, garnered from the symbol table (symtab)
"""
abstract type ELFSymtabEntry{H <: ELFHandle} <: SymtabEntry{H} end

@io struct ELFSymtabEntry32{H <: ELFHandle} <: ELFSymtabEntry{H}
    st_name::UInt32
    st_value::UInt32
    st_size::UInt32
    st_info::UInt8
    st_other::UInt8
    st_shndx::UInt16
end

@io struct ELFSymtabEntry64{H <: ELFHandle} <: ELFSymtabEntry{H}
    st_name::UInt32
    st_info::UInt8
    st_other::UInt8
    st_shndx::UInt16
    st_value::UInt64
    st_size::UInt64
end

function read(oh::ELFHandle, ::Type{ST}) where {ST <: ELFSymtabEntry}
    type_func = symtab_entry_type
    size_func = symtab_entry_size
    return read_struct(oh, type_func, size_func, "Symbol Entry")
end


# Define two helper functions that return ELF-specific symbol infos
st_bind(st_info::UInt8) = st_info >> 4
st_type(st_info::UInt8) = st_info & 0xf

# Define helper functions to detect symbols marked as "reserved"
function isreserved(sym::ELFSymtabEntry)
    return SHN_LORESERVE <= sym.st_shndx <= SHN_HIRESERVE
end

symbol_name(sym::ELFSymtabEntry) = string("strtab@", sym.st_name)
symbol_value(sym::ELFSymtabEntry) = sym.st_value
isundef(sym::ELFSymtabEntry) = (sym.st_shndx == SHN_UNDEF)
isglobal(sym::ELFSymtabEntry) = (st_bind(sym.st_info) & STB_GLOBAL) != 0
islocal(sym::ELFSymtabEntry) = !isglobal(sym)
isweak(sym::ELFSymtabEntry) = (st_bind(sym.st_info) & STB_WEAK) != 0


"""
    ELFSymbolRef

Contains a reference to an `ELFSymtabEntry`, as well as an `ELFSymbols`, etc...
"""
struct ELFSymbolRef{H<:ELFHandle} <: SymbolRef{H}
    syms::ELFSymbols{H}
    entry::ELFSymtabEntry{H}
    idx::UInt32
end
function SymbolRef(syms::ELFSymbols, entry::ELFSymtabEntry, idx)
    return ELFSymbolRef(syms, entry, UInt32(idx))
end

deref(sym::ELFSymbolRef) = sym.entry
Symbols(sym::ELFSymbolRef) = sym.syms

@derefmethod isreserved(sym::ELFSymbolRef)
symbol_number(sym::ELFSymbolRef) = sym.idx
function symbol_name(sym::ELFSymbolRef)
    # We look up the symbol name in the linked string table for this particular section
    strtab = StrTab(Symbols(sym))
    return strtab_lookup(strtab, deref(sym).st_name)
end
# Helper function to get the section a symbol refers to
symbol_section(sym::ELFSymbolRef) = Sections(handle(sym))[deref(sym).st_shndx + 1]

function symbol_value(sym::ELFSymbolRef)
    # First, grab the actual `st_value` entry from the SymtabEntry
    value = symbol_value(deref(sym))

    # If the given symbol is defined, and is not reserved
    if !isundef(sym) && !isreserved(sym)
        # Grab the address of the section this symbol refers to
        sh_addr = section_address(symbol_section(sym))

        # What to do next depends on the object kind. Shared libraries and
        # executable's st_value's are virtual addresses
        e_type = header(handle(sym)).e_type

        # If this is a plain relocatable file (`.o` file) just increment by
        # section address
        if sh_addr != 0 && e_type == ET_REL
            value += sh_addr
        end

        # If this is an executable or dynamic library
        if e_type in (ET_EXEC, ET_DYN)
            # Subtract off the virtual address of the first PT_LOAD segment
            P = [s for s in Segments(handle(sym)) if segment_type(s) == PT_LOAD]
            if !isempty(P)
                value -= segment_virtual_address(first(P))
            end
        end
    end

    # Return our ill-gotten goods
    return value
end

function symbol_offset(sym::ELFSymbolRef)
    addr = symbol_value(sym)
    sect = symbol_section(sym)
    virtual_offset =  section_address(sect) - section_offset(sect)
    return addr - virtual_offset
end

# JIT Utils

"""
    is_jit_section(section::Section)

Returns `true` if the given section is detected to be a JIT'ed section, e.g. if
its `sectionaddress` is preposterously high, such as over `0x100000`.
"""
function is_jit_section(section::Section)
    return sectionaddress(section) > 0x100000
end
@derefmethod is_jit_section(s::SectionRef)

"""
    replace_sections(oh::ObjectHandle, new_buffer)

Allows the direct reading of JIT sections into a buffer
"""
function replace_sections(oh::T, new_buffer) where {T <: ObjectHandle}
    for sec in Sections(oh)
        if ObjFileBase.is_jit_section(sec)
            seek(new_buffer,sectionoffset(sec))
            write(new_buffer,pointer_to_array(
                reinterpret(Ptr{UInt8},sectionaddress(sec)),
                sectionsize(sec),false))
        end
    end
    seekstart(new_buffer)
    new_buffer
end

# Export Mach-O specific stuff that is useful
export MachOLoadCmd, MachOLoadCmdHeader, MachOLoadCmds, MachOLoadCmdRef


"""
    MachOLoadCmdHeader

All MachO Load Commands have a common header, containing information about what
kind of Load Command it is, and how large the load command is.
"""
@io struct MachOLoadCmdHeader{H <: MachOHandle}
    cmd::UInt32
    cmdsize::UInt32
end


"""
    MachOLoadCmd

Abstraction over all Load Commands that can exist within a Mach-O object file,
containing subclasses such as `MachOSegmentCmd` or `MachODySymtabCmd`.
The list of available API operations is given below, with methods that
subclasses must implement marked in emphasis:

### Creation
  - MachOLoadCmd()
"""
abstract type MachOLoadCmd{H <: MachOHandle} end


"""
    MachOLoadCmd(oh::MachOHandle, CT::Type, header)

Construct a `MachOLoadCmd` from the given `MachOHandle`, constructing an object
of type `CT` (which can be calculated via `load_cmd_type(header)`, but is
explicitly passed to `MachOLoadCmd()` for dispatch purposes).
"""
function MachOLoadCmd(oh::MachOHandle, CT::Type, header)
    # In general, just unpack the type
    return unpack(oh, CT)
end



"""
    MachOLoadCmds

Allows iteration over the LoadCmds within a Mach-O file.

### Creation
  - MachOLoadCmds()

### Iteration
  - getindex()
  - lastindex()
  - iterate()
  - keys()
  - length()
  - eltype()

### Access
  - find

### Convenience constructors
  - Segments()
"""
struct MachOLoadCmds{H <: MachOHandle}
    handle::H
    headers::Vector{MachOLoadCmdHeader{H}}
    cmds::Vector{MachOLoadCmd{H}}
    positions::Vector{UInt32}
end

"""
    MachOLoadCmdRef

Datatype containing a Mach-O Load Command, its header, and a reference back to
the `MachOLoadCmds` object it was garnered from
"""
struct MachOLoadCmdRef{H <: MachOHandle, C <: MachOLoadCmd{H}}
    lcs::MachOLoadCmds{H}
    header::MachOLoadCmdHeader{H}
    cmd::C
    position::UInt32
end

MachOLoadCmds(lcr::MachOLoadCmdRef) = lcr.lcs
handle(lcr::MachOLoadCmdRef) = handle(MachOLoadCmds(lcr))
header(lcr::MachOLoadCmdRef) = lcr.header
deref(lcr::MachOLoadCmdRef) = lcr.cmd
position(lcr::MachOLoadCmdRef) = lcr.position
seek(lcr::MachOLoadCmdRef) = seek(handle(lcr), position(lcr))
type_str(cmd::MachOLoadCmdRef) = load_cmd_type_string(header(cmd))


include("LoadCmds/UnknownCmd.jl")
include("LoadCmds/DylibCmds.jl")
include("LoadCmds/SegmentCmds.jl")
include("LoadCmds/SymtabCmds.jl")

function show(io::IO, cmd::MachOLoadCmd)
    print(io, "MachOLoadCmd")
end

function show(io::IO, cmd::MachOLoadCmdRef)
    print(io, "MachOLoadCmd $(type_str(cmd))")
end

"""
    MachOLoadCmds(oh::MachOHandle)

Load the set of Mach-O Load Commands from the given object handle.
"""
function MachOLoadCmds(oh::H) where {H <: MachOHandle}
    # These are the cmds we will read in
    headers = MachOLoadCmdHeader{H}[]
    cmds = MachOLoadCmd{H}[]
    positions = UInt32[]

    # Begin by seeking to the header offset
    seek(oh, sizeof(header(oh)))

    for idx in 1:header(oh).ncmds
        # Unpack each load command.  First, read in the header:
        cmd_header = unpack(oh, MachOLoadCmdHeader{H})

        # Examine its type, and proceed to unpack the rest of the command
        cmd_pos = position(oh)
        next_cmd_pos = cmd_pos + load_cmd_size(cmd_header)
        cmd = MachOLoadCmd(oh, load_cmd_type(cmd_header), cmd_header)

        # We do this because commands are variable-size and sometimes we don't
        # actually read the whole thing.
        seek(oh, next_cmd_pos)

        push!(headers, cmd_header)
        push!(cmds, cmd)
        push!(positions, cmd_pos)
    end

    return MachOLoadCmds(oh, headers, cmds, positions)
end

handle(lcs::MachOLoadCmds) = lcs.handle
header(lcs::MachOLoadCmds) = header(handle(lcs))

# Iteration
keys(lcs::MachOLoadCmds) = 1:length(lcs)
iterate(lcs::MachOLoadCmds, idx=1) = idx > length(lcs) ? nothing : (lcs.cmds[idx], idx+1)
lastindex(lcs::MachOLoadCmds) = lastindex(lcs.cmds)
length(lcs::MachOLoadCmds) = length(lcs.cmds)
eltype(::Type{S}) where {S <: MachOLoadCmds} = MachOLoadCmdRef
function getindex(l::MachOLoadCmds, idx)
    return MachOLoadCmdRef(l, l.headers[idx], l.cmds[idx], l.positions[idx])
end

# Searching
"""
    findall(lcs::MachOLoadCmds, lc_types::Vector{Type})

Given a list of `Type`s, filter out all load commands within `lcs` that are not
of that type.  This method returns a `Vector` of `MachOLoadCmdRef` objects,
containing only load commands that are of the requested types.  For example, to
find all segments within a file:

    findall(MachOLoadCmds(oh), [MachOSegmentCmd])
"""
function findall(lcs::MachOLoadCmds, lc_types::Vector{T}) where {T <: Type}
    indices = Integer[]
    for idx in 1:length(lcs.cmds)
        if any(typeof(lcs.cmds[idx]) <: lct for lct in lc_types)
            push!(indices, idx)
        end
    end

    # Return a new MachOLoadCmds object, that has those headers defined within it
    return [lcs[idx] for idx in indices]
end
findall(lcs::MachOLoadCmds, lc_type::T) where {T <: Type} = findall(lcs, [lc_type])


function load_cmd_type(header::MachOLoadCmdHeader{H}) where {H <: MachOHandle}
    type_mapping = Dict(
        LC_SEGMENT => MachOSegment32Cmd{H},
        LC_SEGMENT_64 => MachOSegment64Cmd{H},
        LC_LOAD_DYLIB => MachOLoadDylibCmd{H},
        LC_ID_DYLIB => MachOIdDylibCmd{H},
        LC_RPATH => MachORPathCmd{H},
        LC_SYMTAB => MachOSymtabCmd{H},
    )

    # We drop LC_REQ_DYLD from the flags because we don't care
    return get(type_mapping, header.cmd & ~LC_REQ_DYLD, MachOUnknownCmd{H})
end

function load_cmd_type_string(header::MachOLoadCmdHeader{H}) where {H <: MachOHandle}
    global LCTYPES

    if haskey(LCTYPES, header.cmd)
        return LCTYPES[header.cmd]
    end
    return string("Unknown Type (0x", string(header.cmd, base=16), ")")
end

"""
    load_cmd_size(header::MachOLoadCmdHeader)

Return the size, in bytes, of the referred `MachOLoadCmd`, not counting the
space for the header itself.
"""
function load_cmd_size(header::MachOLoadCmdHeader{H}) where {H <: MachOHandle}
    return header.cmdsize - packed_sizeof(MachOLoadCmdHeader{H})
end

function show(io::IO, lcs::MachOLoadCmds)
    print(io, "MachO Load Commands")
    for lc in lcs
        print(io, "\n  ")
        show(io, lc)
    end
end

"""
    unpack_lcstr(oh::MachOHandle, offset, max_size)

Given a Load Command STRing located `offset` bytes ahead in the current file,
and ending no more than `max_size` bytes ahead, read it in and return it as a
Julia-native `String`.  If the given offset is bad in some way (it is negative,
or begins beyond the end of `max_size`) an error string is returned.
"""
function unpack_lcstr(oh::H, offset, max_size) where {H <: MachOHandle}
    # Perform sanity checking on offset; if it is too small or too large,
    # don't try to read the lc_str, just assign it "<lc_str offset corrupt>"
    if offset >= 0 && offset < max_size
        # Skip ahead to the given offset
        skip(oh, offset)

        # Read in the cstring
        return unsafe_string(oh, max_size - offset)
    else
        # If we are outside the bounds, (either the string begins in the middle
        # of the rest of the struct, or it begins outside of this load command)
        # do not attempt to automatically read it
        return "<lc_str offset corrupt>"
    end
end

# Export ObjectHandle API
export ObjectHandle,
       readmeta,
       seek, seekstart, skip, iostream, position, read, readuntil, eof,
       endianness, is64bit, isrelocatable, isexecutable, islibrary, isdynamic,
       mangle_section_name, mangle_symbol_name, handle, header, format_string,
       section_header_offset, section_header_size, section_header_type,
       segment_header_offset, segment_header_size, segment_header_type,
       symtab_entry_offset, symtab_entry_size, symtab_entry_type,
       path, find_library, find_libraries

export MagicMismatch

# Import methods for extension
import Base: seek, seekstart, skip, position, read, readuntil, eof,
             getindex
import Base.Sys: isexecutable
import StructIO: unpack

"""
    ObjectHandle

The basic type that provides access to object files.  The list of available API
operations is given below, with methods that subclasses must implement marked
in emphasis.  Note tha "must implement" is a bit of a misnomer, if an Object
file does not have need of a certain piece of this API (e.g. `COFF` files have
no concept of `Segment`s), leaving that chunk of the API undefined will simply
cause errors if a user attempts to use methods that use that part of the API
(in the example above, an error will be thrown if the user calls `Segments(oh)`
where `oh <: COFFHandle`).

### Creation
  - *readmeta()*

### IOStream-like operations:
  - seek()
  - seekstart()
  - skip()
  - startaddr()
  - iostream()
  - position()
  - read()
  - readuntil()
  - eof()
  - unpack()

### Format-specific properties
  - *Platform()*
  - *endianness()*
  - *is64bit()*
  - *isrelocatable()*
  - *isexecutable()*
  - *islibrary()*
  - *isdynamic()*
  - *mangle_section_name()*
  - *mangle_symbol_name()*
  - handle()
  - *header()*
  - *format_string()*

### Section properties
  - *section_header_offset()*
  - *section_header_size()*
  - *section_header_type()*

### Segment properties
  - *segment_header_offset()*
  - *segment_header_size()*
  - *segment_header_type()*

### Symbol properties
  - *symtab_entry_offset()*
  - *symtab_entry_size()*
  - *symtab_entry_type()*

### Misc
  - *path()*
  - show()
  - find_library()
  - find_libraries()
"""
abstract type ObjectHandle end

"""
    MagicMismatch

This is an error type used to denote that `readmeta()` was called on a file
that does not contain the proper magic at the beginning for the type of object
file that was attempting to be loaded.
"""
struct MagicMismatch
    message
end

"""
    ObjTypes::Vector{Type}

`ObjTypes` contains the registry of file formats that will be used to try and
open a object file, (e.g. `ELF`, `MachO`, etc...).  This vector is initialized
at `__init__()` time, and used within `readmeta()`.
"""
const ObjTypes = Type[]

"""
    readmeta(io::IO, ::ObjectHandle)

Read an Object File out from an `IOStream`.  This is the first method you
should call in order to manipulate object files.
"""
function readmeta(io::IO, ::Type{T}) where {T<:ObjectHandle}
    # Implementing packages such as MachO.jl must explicitly override this
    error("$T must implement readmeta")
end

"""
    readmeta(io::IO)

Read an Object File out from an `IOStream`, guessing at the type of object
within the stream by calling `readmeta(io, T)` for each `T` within `ObjTypes`,
and returning the first that does not throw a `MagicMismatch`.
"""
function readmeta(io::IO)
    pos = position(io)
    for T in ObjTypes
        seek(io,pos)
        try
            return readmeta(io, T)
        catch e
            if !isa(e,MagicMismatch) && !isa(e,EOFError)
                rethrow(e)
            end
        end
    end

    # If the file didn't match anything, error out
    msg = strip("""
    Object file is not any of $(join(ObjTypes, ", "))!
    To force one object file format use readmeta(io, T).
    """)
    throw(MagicMismatch(replace(msg, "\n" => " ")))
end

function readmeta(file::AbstractString)
    @warn("`readmeta(file::AbstractString)` is deprecated, use the do-block variant instead.")
    return readmeta(open(file, "r"))
end

"""
    readmeta(f::Function, file::AbstractString)

Do-block variant of `readmeta()`.  Use via something like:

    readmeta("libfoo.so") do f
        ...
    end
"""
function readmeta(f::Function, file::AbstractString)
    io = open(file, "r")
    try
        return f(readmeta(io))
    finally
        close(io)
    end
end


## IOStream-like operations
"""
    iostream(oh::ObjectHandle)

Returns the `IOStream` backing the `ObjectHandle`
"""
@mustimplement iostream(oh::ObjectHandle)

"""
    startaddr(oh::ObjectHandle)

Returns the offset within the underlying `IOStream` at which this
`ObjectHandle` is located.
"""
@mustimplement startaddr(oh::ObjectHandle)

unpack(oh::ObjectHandle, T) = unpack(iostream(oh), T, endianness(oh))
position(oh::ObjectHandle) = position(iostream(oh)) - startaddr(oh)
seek(oh::ObjectHandle, pos::Integer) = seek(iostream(oh), startaddr(oh) + pos)
seekstart(oh::ObjectHandle) = seek(oh, 0)

# Generate a bunch of wrappers for ObjectHandles that just call iostream()
# intelligently, so we don't have to continually unwrap
for f in [:skip, :seekstart, :eof, :read, :readuntil, :readbytes, :write]
    @eval $(f)(oh::H, args...) where {H<:ObjectHandle} = $(f)(iostream(oh), args...)
end

"""
    Platform(oh::ObjectHandle)

Returns a `Platform` object representing the binary platform this object is built for.
"""
@mustimplement Platform(oh::ObjectHandle)

"""
    endianness(oh::ObjectHandle)

Returns the endianness of the given `ObjectHandle` (e.g. `:LittleEndian`)
"""
@mustimplement endianness(oh::ObjectHandle)

"""
    is64bit(oh::ObjectHandle)

Returns `true` if the given `ObjectHandle` represents a 64-bit object
"""
@mustimplement is64bit(oh::ObjectHandle)

"""
    isrelocatable(oh::ObjectHandle)

Returns `true` if the given `ObjectHandle` represents a relocatable object
file, e.g. an `.o` file as generated by `gcc -c`
"""
@mustimplement isrelocatable(oh::ObjectHandle)

"""
    isexecutable(oh::ObjectHandle)

Returns `true` if the given `ObjectHandle` represents an executable object
"""
@mustimplement isexecutable(oh::ObjectHandle)

"""
    islibrary(oh::ObjectHandle)

Returns `true` if the given `ObjectHandle` represents a shared library
"""
@mustimplement islibrary(oh::ObjectHandle)

"""
    isdynamic(oh::ObjectHandle)

Returns `true` if the given `ObjectHandle` makes use of dynamic linking.
"""
@mustimplement isdynamic(oh::ObjectHandle)

"""
    mangle_section_name(oh::ObjectHandle, name::AbstractString)

Turn a section `name` into the object-format specific naming convention, e.g.
returning `".bss"` for `ELF`/`COFF` files, and `"__bss"` for `MachO` files
"""
@mustimplement mangle_section_name(oh::ObjectHandle, name::AbstractString)

"""
    mangle_symbol_name(oh::ObjectHandle, name::AbstractString)

Mangle a symbol name using the object-format specific naming convention, e.g.
prefixing `"_"` for MachO files.
"""
@mustimplement mangle_symbol_name(oh::ObjectHandle, name::AbstractString)

# Silly handle() fallthrough for an ObjectHandle itself
handle(oh::ObjectHandle) = oh

"""
    header(oh::ObjectHandle)

Return the `ObjectHandle`'s header object, whatever that may be for this
particular object file format.
"""
@mustimplement header(oh::ObjectHandle)

"""
    format_string(::Type{H}) where {H <: ObjectHandle}

Return the string name of the given `ObjectHandle`, examples are "ELF",
"MachO", "COFF", etc...
"""
@mustimplement format_string(oh::Type)
format_string(::H) where {H <: ObjectHandle} = format_string(H)

"""
    section_header_offset(oh::ObjectHandle)

Given an `ObjectHandle`, return the offset (in bytes) at which the sections
start within the containing object file.
"""
@mustimplement section_header_offset(oh::ObjectHandle)

"""
    section_header_size(oh::ObjectHandle)

Given an `ObjectHandle`, return the size of a section header (used for reading
in the sections header when trying to load a `Section` object or iterating over
a `Sections` object)
"""
@mustimplement section_header_size(oh::ObjectHandle)

"""
    section_header_type(oh::ObjectHandle)

Given an `ObjectHandle`, return the type of a section header (used for reading
in the sections header when trying to load a `Section` object or iterating over
a `Sections` object).  For instance, for a 64-bit ELF file, this would return
the type `ELFSection64`
"""
@mustimplement section_header_type(oh::ObjectHandle)


"""
    segment_header_offset(oh::ObjectHandle)

Given an `ObjectHandle`, return the offset (in bytes) at which the segments
start within the containing object file.
"""
@mustimplement segment_header_offset(oh::ObjectHandle)

"""
    segment_header_size(oh::ObjectHandle)

Given an `ObjectHandle`, return the size of a segment header (used for reading
in the segments header when trying to load a `Segment` object or iterating over
a `Segments` object)
"""
@mustimplement segment_header_size(oh::ObjectHandle)

"""
    segment_header_type(oh::ObjectHandle)

Given an `ObjectHandle`, return the type of a segment header (used for reading
in the segments header when trying to load a `Segment` object or iterating over
a `Segments` object).  For instance, for a 64-bit ELF file, this would return
the type `ELFSegment64`
"""
@mustimplement segment_header_type(oh::ObjectHandle)


"""
    symtab_entry_offset(oh::ObjectHandle)

Given an `ObjectHandle`, return the offset (in bytes) at which the symbol
table starts within the containing object file.
"""
@mustimplement symtab_entry_offset(oh::ObjectHandle)

"""
    symtab_entry_size(oh::ObjectHandle)

Given an `ObjectHandle`, return the size of a symbol table entry (used for
reading in the symbol table when trying to load a `SymtabEntry` object or
iterating over a `Symbols` object).
"""
@mustimplement symtab_entry_size(oh::ObjectHandle)

"""
    symtab_entry_type(oh::ObjectHandle)

Given an `ObjectHandle`, return the type of a symbol table entry (used for
reading in the symbol table when trying to load a `SymtabEntry` object or
iterating over a `Symbols` object).  For instance, for a 64-bit ELF file, this
would return the type `ELFSymtabEntry64`
"""
@mustimplement symtab_entry_type(oh::ObjectHandle)


# Misc. stuff
"""
    path(oh::ObjectHandle)

Return the absolute path to the given `ObjectHandle`, if it was a file loaded
from the local disk.  If it was loaded from a general `IOStream` or in some
other way such that the path is unknown or unknowable, return the empty string.
"""
@mustimplement path(oh::ObjectHandle)

"""
    path(io::IO)

Try to guess the path of an `IO` object.  If it cannot be guessed, returns the
empty string.
"""
function path(io::IO)
    if hasfield(typeof(io), :name) && startswith(io.name, "<file ") && endswith(io.name, ">")
        return abspath(io.name[7:end-1])
    end
    return ""
end

function show(io::IO, oh::H) where {H <: ObjectHandle}
    print(io, "$(format_string(H)) Handle ($(is64bit(oh) ? "64" : "32")-bit)")
end

"""
    find_library(oh::ObjectHandle, soname::String)

Return the absolute path to the given `soname`, using the linker search path
that the given `ObjectHandle` would use at runtime.  See the documentation for
`find_library(::RPath, ::String)` for more details.
"""
function find_library(oh::ObjectHandle, soname::AbstractString)
    return find_library(RPath(oh), soname)
end

"""
    find_libraries(oh::ObjectHandle)

Return a mapping from sonames to absolute paths, containing all the sonames
declared as beeing needed by the given `ObjectHandle`.  See the documentation
for `find_library(::RPath, ::String)` and `RPath` for more details.
"""
function find_libraries(oh::ObjectHandle)
    rpath = RPath(oh)
    sonames = [path(dl) for dl in DynamicLinks(oh)]

    # Remove '@rpath/' prefix if it exists
    function strip_rpath(soname)
        if startswith(soname, "@rpath/")
            return soname[8:end]
        end
       return soname
    end

    # Translate `@loader_path/` to the actual path of the binary
    function strip_loader_path(soname)
        if startswith(soname, "@loader_path/")
            return joinpath(dirname(path(oh)), soname[14:end])
        end
        return soname
    end

    # Get rid of confusing loader tokens
    sonames = strip_rpath.(sonames)
    sonames = strip_loader_path.(sonames)

    return Dict(s => find_library(oh, s) for s in sonames)
end

abstract type ELFRel{H <: ELFHandle} end
abstract type ELFRela{H <: ELFHandle} end

@io struct ELFRel32{H <: ELFHandle} <: ELFRel{H}
    r_offset::UInt32
    r_info::UInt32
end

@io struct ELFRela32{H <: ELFHandle} <: ELFRela{H}
    r_offset::UInt32
    r_info::UInt32
    r_addend::Int32
end

@io struct ELFRel64{H <: ELFHandle} <: ELFRel{H}
    r_offset::UInt64
    r_info::UInt64
end

@io struct ELFRela64{H <: ELFHandle} <: ELFRela{H}
    r_offset::UInt64
    r_info::UInt64
    r_addend::Int64
end


# Access to relocations
struct Relocations{T <: ELFRel, S <: SectionRef}
    sec::S
end
function Relocations(sec::SectionRef)
    is64 = isa(sec.handle.file,ELF64.File)
    isRela = sec.header.sh_type == SHT_RELA
    Relocations{is64 ? (isRela ? ELF64.Rela : ELF64.Rel) : (isRela ? ELF32.Rela : ELF32.Rel),typeof(sec)}(sec)
end

struct RelocationRef{T <: ELFRel} <: ObjFileBase.RelocationRef{ELFHandle}
    h::ELFHandle
    reloc::T
end

deref(x::RelocationRef) = x.reloc

entrysize{T}(s::Relocations{T}) = sizeof(T)
lastindex{T}(s::Relocations{T}) = div(s.sec.header.sh_size,entrysize(s))
length(r::Relocations) = lastindex(r)
function getindex{T}(s::Relocations{T},n)
    if n < 1 || n > length(s)
        throw(BoundsError())
    end
    offset = sectionoffset(s.sec) + (n-1)*entrysize(s)
    seek(s.sec.handle,offset)
    RelocationRef{T}(s.sec.handle,unpack(s.sec.handle, T))
end

keys(s::Relocations) = 1:length(s)
iterate(s::Relocations, idx=1) = idx > length(s) ? nothing : (s[idx], idx+1)

# Utilities for extracting information from relocation entries
r_sym(rel::Union{ELF32.Rel,ELF32.Rela}) = rel.r_info >> 8
r_type(rel::Union{ELF32.Rel,ELF32.Rela}) = rel.r_info % UInt8
r_sym(rel::Union{ELF64.Rel,ELF64.Rela}) = rel.r_info >> 32
r_type(rel::Union{ELF64.Rel,ELF64.Rela}) = rel.r_info % UInt32
addend(rel::Union{ELF32.Rela,ELF64.Rela}) = rel.r_addend
addend(rel::Union{ELF32.Rel,ELF64.Rel}) = 0

r_sym(x) = r_sym(deref(x))
r_type(x) = r_type(deref(x))
addend(x) = addend(deref(x))

# The relocation to apply
struct RelocToApply
    value::UInt64
    size::UInt8
end

function compute_value(h, symbols, reloc, secs)
    # Here one could to external symbol lookups, etc, but I'm not interested
    UInt(symbolvalue(symbols[r_sym(reloc) + 1], secs)), deref(symbols[r_sym(reloc) + 1]).st_value
end

# Apply relocations in `buffer`. `h` should be the buffer being relocated
function relocate!(buffer, h; LOI = nothing)
    sects = Sections(h)
    rel_sects = filter(sects) do sec
        sht = deref(sec).sh_type
        sht == SHT_RELA || sht == SHT_REL
    end
    for sec in rel_sects
        symbols = Symbols(link_sec(sec))
        relocated_sec = info_sec(sec)
        for reloc in Relocations(sec)
            if r_type(reloc) == 0
                continue
            end
            Value, STValue = compute_value(h, symbols, reloc, sects)
            if LOI === nothing
                SectionLoadAddress = deref(relocated_sec).sh_addr
            else
                SectionLoadAddress = getSectionLoadAddress(LOI,relocated_sec)
            end
            rta = compute_relocation(h, reloc, SectionLoadAddress, Value, STValue)
            seek(buffer, deref(relocated_sec).sh_offset + deref(reloc).r_offset)
            write(buffer, rta.size == 8 ? rta.value :
                rta.size == 4 ? convert(UInt32,rta.value) :
                rta.size == 2 ? convert(UInt16,rta.value) :
                rta.size == 1 ? convert(UInt8,rta.value) :
                error("Unsupported Relocation Size"))
        end
    end
end

function compute_relocation(h, reloc, SectionLoadAddress, Value, STValue)
    if h.file.header.e_machine == EM_X86_64
        return compute_X86_64(reloc, SectionLoadAddress, Value, STValue)
    else
        error("Unknown Machine!")
    end
end

function compute_X86_64(reloc, SectionLoadAddress, Value, STValue)
    # The distinction between Value and STValue deserves some explanation.
    # The added difficulty stems from the fact that we're also relocating
    # relocatable object whose sections need not be contiguous in memory,
    # which is an assumption that is implicitly made in the ELF relocation
    # rules. Instead, we need to confront the possibility that the location
    # at which we're applying the relocation and `Value` are contained in
    # sections with different slides. To counteract this, `Value` is the full
    # load address of the target. It is to be used in computations that demand
    # comparison to other absolute addresses. `STValue` on the other hand is the
    # symbol's `st_value`
    
    # Any error generated by the conversions below indicates a bad
    # value (the conversions are checked)
    kind = r_type(reloc)
    Offset = deref(reloc).r_offset
    Addend = addend(reloc)
    Value += Addend
    STValue += Addend
    if kind == R_X86_64_64
        return RelocToApply(Value, 8)
    elseif kind == R_X86_64_32
        return RelocToApply(convert(UInt32,STValue), 4)
    elseif kind == R_X86_64_32S
        return RelocToApply(convert(Int32,reinterpret(Int,STValue)), 4)
    else
        PCOffset = Value - UInt(SectionLoadAddress + Offset)
        if kind == R_X86_64_PC64
            return RelocToApply(PCOffset, 8)
        elseif kind == R_X86_64_PC32
            return RelocToApply(convert(Int32,PCOffset), 4)
        elseif kind == R_X86_64_GLOB_DAT || kind == R_X86_64_JUMP_SLOT
            return RelocToApply(Value, 8)
        elseif kind == R_X86_64_RELATIVE
            return RelocToApply(Addend #= + LoadAddress =#, 8) 
        else
            error("Unknown relocation ($(R_X86_64[kind]))")
        end
    end
end
